(() => {
  var __defProp = Object.defineProperty;
  var __export = (target, all) => {
    for (var name in all)
      __defProp(target, name, { get: all[name], enumerable: !0 });
  };

  // libs/subsrt-ts/lib/handler.ts
  var Handler = class {
    constructor({ name, build: build10, detect: detect10, helper: helper7, parse: parse10 }) {
      this.name = name, this.helper = helper7, this.build = build10, this.detect = (content) => {
        if (typeof content != "string")
          throw new Error("Expected string content!");
        return detect10(content);
      }, this.parse = (content, _options) => {
        if (typeof content != "string")
          throw new Error("Expected string content!");
        return parse10(content, _options);
      };
    }
  }, buildHandler = (args) => new Handler(args);

  // libs/subsrt-ts/lib/format/ssa.ts
  var FORMAT_NAME = "ssa", helper = {
    toMilliseconds: (s5) => {
      let match = /^\s*(\d+:)?(\d{1,2}):(\d{1,2})(?:[.,](\d{1,3}))?\s*$/.exec(
        s5
      );
      if (!match)
        throw new Error(`Invalid time format: ${s5}`);
      let hh = match[1] ? parseInt(match[1].replace(":", "")) : 0, mm = parseInt(match[2]), ss = parseInt(match[3]), ff = match[4] ? parseInt(match[4]) : 0;
      return hh * 3600 * 1e3 + mm * 60 * 1e3 + ss * 1e3 + ff * 10;
    },
    toTimeString: (ms) => {
      let hh = Math.floor(ms / 1e3 / 3600), mm = Math.floor(ms / 1e3 / 60 % 60), ss = Math.floor(ms / 1e3 % 60), ff = Math.floor(ms % 1e3 / 10);
      return `${hh}:${mm < 10 ? "0" : ""}${mm}:${ss < 10 ? "0" : ""}${ss}.${ff < 10 ? "0" : ""}${ff}`;
    }
  }, parse = (content, options) => {
    let meta, columns = null, captions = [], eol = options.eol || `\r
`, parts = content.split(/\r?\n\s*\n/);
    for (let i3 = 0; i3 < parts.length; i3++) {
      let match = /^\s*\[([^\]]+)\]\r?\n([\s\S]*)$/.exec(parts[i3]);
      if (match) {
        let tag = match[1], lines = match[2].split(/\r?\n/);
        for (let l2 = 0; l2 < lines.length; l2++) {
          let line = lines[l2];
          if (/^\s*;/.test(line))
            continue;
          let m5 = /^\s*([^\s:]+):\s*(.*)$/.exec(line);
          if (m5) {
            if (tag === "Script Info")
              if (meta || (meta = {}, meta.type = "meta", meta.data = {}, captions.push(meta)), typeof meta.data == "object") {
                let name = m5[1].trim(), value = m5[2].trim();
                meta.data[name] = value;
              } else
                throw new Error(`Invalid meta data: ${line}`);
            else if (tag === "V4 Styles" || tag === "V4+ Styles") {
              let name = m5[1].trim(), value = m5[2].trim();
              if (name === "Format")
                columns = value.split(/\s*,\s*/g);
              else if (name === "Style" && columns) {
                let values = value.split(/\s*,\s*/g), caption = {};
                caption.type = "style", caption.data = {};
                for (let c3 = 0; c3 < columns.length && c3 < values.length; c3++)
                  caption.data[columns[c3]] = values[c3];
                captions.push(caption);
              }
            } else if (tag === "Events") {
              let name = m5[1].trim(), value = m5[2].trim();
              if (name === "Format")
                columns = value.split(/\s*,\s*/g);
              else if (name === "Dialogue" && columns) {
                let values = value.split(/\s*,\s*/g), caption = {};
                caption.type = "caption", caption.data = {};
                for (let c3 = 0; c3 < columns.length && c3 < values.length; c3++)
                  caption.data[columns[c3]] = values[c3];
                caption.start = helper.toMilliseconds(caption.data.Start), caption.end = helper.toMilliseconds(caption.data.End), caption.duration = caption.end - caption.start, caption.content = caption.data.Text;
                let indexOfText = ((s5, search, index) => s5.split(search, index).join(search).length)(value, ",", columns.length - 1) + 1;
                caption.content = value.substring(indexOfText), caption.data.Text = caption.content, caption.text = caption.content.replace(/\\N/g, eol).replace(/\{[^}]+\}/g, ""), captions.push(caption);
              }
            }
          }
        }
      }
      options.verbose;
    }
    return captions;
  }, build = (captions, options) => {
    let eol = options.eol || `\r
`, ass = options.format === "ass", content = "";
    content += `[Script Info]${eol}`, content += `; Script generated by subsrt ${eol}`, content += `ScriptType: v4.00${ass ? "+" : ""}${eol}`, content += `Collisions: Normal${eol}`, content += eol, ass ? (content += `[V4+ Styles]${eol}`, content += `Format: Name, Fontname, Fontsize, PrimaryColour, SecondaryColour, OutlineColour, BackColour, Bold, Italic, Underline, StrikeOut, ScaleX, ScaleY, Spacing, Angle, BorderStyle, Outline, Shadow, Alignment, MarginL, MarginR, MarginV, Encoding${eol}`, content += `Style: DefaultVCD, Arial,28,&H00B4FCFC,&H00B4FCFC,&H00000008,&H80000008,-1,0,0,0,100,100,0.00,0.00,1,1.00,2.00,2,30,30,30,0${eol}`) : (content += `[V4 Styles]${eol}`, content += `Format: Name, Fontname, Fontsize, PrimaryColour, SecondaryColour, TertiaryColour, BackColour, Bold, Italic, BorderStyle, Outline, Shadow, Alignment, MarginL, MarginR, MarginV, AlphaLevel, Encoding${eol}`, content += `Style: DefaultVCD, Arial,28,11861244,11861244,11861244,-2147483640,-1,0,1,1,2,2,30,30,30,0,0${eol}`), content += eol, content += `[Events]${eol}`, content += `Format: ${ass ? "Layer" : "Marked"}, Start, End, Style, Name, MarginL, MarginR, MarginV, Effect, Text${eol}`;
    for (let i3 = 0; i3 < captions.length; i3++) {
      let caption = captions[i3];
      if (caption.type !== "meta") {
        if (!caption.type || caption.type === "caption") {
          content += `Dialogue: ${ass ? "0" : "Marked=0"},${helper.toTimeString(caption.start)},${helper.toTimeString(
            caption.end
          )},DefaultVCD, NTP,0000,0000,0000,,${caption.text.replace(/\r?\n/g, "\\N")}${eol}`;
          continue;
        }
        options.verbose;
      }
    }
    return content;
  }, detect = (content) => /^\s*\[Script Info\]\r?\n/.test(content) && /\s*\[Events\]\r?\n/.test(content) ? content.indexOf("[V4+ Styles]") > 0 ? "ass" : "ssa" : !1, ssa_default = buildHandler({
    name: FORMAT_NAME,
    build,
    detect,
    helper,
    parse
  });

  // libs/subsrt-ts/lib/format/ass.ts
  var FORMAT_NAME2 = "ass", ass_default = buildHandler({
    name: FORMAT_NAME2,
    build,
    detect,
    helper,
    parse
  });

  // libs/subsrt-ts/lib/format/json.ts
  var FORMAT_NAME3 = "json", parse2 = (content, _options) => JSON.parse(content), build2 = (captions, _options) => JSON.stringify(captions, void 0, 2), detect2 = (content) => {
    try {
      let res = JSON.parse(content);
      return Array.isArray(res) && res.length > 0 && typeof res[0] == "object";
    } catch {
      return !1;
    }
  }, json_default = buildHandler({ name: FORMAT_NAME3, build: build2, detect: detect2, parse: parse2 });

  // libs/subsrt-ts/lib/format/lrc.ts
  var FORMAT_NAME4 = "lrc", helper2 = {
    toMilliseconds: (s5) => {
      let match = /^\s*(\d+):(\d{1,2})(?:[.,](\d{1,3}))?\s*$/.exec(s5);
      if (!match)
        throw new Error(`Invalid time format: ${s5}`);
      let mm = parseInt(match[1]), ss = parseInt(match[2]), ff = match[3] ? parseInt(match[3]) : 0;
      return mm * 60 * 1e3 + ss * 1e3 + ff * 10;
    },
    toTimeString: (ms) => {
      let mm = Math.floor(ms / 1e3 / 60), ss = Math.floor(ms / 1e3 % 60), ff = Math.floor(ms % 1e3);
      return `${(mm < 10 ? "0" : "") + mm}:${ss < 10 ? "0" : ""}${ss}.${ff < 100 ? "0" : ""}${ff < 10 ? "0" : Math.floor(ff / 10)}`;
    }
  }, parse3 = (content, options) => {
    let prev = null, captions = [], parts = content.split(/\r?\n/);
    for (let i3 = 0; i3 < parts.length; i3++) {
      if (!parts[i3] || parts[i3].trim().length === 0)
        continue;
      let match = /^\[(\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?)\](.*)(?:\r?\n)*$/.exec(parts[i3]);
      if (match) {
        let caption = {};
        caption.type = "caption", caption.start = helper2.toMilliseconds(match[1]), caption.end = caption.start + 2e3, caption.duration = caption.end - caption.start, caption.content = match[2], caption.text = caption.content, captions.push(caption), prev && (prev.end = caption.start, prev.duration = prev.end - prev.start), prev = caption;
        continue;
      }
      let meta = /^\[(\w+):([^\]]*)\](?:\r?\n)*$/.exec(parts[i3]);
      if (meta) {
        let caption = {};
        caption.type = "meta", caption.tag = meta[1], meta[2] && (caption.data = meta[2]), captions.push(caption);
        continue;
      }
      options.verbose;
    }
    return captions;
  }, build3 = (captions, options) => {
    let content = "", lyrics = !1, eol = options.eol || `\r
`;
    for (let i3 = 0; i3 < captions.length; i3++) {
      let caption = captions[i3];
      if (caption.type === "meta") {
        caption.tag && caption.data && typeof caption.data == "string" && (content += `[${caption.tag}:${caption.data.replace(/[\r\n]+/g, " ")}]${eol}`);
        continue;
      }
      if (!caption.type || caption.type === "caption") {
        lyrics || (content += eol, lyrics = !0), content += `[${helper2.toTimeString(caption.start)}]${caption.text}${eol}`;
        continue;
      }
      options.verbose;
    }
    return content;
  }, detect3 = (content) => /\r?\n\[\d+:\d{1,2}(?:[.,]\d{1,3})?\].*\r?\n/.test(content), lrc_default = buildHandler({
    name: FORMAT_NAME4,
    build: build3,
    detect: detect3,
    helper: helper2,
    parse: parse3
  });

  // libs/subsrt-ts/lib/format/sbv.ts
  var FORMAT_NAME5 = "sbv", helper3 = {
    toMilliseconds: (s5) => {
      let match = /^\s*(\d{1,2}):(\d{1,2}):(\d{1,2})(?:[.,](\d{1,3}))?\s*$/.exec(s5);
      if (!match)
        throw new Error(`Invalid time format: ${s5}`);
      let hh = parseInt(match[1]), mm = parseInt(match[2]), ss = parseInt(match[3]), ff = match[4] ? parseInt(match[4]) : 0;
      return hh * 3600 * 1e3 + mm * 60 * 1e3 + ss * 1e3 + ff;
    },
    toTimeString: (ms) => {
      let hh = Math.floor(ms / 1e3 / 3600), mm = Math.floor(ms / 1e3 / 60 % 60), ss = Math.floor(ms / 1e3 % 60), ff = Math.floor(ms % 1e3);
      return `${(hh < 10 ? "0" : "") + hh}:${mm < 10 ? "0" : ""}${mm}:${ss < 10 ? "0" : ""}${ss}.${ff < 100 ? "0" : ""}${ff < 10 ? "0" : ""}${ff}`;
    }
  }, parse4 = (content, options) => {
    let captions = [], eol = options.eol || `\r
`, parts = content.split(/\r?\n\s*\n/);
    for (let i3 = 0; i3 < parts.length; i3++) {
      let match = /^(\d{1,2}:\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?)\s*[,;]\s*(\d{1,2}:\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?)\r?\n([\s\S]*)$/.exec(parts[i3]);
      if (match) {
        let caption = {};
        caption.type = "caption", caption.start = helper3.toMilliseconds(match[1]), caption.end = helper3.toMilliseconds(match[2]), caption.duration = caption.end - caption.start;
        let lines = match[3].split(/\[br\]|\r?\n/gi);
        caption.content = lines.join(eol), caption.text = caption.content.replace(/>>[^:]+:\s*/g, ""), captions.push(caption);
        continue;
      }
      options.verbose;
    }
    return captions;
  }, build4 = (captions, options) => {
    let content = "", eol = options.eol || `\r
`;
    for (let i3 = 0; i3 < captions.length; i3++) {
      let caption = captions[i3];
      if (!caption.type || caption.type === "caption") {
        content += `${helper3.toTimeString(caption.start)},${helper3.toTimeString(caption.end)}${eol}`, content += caption.text + eol, content += eol;
        continue;
      }
      options.verbose;
    }
    return content;
  }, detect4 = (content) => /\d{1,2}:\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?\s*[,;]\s*\d{1,2}:\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?/.test(content), sbv_default = buildHandler({
    name: FORMAT_NAME5,
    build: build4,
    detect: detect4,
    helper: helper3,
    parse: parse4
  });

  // libs/subsrt-ts/lib/format/smi.ts
  var FORMAT_NAME6 = "smi", helper4 = {
    htmlEncode: (text) => text.replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&#39;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\r?\n/g, "<BR>"),
    htmlDecode: (html, eol) => html.replace(/<BR\s*\/?>/gi, eol || `\r
`).replace(/&nbsp;/g, " ").replace(/&quot;/g, '"').replace(/&#39;/g, "'").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&amp;/g, "&")
  }, parse5 = (content, options) => {
    if (options.format && options.format !== FORMAT_NAME6)
      throw new Error(`Invalid format: ${options.format}`);
    let captions = [], eol = options.eol || `\r
`, title = /<TITLE[^>]*>([\s\S]*)<\/TITLE>/i.exec(content);
    if (title) {
      let caption = {};
      caption.type = "meta", caption.name = "title", caption.data = title[1].replace(/^\s*/g, "").replace(/\s*$/g, ""), captions.push(caption);
    }
    let style = /<STYLE[^>]*>([\s\S]*)<\/STYLE>/i.exec(content);
    if (style) {
      let caption = {};
      caption.type = "meta", caption.name = "style", caption.data = style[1], captions.push(caption);
    }
    let sami = content.replace(/^[\s\S]*<BODY[^>]*>/gi, "").replace(/<\/BODY[^>]*>[\s\S]*$/gi, ""), prev = null, parts = sami.split(/<SYNC/gi);
    for (let i3 = 0; i3 < parts.length; i3++) {
      if (!parts[i3] || parts[i3].trim().length === 0)
        continue;
      let part = `<SYNC${parts[i3]}`, match = /^<SYNC[^>]+Start\s*=\s*["']?(\d+)[^\d>]*>([\s\S]*)/i.exec(
        part
      );
      if (match) {
        let caption = {};
        caption.type = "caption", caption.start = parseInt(match[1]), caption.end = caption.start + 2e3, caption.duration = caption.end - caption.start, caption.content = match[2].replace(/^<\/SYNC[^>]*>/gi, "");
        let blank = !0, p4 = /^<P.+Class\s*=\s*["']?([\w-]+)(?: .*)?>([\s\S]*)/i.exec(
          caption.content
        ) || /^<P([^>]*)>([\s\S]*)/i.exec(caption.content);
        if (p4) {
          let html = p4[2].replace(/<P[\s\S]+$/gi, "");
          html = html.replace(/<BR\s*\/?>\s+/gi, eol).replace(/<BR\s*\/?>/gi, eol).replace(/<[^>]+>/g, ""), html = html.replace(/^\s+/g, "").replace(/\s+$/g, ""), blank = html.replace(/&nbsp;/gi, " ").replace(/\s+/g, "").length === 0, caption.text = helper4.htmlDecode(html, eol);
        }
        !options.preserveSpaces && blank ? options.verbose : captions.push(caption), prev && (prev.end = caption.start, prev.duration = prev.end - prev.start), prev = caption;
        continue;
      }
      options.verbose;
    }
    return captions;
  }, build5 = (captions, options) => {
    let eol = options.eol || `\r
`, content = "";
    content += `<SAMI>${eol}`, content += `<HEAD>${eol}`, content += `<TITLE>${options.title || ""}</TITLE>${eol}`, content += `<STYLE TYPE="text/css">${eol}`, content += `<!--${eol}`, content += `P { font-family: Arial; font-weight: normal; color: white; background-color: black; text-align: center; }${eol}`, content += `.LANG { Name: ${options.langName || "English"}; lang: ${options.langCode || "en-US"}; SAMIType: CC; }${eol}`, content += `-->${eol}`, content += `</STYLE>${eol}`, content += `</HEAD>${eol}`, content += `<BODY>${eol}`;
    for (let i3 = 0; i3 < captions.length; i3++) {
      let caption = captions[i3];
      if (caption.type !== "meta") {
        if (!caption.type || caption.type === "caption") {
          content += `<SYNC Start=${caption.start}>${eol}`, content += `  <P Class=LANG>${helper4.htmlEncode(caption.text || "")}${options.closeTags ? "</P>" : ""}${eol}`, options.closeTags && (content += `</SYNC>${eol}`), content += `<SYNC Start=${caption.end}>${eol}`, content += `  <P Class=LANG>&nbsp;${options.closeTags ? "</P>" : ""}${eol}`, options.closeTags && (content += `</SYNC>${eol}`);
          continue;
        }
        options.verbose;
      }
    }
    return content += `</BODY>${eol}`, content += `</SAMI>${eol}`, content;
  }, detect5 = (content) => /<SAMI[^>]*>[\s\S]*<BODY[^>]*>/.test(content), smi_default = buildHandler({
    name: FORMAT_NAME6,
    build: build5,
    detect: detect5,
    helper: helper4,
    parse: parse5
  });

  // libs/subsrt-ts/lib/format/srt.ts
  var FORMAT_NAME7 = "srt", helper5 = {
    toMilliseconds: (s5) => {
      let match = /^\s*(\d{1,2}):(\d{1,2}):(\d{1,2})(?:[.,](\d{1,3}))?\s*$/.exec(s5);
      if (!match)
        throw new Error(`Invalid time format: ${s5}`);
      let hh = parseInt(match[1]), mm = parseInt(match[2]), ss = parseInt(match[3]), ff = match[4] ? parseInt(match[4]) : 0;
      return hh * 3600 * 1e3 + mm * 60 * 1e3 + ss * 1e3 + ff;
    },
    toTimeString: (ms) => {
      let hh = Math.floor(ms / 1e3 / 3600), mm = Math.floor(ms / 1e3 / 60 % 60), ss = Math.floor(ms / 1e3 % 60), ff = Math.floor(ms % 1e3);
      return `${(hh < 10 ? "0" : "") + hh}:${mm < 10 ? "0" : ""}${mm}:${ss < 10 ? "0" : ""}${ss},${ff < 100 ? "0" : ""}${ff < 10 ? "0" : ""}${ff}`;
    }
  }, parse6 = (content, options) => {
    let captions = [], eol = options.eol || `\r
`, parts = content.split(/\r?\n\s*\n/g);
    for (let i3 = 0; i3 < parts.length; i3++) {
      let match = /^(\d+)\r?\n(\d{1,2}:\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?)\s*-->\s*(\d{1,2}:\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?)\r?\n([\s\S]*)$/.exec(parts[i3]);
      if (match) {
        let caption = {};
        caption.type = "caption", caption.index = parseInt(match[1]), caption.start = helper5.toMilliseconds(match[2]), caption.end = helper5.toMilliseconds(match[3]), caption.duration = caption.end - caption.start;
        let lines = match[4].split(/\r?\n/);
        caption.content = lines.join(eol), caption.text = caption.content.replace(/<[^>]+>/g, "").replace(/\{[^}]+\}/g, "").replace(/>>[^:]*:\s*/g, ""), captions.push(caption);
        continue;
      }
      options.verbose;
    }
    return captions;
  }, build6 = (captions, options) => {
    let srt = "", eol = options.eol || `\r
`;
    for (let i3 = 0; i3 < captions.length; i3++) {
      let caption = captions[i3];
      if (!caption.type || caption.type === "caption") {
        srt += (caption.index ? caption.index : i3 + 1).toString() + eol, srt += `${helper5.toTimeString(caption.start)} --> ${helper5.toTimeString(caption.end)}${eol}`, srt += caption.text + eol, srt += eol;
        continue;
      }
      options.verbose;
    }
    return srt;
  }, detect6 = (content) => /\d+\r?\n\d{1,2}:\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?\s*-->\s*\d{1,2}:\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?/.test(content), srt_default = buildHandler({
    name: FORMAT_NAME7,
    build: build6,
    detect: detect6,
    helper: helper5,
    parse: parse6
  });

  // libs/subsrt-ts/lib/format/sub.ts
  var FORMAT_NAME8 = "sub", DEFAULT_FPS = 25, parse7 = (content, options) => {
    options.fps ||= DEFAULT_FPS;
    let fps = options.fps > 0 ? options.fps : DEFAULT_FPS, captions = [], eol = options.eol || `\r
`, parts = content.split(/\r?\n/g);
    for (let i3 = 0; i3 < parts.length; i3++) {
      let match = /^\{(\d+)\}\{(\d+)\}(.*)$/.exec(parts[i3]);
      if (match) {
        let caption = {};
        caption.type = "caption", caption.index = i3 + 1, caption.frame = {
          start: parseInt(match[1]),
          end: parseInt(match[2]),
          count: parseInt(match[2]) - parseInt(match[1])
        }, caption.start = Math.round(caption.frame.start / fps), caption.end = Math.round(caption.frame.end / fps), caption.duration = caption.end - caption.start;
        let lines = match[3].split(/\|/g);
        caption.content = lines.join(eol), caption.text = caption.content.replace(/\{[^}]+\}/g, ""), captions.push(caption);
        continue;
      }
      options.verbose;
    }
    return captions;
  }, build7 = (captions, options) => {
    let fps = (options.fps || 0) > 0 ? options.fps : DEFAULT_FPS, sub = "", eol = options.eol || `\r
`;
    for (let i3 = 0; i3 < captions.length; i3++) {
      let caption = captions[i3];
      if (!caption.type || caption.type === "caption") {
        let startFrame = typeof caption.frame == "object" && caption.frame.start >= 0 ? caption.frame.start : caption.start * fps, endFrame = typeof caption.frame == "object" && caption.frame.end >= 0 ? caption.frame.end : caption.end * fps, text = caption.text.replace(/\r?\n/, "|");
        sub += `{${startFrame}}{${endFrame}}${text}${eol}`;
        continue;
      }
      options.verbose;
    }
    return sub;
  }, detect7 = (content) => /^\{\d+\}\{\d+\}.*/.test(content), sub_default = buildHandler({ name: FORMAT_NAME8, build: build7, detect: detect7, parse: parse7 });

  // libs/subsrt-ts/lib/format/vtt.ts
  var FORMAT_NAME9 = "vtt", helper6 = {
    toMilliseconds: (s5) => {
      let match = /^\s*(\d{1,2}:)?(\d{1,2}):(\d{1,2})(?:[.,](\d{1,3}))?\s*$/.exec(s5);
      if (!match)
        throw new Error(`Invalid time format: ${s5}`);
      let hh = match[1] ? parseInt(match[1].replace(":", "")) : 0, mm = parseInt(match[2]), ss = parseInt(match[3]), ff = match[4] ? parseInt(match[4]) : 0;
      return hh * 3600 * 1e3 + mm * 60 * 1e3 + ss * 1e3 + ff;
    },
    toTimeString: (ms) => {
      let hh = Math.floor(ms / 1e3 / 3600), mm = Math.floor(ms / 1e3 / 60 % 60), ss = Math.floor(ms / 1e3 % 60), ff = Math.floor(ms % 1e3);
      return `${(hh < 10 ? "0" : "") + hh}:${mm < 10 ? "0" : ""}${mm}:${ss < 10 ? "0" : ""}${ss}.${ff < 100 ? "0" : ""}${ff < 10 ? "0" : ""}${ff}`;
    }
  }, parse8 = (content, options) => {
    let index = 1, captions = [], parts = content.split(/\r?\n\s*\n/);
    for (let i3 = 0; i3 < parts.length; i3++) {
      let match = /^([^\r\n]+\r?\n)?((?:\d{1,2}:)?\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?)\s*-->\s*((?:\d{1,2}:)?\d{1,2}:\d{1,2}(?:[.,]\d{1,3})?)\s?.*\r?\n([\s\S]*)$/.exec(parts[i3]);
      if (match) {
        let caption = {};
        caption.type = "caption", caption.index = index++, match[1] && (caption.cue = match[1].replace(/[\r\n]*/g, "")), caption.start = helper6.toMilliseconds(match[2]), caption.end = helper6.toMilliseconds(match[3]), caption.duration = caption.end - caption.start;
        let lines = match[4].split(/\r?\n/);
        caption.content = lines.join(" "), caption.text = caption.content.replace(/<[^>]+>/g, "").replace(/\{[^}]+\}/g, ""), captions.push(caption);
        continue;
      }
      let meta = /^([A-Z]+)(\r?\n([\s\S]*))?$/.exec(parts[i3]) || /^([A-Z]+)\s+([^\r\n]*)$/.exec(parts[i3]);
      if (meta) {
        let caption = {};
        caption.type = "meta", caption.name = meta[1], meta[3] && (caption.data = meta[3]), captions.push(caption);
        continue;
      }
      options.verbose;
    }
    return captions;
  }, build8 = (captions, options) => {
    let eol = options.eol || `\r
`, content = `WEBVTT${eol}${eol}`;
    for (let i3 = 0; i3 < captions.length; i3++) {
      let caption = captions[i3];
      if (caption.type === "meta") {
        if (caption.name === "WEBVTT")
          continue;
        content += caption.name + eol, content += caption.data ? caption.data + eol : "", content += eol;
        continue;
      }
      if (!caption.type || caption.type === "caption") {
        content += (i3 + 1).toString() + eol, content += `${helper6.toTimeString(caption.start)} --> ${helper6.toTimeString(caption.end)}${eol}`, content += caption.text + eol, content += eol;
        continue;
      }
      options.verbose;
    }
    return content;
  }, detect8 = (content) => /^\s*WEBVTT\r?\n/.test(content), vtt_default = buildHandler({
    name: FORMAT_NAME9,
    build: build8,
    detect: detect8,
    helper: helper6,
    parse: parse8
  });

  // libs/subsrt-ts/lib/format/index.ts
  var formats = {
    vtt: vtt_default,
    lrc: lrc_default,
    smi: smi_default,
    ssa: ssa_default,
    ass: ass_default,
    sub: sub_default,
    srt: srt_default,
    sbv: sbv_default,
    json: json_default
  }, format_default = formats;

  // libs/subsrt-ts/lib/subsrt.ts
  var clone = (obj) => JSON.parse(JSON.stringify(obj)), Subsrt = class {
    constructor() {
      this.format = format_default;
      /**
       * Gets a list of supported subtitle formats.
       */
      this.list = () => Object.keys(this.format);
      /**
       * Detects a subtitle format from the content.
       */
      this.detect = (content) => {
        let formats2 = this.list();
        for (let i3 = 0; i3 < formats2.length; i3++) {
          let f5 = formats2[i3], handler = this.format[f5];
          if (typeof handler > "u" || typeof handler.detect != "function")
            continue;
          let d6 = handler.detect(content);
          if (d6 === !0 || d6 === f5)
            return f5;
        }
        return "";
      };
      /**
       * Parses a subtitle content.
       */
      this.parse = (content, options = {}) => {
        let format3 = options.format || this.detect(content);
        if (!format3 || format3.trim().length === 0)
          throw new Error("Cannot determine subtitle format!");
        let handler = this.format[format3];
        if (typeof handler > "u")
          throw new Error(`Unsupported subtitle format: ${format3}`);
        let func = handler.parse;
        if (typeof func != "function")
          throw new Error(`Subtitle format does not support 'parse' op: ${format3}`);
        return func(content, options);
      };
      /**
       * Builds a subtitle content.
       */
      this.build = (captions, options = {}) => {
        let format3 = options.format || "srt";
        if (!format3 || format3.trim().length === 0)
          throw new Error("Cannot determine subtitle format!");
        let handler = this.format[format3];
        if (typeof handler > "u")
          throw new Error(`Unsupported subtitle format: ${format3}`);
        let func = handler.build;
        if (typeof func != "function")
          throw new Error(`Subtitle format does not support 'build' op: ${format3}`);
        return func(captions, options);
      };
      /**
       * Converts subtitle format.
       */
      this.convert = (content, _options = {}) => {
        let options = {};
        typeof _options == "string" ? options.to = _options : options = _options;
        let parseOptions = {
          format: options.from || void 0,
          verbose: options.verbose,
          eol: options.eol
        }, captions = this.parse(content, parseOptions);
        options.resync && (captions = this.resync(captions, options.resync));
        let buildOptions = {
          format: options.to || options.format,
          verbose: options.verbose,
          eol: options.eol
        };
        return this.build(captions, buildOptions);
      };
      /**
       * Shifts the time of the captions.
       */
      this.resync = (captions, options = {}) => {
        let func, ratio, frame = !1, offset;
        if (typeof options == "function")
          func = options;
        else if (typeof options == "number")
          offset = options, func = (a3) => [a3[0] + offset, a3[1] + offset];
        else if (typeof options == "object")
          offset = (options.offset || 0) * (options.frame ? options.fps || 25 : 1), ratio = options.ratio || 1, frame = options.frame || !1, func = (a3) => [
            Math.round(a3[0] * ratio + offset),
            Math.round(a3[1] * ratio + offset)
          ];
        else
          throw new Error("Argument 'options' not defined!");
        let resynced = [];
        for (let i3 = 0; i3 < captions.length; i3++) {
          let caption = clone(captions[i3]);
          if (!caption.type || caption.type === "caption")
            if (frame) {
              let shift = func([caption.frame.start, caption.frame.end]);
              shift && shift.length === 2 && (caption.frame.start = shift[0], caption.frame.end = shift[1], caption.frame.count = caption.frame.end - caption.frame.start);
            } else {
              let shift = func([caption.start, caption.end]);
              shift && shift.length === 2 && (caption.start = shift[0], caption.end = shift[1], caption.duration = caption.end - caption.start);
            }
          resynced.push(caption);
        }
        return resynced;
      };
    }
  }, subsrt = new Subsrt(), subsrt_default = subsrt, { format, list, detect: detect9, parse: parse9, build: build9, convert, resync } = subsrt;

  // https://esm.sh/stable/preact@10.11.0/deno/preact.mjs
  var P, d, $, Y, S, F, B, T = {}, V = [], Z = /acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|itera/i;
  function k(e3, t2) {
    for (var _3 in t2)
      e3[_3] = t2[_3];
    return e3;
  }
  function j(e3) {
    var t2 = e3.parentNode;
    t2 && t2.removeChild(e3);
  }
  function ee(e3, t2, _3) {
    var r, l2, o3, s5 = {};
    for (o3 in t2)
      o3 == "key" ? r = t2[o3] : o3 == "ref" ? l2 = t2[o3] : s5[o3] = t2[o3];
    if (arguments.length > 2 && (s5.children = arguments.length > 3 ? P.call(arguments, 2) : _3), typeof e3 == "function" && e3.defaultProps != null)
      for (o3 in e3.defaultProps)
        s5[o3] === void 0 && (s5[o3] = e3.defaultProps[o3]);
    return w(e3, s5, r, l2, null);
  }
  function w(e3, t2, _3, r, l2) {
    var o3 = { type: e3, props: t2, key: _3, ref: r, __k: null, __: null, __b: 0, __e: null, __d: void 0, __c: null, __h: null, constructor: void 0, __v: l2 ?? ++$ };
    return l2 == null && d.vnode != null && d.vnode(o3), o3;
  }
  function L(e3) {
    return e3.children;
  }
  function U(e3, t2) {
    this.props = e3, this.context = t2;
  }
  function C(e3, t2) {
    if (t2 == null)
      return e3.__ ? C(e3.__, e3.__.__k.indexOf(e3) + 1) : null;
    for (var _3; t2 < e3.__k.length; t2++)
      if ((_3 = e3.__k[t2]) != null && _3.__e != null)
        return _3.__e;
    return typeof e3.type == "function" ? C(e3) : null;
  }
  function z(e3) {
    var t2, _3;
    if ((e3 = e3.__) != null && e3.__c != null) {
      for (e3.__e = e3.__c.base = null, t2 = 0; t2 < e3.__k.length; t2++)
        if ((_3 = e3.__k[t2]) != null && _3.__e != null) {
          e3.__e = e3.__c.base = _3.__e;
          break;
        }
      return z(e3);
    }
  }
  function M(e3) {
    (!e3.__d && (e3.__d = !0) && S.push(e3) && !D.__r++ || F !== d.debounceRendering) && ((F = d.debounceRendering) || setTimeout)(D);
  }
  function D() {
    for (var e3; D.__r = S.length; )
      e3 = S.sort(function(t2, _3) {
        return t2.__v.__b - _3.__v.__b;
      }), S = [], e3.some(function(t2) {
        var _3, r, l2, o3, s5, f5;
        t2.__d && (s5 = (o3 = (_3 = t2).__v).__e, (f5 = _3.__P) && (r = [], (l2 = k({}, o3)).__v = o3.__v + 1, W(f5, o3, l2, _3.__n, f5.ownerSVGElement !== void 0, o3.__h != null ? [s5] : null, r, s5 ?? C(o3), o3.__h), K(r, o3), o3.__e != s5 && z(o3)));
      });
  }
  function G(e3, t2, _3, r, l2, o3, s5, f5, p4, a3) {
    var n2, h3, c3, i3, u4, b6, v5, y3 = r && r.__k || V, g5 = y3.length;
    for (_3.__k = [], n2 = 0; n2 < t2.length; n2++)
      if ((i3 = _3.__k[n2] = (i3 = t2[n2]) == null || typeof i3 == "boolean" ? null : typeof i3 == "string" || typeof i3 == "number" || typeof i3 == "bigint" ? w(null, i3, null, null, i3) : Array.isArray(i3) ? w(L, { children: i3 }, null, null, null) : i3.__b > 0 ? w(i3.type, i3.props, i3.key, i3.ref ? i3.ref : null, i3.__v) : i3) != null) {
        if (i3.__ = _3, i3.__b = _3.__b + 1, (c3 = y3[n2]) === null || c3 && i3.key == c3.key && i3.type === c3.type)
          y3[n2] = void 0;
        else
          for (h3 = 0; h3 < g5; h3++) {
            if ((c3 = y3[h3]) && i3.key == c3.key && i3.type === c3.type) {
              y3[h3] = void 0;
              break;
            }
            c3 = null;
          }
        W(e3, i3, c3 = c3 || T, l2, o3, s5, f5, p4, a3), u4 = i3.__e, (h3 = i3.ref) && c3.ref != h3 && (v5 || (v5 = []), c3.ref && v5.push(c3.ref, null, i3), v5.push(h3, i3.__c || u4, i3)), u4 != null ? (b6 == null && (b6 = u4), typeof i3.type == "function" && i3.__k === c3.__k ? i3.__d = p4 = q(i3, p4, e3) : p4 = J(e3, i3, c3, y3, u4, p4), typeof _3.type == "function" && (_3.__d = p4)) : p4 && c3.__e == p4 && p4.parentNode != e3 && (p4 = C(c3));
      }
    for (_3.__e = b6, n2 = g5; n2--; )
      y3[n2] != null && (typeof _3.type == "function" && y3[n2].__e != null && y3[n2].__e == _3.__d && (_3.__d = C(r, n2 + 1)), X(y3[n2], y3[n2]));
    if (v5)
      for (n2 = 0; n2 < v5.length; n2++)
        Q(v5[n2], v5[++n2], v5[++n2]);
  }
  function q(e3, t2, _3) {
    for (var r, l2 = e3.__k, o3 = 0; l2 && o3 < l2.length; o3++)
      (r = l2[o3]) && (r.__ = e3, t2 = typeof r.type == "function" ? q(r, t2, _3) : J(_3, r, r, l2, r.__e, t2));
    return t2;
  }
  function J(e3, t2, _3, r, l2, o3) {
    var s5, f5, p4;
    if (t2.__d !== void 0)
      s5 = t2.__d, t2.__d = void 0;
    else if (_3 == null || l2 != o3 || l2.parentNode == null)
      e:
        if (o3 == null || o3.parentNode !== e3)
          e3.appendChild(l2), s5 = null;
        else {
          for (f5 = o3, p4 = 0; (f5 = f5.nextSibling) && p4 < r.length; p4 += 2)
            if (f5 == l2)
              break e;
          e3.insertBefore(l2, o3), s5 = o3;
        }
    return s5 !== void 0 ? s5 : l2.nextSibling;
  }
  function _e(e3, t2, _3, r, l2) {
    var o3;
    for (o3 in _3)
      o3 === "children" || o3 === "key" || o3 in t2 || N(e3, o3, null, _3[o3], r);
    for (o3 in t2)
      l2 && typeof t2[o3] != "function" || o3 === "children" || o3 === "key" || o3 === "value" || o3 === "checked" || _3[o3] === t2[o3] || N(e3, o3, t2[o3], _3[o3], r);
  }
  function I(e3, t2, _3) {
    t2[0] === "-" ? e3.setProperty(t2, _3) : e3[t2] = _3 == null ? "" : typeof _3 != "number" || Z.test(t2) ? _3 : _3 + "px";
  }
  function N(e3, t2, _3, r, l2) {
    var o3;
    e:
      if (t2 === "style")
        if (typeof _3 == "string")
          e3.style.cssText = _3;
        else {
          if (typeof r == "string" && (e3.style.cssText = r = ""), r)
            for (t2 in r)
              _3 && t2 in _3 || I(e3.style, t2, "");
          if (_3)
            for (t2 in _3)
              r && _3[t2] === r[t2] || I(e3.style, t2, _3[t2]);
        }
      else if (t2[0] === "o" && t2[1] === "n")
        o3 = t2 !== (t2 = t2.replace(/Capture$/, "")), t2 = t2.toLowerCase() in e3 ? t2.toLowerCase().slice(2) : t2.slice(2), e3.l || (e3.l = {}), e3.l[t2 + o3] = _3, _3 ? r || e3.addEventListener(t2, o3 ? R : O, o3) : e3.removeEventListener(t2, o3 ? R : O, o3);
      else if (t2 !== "dangerouslySetInnerHTML") {
        if (l2)
          t2 = t2.replace(/xlink(H|:h)/, "h").replace(/sName$/, "s");
        else if (t2 !== "href" && t2 !== "list" && t2 !== "form" && t2 !== "tabIndex" && t2 !== "download" && t2 in e3)
          try {
            e3[t2] = _3 ?? "";
            break e;
          } catch {
          }
        typeof _3 == "function" || (_3 != null && (_3 !== !1 || t2[0] === "a" && t2[1] === "r") ? e3.setAttribute(t2, _3) : e3.removeAttribute(t2));
      }
  }
  function O(e3) {
    this.l[e3.type + !1](d.event ? d.event(e3) : e3);
  }
  function R(e3) {
    this.l[e3.type + !0](d.event ? d.event(e3) : e3);
  }
  function W(e3, t2, _3, r, l2, o3, s5, f5, p4) {
    var a3, n2, h3, c3, i3, u4, b6, v5, y3, g5, x2, H6, E4, m5 = t2.type;
    if (t2.constructor !== void 0)
      return null;
    _3.__h != null && (p4 = _3.__h, f5 = t2.__e = _3.__e, t2.__h = null, o3 = [f5]), (a3 = d.__b) && a3(t2);
    try {
      e:
        if (typeof m5 == "function") {
          if (v5 = t2.props, y3 = (a3 = m5.contextType) && r[a3.__c], g5 = a3 ? y3 ? y3.props.value : a3.__ : r, _3.__c ? b6 = (n2 = t2.__c = _3.__c).__ = n2.__E : ("prototype" in m5 && m5.prototype.render ? t2.__c = n2 = new m5(v5, g5) : (t2.__c = n2 = new U(v5, g5), n2.constructor = m5, n2.render = oe), y3 && y3.sub(n2), n2.props = v5, n2.state || (n2.state = {}), n2.context = g5, n2.__n = r, h3 = n2.__d = !0, n2.__h = []), n2.__s == null && (n2.__s = n2.state), m5.getDerivedStateFromProps != null && (n2.__s == n2.state && (n2.__s = k({}, n2.__s)), k(n2.__s, m5.getDerivedStateFromProps(v5, n2.__s))), c3 = n2.props, i3 = n2.state, h3)
            m5.getDerivedStateFromProps == null && n2.componentWillMount != null && n2.componentWillMount(), n2.componentDidMount != null && n2.__h.push(n2.componentDidMount);
          else {
            if (m5.getDerivedStateFromProps == null && v5 !== c3 && n2.componentWillReceiveProps != null && n2.componentWillReceiveProps(v5, g5), !n2.__e && n2.shouldComponentUpdate != null && n2.shouldComponentUpdate(v5, n2.__s, g5) === !1 || t2.__v === _3.__v) {
              n2.props = v5, n2.state = n2.__s, t2.__v !== _3.__v && (n2.__d = !1), n2.__v = t2, t2.__e = _3.__e, t2.__k = _3.__k, t2.__k.forEach(function(A5) {
                A5 && (A5.__ = t2);
              }), n2.__h.length && s5.push(n2);
              break e;
            }
            n2.componentWillUpdate != null && n2.componentWillUpdate(v5, n2.__s, g5), n2.componentDidUpdate != null && n2.__h.push(function() {
              n2.componentDidUpdate(c3, i3, u4);
            });
          }
          if (n2.context = g5, n2.props = v5, n2.__v = t2, n2.__P = e3, x2 = d.__r, H6 = 0, "prototype" in m5 && m5.prototype.render)
            n2.state = n2.__s, n2.__d = !1, x2 && x2(t2), a3 = n2.render(n2.props, n2.state, n2.context);
          else
            do
              n2.__d = !1, x2 && x2(t2), a3 = n2.render(n2.props, n2.state, n2.context), n2.state = n2.__s;
            while (n2.__d && ++H6 < 25);
          n2.state = n2.__s, n2.getChildContext != null && (r = k(k({}, r), n2.getChildContext())), h3 || n2.getSnapshotBeforeUpdate == null || (u4 = n2.getSnapshotBeforeUpdate(c3, i3)), E4 = a3 != null && a3.type === L && a3.key == null ? a3.props.children : a3, G(e3, Array.isArray(E4) ? E4 : [E4], t2, _3, r, l2, o3, s5, f5, p4), n2.base = t2.__e, t2.__h = null, n2.__h.length && s5.push(n2), b6 && (n2.__E = n2.__ = null), n2.__e = !1;
        } else
          o3 == null && t2.__v === _3.__v ? (t2.__k = _3.__k, t2.__e = _3.__e) : t2.__e = ne(_3.__e, t2, _3, r, l2, o3, s5, p4);
      (a3 = d.diffed) && a3(t2);
    } catch (A5) {
      t2.__v = null, (p4 || o3 != null) && (t2.__e = f5, t2.__h = !!p4, o3[o3.indexOf(f5)] = null), d.__e(A5, t2, _3);
    }
  }
  function K(e3, t2) {
    d.__c && d.__c(t2, e3), e3.some(function(_3) {
      try {
        e3 = _3.__h, _3.__h = [], e3.some(function(r) {
          r.call(_3);
        });
      } catch (r) {
        d.__e(r, _3.__v);
      }
    });
  }
  function ne(e3, t2, _3, r, l2, o3, s5, f5) {
    var p4, a3, n2, h3 = _3.props, c3 = t2.props, i3 = t2.type, u4 = 0;
    if (i3 === "svg" && (l2 = !0), o3 != null) {
      for (; u4 < o3.length; u4++)
        if ((p4 = o3[u4]) && "setAttribute" in p4 == !!i3 && (i3 ? p4.localName === i3 : p4.nodeType === 3)) {
          e3 = p4, o3[u4] = null;
          break;
        }
    }
    if (e3 == null) {
      if (i3 === null)
        return document.createTextNode(c3);
      e3 = l2 ? document.createElementNS("http://www.w3.org/2000/svg", i3) : document.createElement(i3, c3.is && c3), o3 = null, f5 = !1;
    }
    if (i3 === null)
      h3 === c3 || f5 && e3.data === c3 || (e3.data = c3);
    else {
      if (o3 = o3 && P.call(e3.childNodes), a3 = (h3 = _3.props || T).dangerouslySetInnerHTML, n2 = c3.dangerouslySetInnerHTML, !f5) {
        if (o3 != null)
          for (h3 = {}, u4 = 0; u4 < e3.attributes.length; u4++)
            h3[e3.attributes[u4].name] = e3.attributes[u4].value;
        (n2 || a3) && (n2 && (a3 && n2.__html == a3.__html || n2.__html === e3.innerHTML) || (e3.innerHTML = n2 && n2.__html || ""));
      }
      if (_e(e3, c3, h3, l2, f5), n2)
        t2.__k = [];
      else if (u4 = t2.props.children, G(e3, Array.isArray(u4) ? u4 : [u4], t2, _3, r, l2 && i3 !== "foreignObject", o3, s5, o3 ? o3[0] : _3.__k && C(_3, 0), f5), o3 != null)
        for (u4 = o3.length; u4--; )
          o3[u4] != null && j(o3[u4]);
      f5 || ("value" in c3 && (u4 = c3.value) !== void 0 && (u4 !== e3.value || i3 === "progress" && !u4 || i3 === "option" && u4 !== h3.value) && N(e3, "value", u4, h3.value, !1), "checked" in c3 && (u4 = c3.checked) !== void 0 && u4 !== e3.checked && N(e3, "checked", u4, h3.checked, !1));
    }
    return e3;
  }
  function Q(e3, t2, _3) {
    try {
      typeof e3 == "function" ? e3(t2) : e3.current = t2;
    } catch (r) {
      d.__e(r, _3);
    }
  }
  function X(e3, t2, _3) {
    var r, l2;
    if (d.unmount && d.unmount(e3), (r = e3.ref) && (r.current && r.current !== e3.__e || Q(r, null, t2)), (r = e3.__c) != null) {
      if (r.componentWillUnmount)
        try {
          r.componentWillUnmount();
        } catch (o3) {
          d.__e(o3, t2);
        }
      r.base = r.__P = null, e3.__c = void 0;
    }
    if (r = e3.__k)
      for (l2 = 0; l2 < r.length; l2++)
        r[l2] && X(r[l2], t2, typeof e3.type != "function");
    _3 || e3.__e == null || j(e3.__e), e3.__ = e3.__e = e3.__d = void 0;
  }
  function oe(e3, t2, _3) {
    return this.constructor(e3, _3);
  }
  function re(e3, t2, _3) {
    var r, l2, o3;
    d.__ && d.__(e3, t2), l2 = (r = typeof _3 == "function") ? null : _3 && _3.__k || t2.__k, o3 = [], W(t2, e3 = (!r && _3 || t2).__k = ee(L, null, [e3]), l2 || T, T, t2.ownerSVGElement !== void 0, !r && _3 ? [_3] : l2 ? null : t2.firstChild ? P.call(t2.childNodes) : null, o3, !r && _3 ? _3 : l2 ? l2.__e : t2.firstChild, r), K(o3, e3);
  }
  function ce(e3, t2) {
    var _3 = { __c: t2 = "__cC" + B++, __: e3, Consumer: function(r, l2) {
      return r.children(l2);
    }, Provider: function(r) {
      var l2, o3;
      return this.getChildContext || (l2 = [], (o3 = {})[t2] = this, this.getChildContext = function() {
        return o3;
      }, this.shouldComponentUpdate = function(s5) {
        this.props.value !== s5.value && l2.some(M);
      }, this.sub = function(s5) {
        l2.push(s5);
        var f5 = s5.componentWillUnmount;
        s5.componentWillUnmount = function() {
          l2.splice(l2.indexOf(s5), 1), f5 && f5.call(s5);
        };
      }), r.children;
    } };
    return _3.Provider.__ = _3.Consumer.contextType = _3;
  }
  P = V.slice, d = { __e: function(e3, t2, _3, r) {
    for (var l2, o3, s5; t2 = t2.__; )
      if ((l2 = t2.__c) && !l2.__)
        try {
          if ((o3 = l2.constructor) && o3.getDerivedStateFromError != null && (l2.setState(o3.getDerivedStateFromError(e3)), s5 = l2.__d), l2.componentDidCatch != null && (l2.componentDidCatch(e3, r || {}), s5 = l2.__d), s5)
            return l2.__E = l2;
        } catch (f5) {
          e3 = f5;
        }
    throw e3;
  } }, $ = 0, Y = function(e3) {
    return e3 != null && e3.constructor === void 0;
  }, U.prototype.setState = function(e3, t2) {
    var _3;
    _3 = this.__s != null && this.__s !== this.state ? this.__s : this.__s = k({}, this.state), typeof e3 == "function" && (e3 = e3(k({}, _3), this.props)), e3 && k(_3, e3), e3 != null && this.__v && (t2 && this.__h.push(t2), M(this));
  }, U.prototype.forceUpdate = function(e3) {
    this.__v && (this.__e = !0, e3 && this.__h.push(e3), M(this));
  }, U.prototype.render = L, S = [], D.__r = 0, B = 0;

  // https://esm.sh/stable/preact@10.11.0/deno/hooks.js
  var i, n, d2, N2, f = 0, q2 = [], l = [], V2 = d.__b, g = d.__r, b = d.diffed, C2 = d.__c, A = d.unmount;
  function a(_3, t2) {
    d.__h && d.__h(n, _3, f || t2), f = 0;
    var u4 = n.__H || (n.__H = { __: [], __h: [] });
    return _3 >= u4.__.length && u4.__.push({ __V: l }), u4.__[_3];
  }
  function P2(_3) {
    return f = 1, B2(D2, _3);
  }
  function B2(_3, t2, u4) {
    var o3 = a(i++, 2);
    if (o3.t = _3, !o3.__c && (o3.__ = [u4 ? u4(t2) : D2(void 0, t2), function(v5) {
      var s5 = o3.__N ? o3.__N[0] : o3.__[0], h3 = o3.t(s5, v5);
      s5 !== h3 && (o3.__N = [h3, o3.__[1]], o3.__c.setState({}));
    }], o3.__c = n, !n.u)) {
      n.u = !0;
      var r = n.shouldComponentUpdate;
      n.shouldComponentUpdate = function(v5, s5, h3) {
        if (!o3.__c.__H)
          return !0;
        var y3 = o3.__c.__H.__.filter(function(c3) {
          return c3.__c;
        });
        if (y3.every(function(c3) {
          return !c3.__N;
        }))
          return !r || r.call(this, v5, s5, h3);
        var E4 = !1;
        return y3.forEach(function(c3) {
          if (c3.__N) {
            var k4 = c3.__[0];
            c3.__ = c3.__N, c3.__N = void 0, k4 !== c3.__[0] && (E4 = !0);
          }
        }), !!E4 && (!r || r.call(this, v5, s5, h3));
      };
    }
    return o3.__N || o3.__;
  }
  function j2(_3, t2) {
    var u4 = a(i++, 3);
    !d.__s && H(u4.__H, t2) && (u4.__ = _3, u4.i = t2, n.__H.__h.push(u4));
  }
  function R2() {
    for (var _3; _3 = q2.shift(); )
      if (_3.__P && _3.__H)
        try {
          _3.__H.__h.forEach(m), _3.__H.__h.forEach(p), _3.__H.__h = [];
        } catch (t2) {
          _3.__H.__h = [], d.__e(t2, _3.__v);
        }
  }
  d.__b = function(_3) {
    typeof _3.type != "function" || _3.o || _3.type === L ? _3.o || (_3.o = _3.__ && _3.__.o ? _3.__.o : "") : _3.o = (_3.__ && _3.__.o ? _3.__.o : "") + (_3.__ && _3.__.__k ? _3.__.__k.indexOf(_3) : 0), n = null, V2 && V2(_3);
  }, d.__r = function(_3) {
    g && g(_3), i = 0;
    var t2 = (n = _3.__c).__H;
    t2 && (d2 === n ? (t2.__h = [], n.__h = [], t2.__.forEach(function(u4) {
      u4.__N && (u4.__ = u4.__N), u4.__V = l, u4.__N = u4.i = void 0;
    })) : (t2.__h.forEach(m), t2.__h.forEach(p), t2.__h = [])), d2 = n;
  }, d.diffed = function(_3) {
    b && b(_3);
    var t2 = _3.__c;
    t2 && t2.__H && (t2.__H.__h.length && (q2.push(t2) !== 1 && N2 === d.requestAnimationFrame || ((N2 = d.requestAnimationFrame) || S2)(R2)), t2.__H.__.forEach(function(u4) {
      u4.i && (u4.__H = u4.i), u4.__V !== l && (u4.__ = u4.__V), u4.i = void 0, u4.__V = l;
    })), d2 = n = null;
  }, d.__c = function(_3, t2) {
    t2.some(function(u4) {
      try {
        u4.__h.forEach(m), u4.__h = u4.__h.filter(function(o3) {
          return !o3.__ || p(o3);
        });
      } catch (o3) {
        t2.some(function(r) {
          r.__h && (r.__h = []);
        }), t2 = [], d.__e(o3, u4.__v);
      }
    }), C2 && C2(_3, t2);
  }, d.unmount = function(_3) {
    A && A(_3);
    var t2, u4 = _3.__c;
    u4 && u4.__H && (u4.__H.__.forEach(function(o3) {
      try {
        m(o3);
      } catch (r) {
        t2 = r;
      }
    }), u4.__H = void 0, t2 && d.__e(t2, u4.__v));
  };
  var F2 = typeof requestAnimationFrame == "function";
  function S2(_3) {
    var t2, u4 = function() {
      clearTimeout(o3), F2 && cancelAnimationFrame(t2), setTimeout(_3);
    }, o3 = setTimeout(u4, 100);
    F2 && (t2 = requestAnimationFrame(u4));
  }
  function m(_3) {
    var t2 = n, u4 = _3.__c;
    typeof u4 == "function" && (_3.__c = void 0, u4()), n = t2;
  }
  function p(_3) {
    var t2 = n;
    _3.__c = _3.__(), n = t2;
  }
  function H(_3, t2) {
    return !_3 || _3.length !== t2.length || t2.some(function(u4, o3) {
      return u4 !== _3[o3];
    });
  }
  function D2(_3, t2) {
    return typeof t2 == "function" ? t2(_3) : t2;
  }

  // libs/preact-translation/utils.ts
  function getResourceUrl(root, lang) {
    return [root, !root || root.endsWith("/") ? "" : "/", lang, ".json"].join("");
  }
  function format2(str, params) {
    let result = str;
    return params && Object.keys(params).forEach((key) => {
      let rawValue = params[key], keyIsNumber = isNumber(key);
      if (typeof rawValue == "object" || keyIsNumber) {
        let value = rawValue;
        keyIsNumber && typeof value == "string" && (value = {
          tag: "a",
          href: value,
          target: "_blank"
        });
        let tag = `<${key}>`, tagIndex = result.indexOf(tag);
        if (tagIndex !== -1) {
          let actualTag = value.tag || "a", endIndex = result.indexOf(`</${key}>`);
          if (endIndex !== -1) {
            let html = result.substring(tagIndex + tag.length, endIndex), attrs = Object.keys(value).filter((attr) => attr !== "tag").map((attr) => `${attr}="${value[attr]}"`).join(" ");
            result = result.replace(
              `${tag}${html}</${key}>`,
              `<${actualTag} ${attrs}>${html}</${actualTag}>`
            );
          }
        }
      } else {
        let template = new RegExp("{" + key + "}", "gm");
        result = result.replace(template, rawValue.toString());
      }
    }), result;
  }
  function getValue(languageData, lang, key) {
    let localeData = languageData[lang];
    if (!localeData)
      return key;
    let keys = key.split("."), propKey = "";
    do {
      propKey += keys.shift();
      let value = localeData[propKey];
      value !== void 0 && (typeof value == "object" || !keys.length) ? (localeData = value, propKey = "") : keys.length ? propKey += "." : localeData = key;
    } while (keys.length);
    return localeData;
  }
  function isNumber(value) {
    if (typeof value == "number")
      return !0;
    if (value) {
      let num = parseInt(value);
      return !isNaN(num);
    } else
      return !1;
  }

  // libs/preact-translation/useTranslate.tsx
  var cache = {}, defaultOptions = {
    root: "",
    lang: "en",
    fallbackLang: "en"
  };
  function useTranslate(rawOptions, translations2) {
    let options = Object.assign(
      {},
      defaultOptions,
      rawOptions
    );
    cache = translations2 || cache;
    let [lang, setLang] = P2(options.lang), [data, setData] = P2(cache), [isReady, setReady] = P2(!1), loadData = (langKey) => {
      if (data.hasOwnProperty(langKey))
        return;
      setReady(!1);
      let url = getResourceUrl(options.root || "", langKey);
      options.getUrl && (url = options.getUrl(options.root || "", langKey), fetch(url).then((results) => results.json()).then((resource) => {
        cache[langKey] = resource, setData({ ...cache }), setReady(!0);
      }).catch((error) => {
        setData({ ...cache }), setReady(!0);
      }));
    };
    return j2(() => {
      loadData(options.fallbackLang || "en"), loadData(lang);
    }, [lang]), { lang, setLang, t: (key, params) => {
      if (!data.hasOwnProperty(lang))
        return key;
      let value = getValue(data, lang, key);
      return value === key && lang !== options.fallbackLang && (value = getValue(data, options.fallbackLang, key)), format2(value, params);
    }, isReady };
  }

  // https://esm.sh/stable/preact@10.11.0/deno/jsx-runtime.js
  var a2 = 0;
  function p2(n2, s5, t2, f5, u4) {
    var r, o3, _3 = {};
    for (o3 in s5)
      o3 == "ref" ? r = s5[o3] : _3[o3] = s5[o3];
    var e3 = { type: n2, props: _3, key: t2, ref: r, __k: null, __: null, __b: 0, __e: null, __d: void 0, __c: null, __h: null, constructor: void 0, __v: --a2, __source: u4, __self: f5 };
    if (typeof n2 == "function" && (r = n2.defaultProps))
      for (o3 in r)
        _3[o3] === void 0 && (_3[o3] = r[o3]);
    return d.vnode && d.vnode(e3), e3;
  }

  // libs/preact-translation/translateProvider.tsx
  var TranslateContext = ce(null), defaultOptions2 = {
    root: "assets",
    lang: "en",
    fallbackLang: "en"
  }, TranslateProvider = (props) => {
    let { t: t2, setLang, lang, isReady } = useTranslate(
      {
        root: props.root || defaultOptions2.root,
        lang: props.lang || defaultOptions2.lang,
        fallbackLang: props.fallbackLang || defaultOptions2.fallbackLang,
        getUrl: props.getUrl
      },
      props.translations
    );
    return /* @__PURE__ */ p2(
      TranslateContext.Provider,
      {
        value: {
          t: t2,
          setLang,
          lang,
          isReady
        },
        children: props.children
      }
    );
  };

  // https://esm.sh/v119/@twind/core@1.1.3/deno/core.mjs
  var B3;
  function ae(e3) {
    return [...e3.v, (e3.i ? "!" : "") + e3.n].join(":");
  }
  function ue(e3, t2 = ",") {
    return e3.map(ae).join(t2);
  }
  var Y2 = typeof CSS < "u" && CSS.escape || ((e3) => e3.replace(/[!"'`*+.,;:\\/<=>?@#$%&^|~()[\]{}]/g, "\\$&").replace(/^\d/, "\\3$& "));
  function T2(e3) {
    for (var t2 = 9, r = e3.length; r--; )
      t2 = Math.imul(t2 ^ e3.charCodeAt(r), 1597334677);
    return "#" + ((t2 ^ t2 >>> 9) >>> 0).toString(36);
  }
  function Ce(e3, t2 = "@media ") {
    return t2 + b2(e3).map((r) => (typeof r == "string" && (r = { min: r }), r.raw || Object.keys(r).map((i3) => `(${i3}-width:${r[i3]})`).join(" and "))).join(",");
  }
  function b2(e3 = []) {
    return Array.isArray(e3) ? e3 : e3 == null ? [] : [e3];
  }
  function F3() {
  }
  var S3 = { d: 0, b: 134217728, c: 268435456, a: 671088640, u: 805306368, o: 939524096 };
  function Ee(e3) {
    return e3.match(/[-=:;]/g)?.length || 0;
  }
  function re2(e3) {
    return Math.min(/(?:^|width[^\d]+)(\d+(?:.\d+)?)(p)?/.test(e3) ? Math.max(0, 29.63 * (+RegExp.$1 / (RegExp.$2 ? 15 : 1)) ** 0.137 - 43) : 0, 15) << 22 | Math.min(Ee(e3), 15) << 18;
  }
  var Ue = ["rst-c", "st-ch", "h-chi", "y-lin", "nk", "sited", "ecked", "pty", "ad-on", "cus-w", "ver", "cus", "cus-v", "tive", "sable", "tiona", "quire"];
  function ce2({ n: e3, i: t2, v: r = [] }, i3, n2, l2) {
    e3 && (e3 = ae({ n: e3, i: t2, v: r })), l2 = [...b2(l2)];
    for (let s5 of r) {
      let f5 = i3.theme("screens", s5);
      for (let a3 of b2(f5 && Ce(f5) || i3.v(s5))) {
        var o3;
        l2.push(a3), n2 |= f5 ? 67108864 | re2(a3) : s5 == "dark" ? 1073741824 : a3[0] == "@" ? re2(a3) : (o3 = a3, 1 << ~(/:([a-z-]+)/.test(o3) && ~Ue.indexOf(RegExp.$1.slice(2, 7)) || -18));
      }
    }
    return { n: e3, p: n2, r: l2, i: t2 };
  }
  var pe = /* @__PURE__ */ new Map();
  function ne2(e3) {
    if (e3.d) {
      let t2 = [], r = H2(e3.r.reduce((i3, n2) => n2[0] == "@" ? (t2.push(n2), i3) : n2 ? H2(i3, (l2) => H2(n2, (o3) => {
        let s5 = /(:merge\(.+?\))(:[a-z-]+|\\[.+])/.exec(o3);
        if (s5) {
          let f5 = l2.indexOf(s5[1]);
          return ~f5 ? l2.slice(0, f5) + s5[0] + l2.slice(f5 + s5[1].length) : Q2(l2, o3);
        }
        return Q2(o3, l2);
      })) : i3, "&"), (i3) => Q2(i3, e3.n ? "." + Y2(e3.n) : ""));
      return r && t2.push(r.replace(/:merge\((.+?)\)/g, "$1")), t2.reduceRight((i3, n2) => n2 + "{" + i3 + "}", e3.d);
    }
  }
  function H2(e3, t2) {
    return e3.replace(/ *((?:\(.+?\)|\[.+?\]|[^,])+) *(,|$)/g, (r, i3, n2) => t2(i3) + n2);
  }
  function Q2(e3, t2) {
    return e3.replace(/&/g, t2);
  }
  var $e = new Intl.Collator("en", { numeric: !0 });
  function Me(e3, t2) {
    for (var r = 0, i3 = e3.length; r < i3; ) {
      let n2 = i3 + r >> 1;
      0 >= Ne(e3[n2], t2) ? r = n2 + 1 : i3 = n2;
    }
    return i3;
  }
  function Ne(e3, t2) {
    let r = e3.p & S3.o;
    return r == (t2.p & S3.o) && (r == S3.b || r == S3.o) ? 0 : e3.p - t2.p || e3.o - t2.o || $e.compare(we(e3.n), we(t2.n)) || $e.compare(Ae(e3.n), Ae(t2.n));
  }
  function we(e3) {
    return (e3 || "").split(/:/).pop().split("/").pop() || "\0";
  }
  function Ae(e3) {
    return (e3 || "").replace(/\W/g, (t2) => String.fromCharCode(127 + t2.charCodeAt(0))) + "\0";
  }
  function X2(e3, t2) {
    return Math.round(parseInt(e3, 16) * t2);
  }
  function P3(e3, t2 = {}) {
    if (typeof e3 == "function")
      return e3(t2);
    let { opacityValue: r = "1", opacityVariable: i3 } = t2, n2 = i3 ? `var(${i3})` : r;
    if (e3.includes("<alpha-value>"))
      return e3.replace("<alpha-value>", n2);
    if (e3[0] == "#" && (e3.length == 4 || e3.length == 7)) {
      let l2 = (e3.length - 1) / 3, o3 = [17, 1, 0.062272][l2 - 1];
      return `rgba(${[X2(e3.substr(1, l2), o3), X2(e3.substr(1 + l2, l2), o3), X2(e3.substr(1 + 2 * l2, l2), o3), n2]})`;
    }
    return n2 == "1" ? e3 : n2 == "0" ? "#0000" : e3.replace(/^(rgb|hsl)(\([^)]+)\)$/, `$1a$2,${n2})`);
  }
  function de(e3, t2, r, i3, n2 = []) {
    return function l2(o3, { n: s5, p: f5, r: a3 = [], i: c3 }, u4) {
      let p4 = [], g5 = "", y3 = 0, $5 = 0;
      for (let h3 in o3 || {}) {
        var A5, R6;
        let d6 = o3[h3];
        if (h3[0] == "@") {
          if (!d6)
            continue;
          if (h3[1] == "a") {
            p4.push(...ge(s5, f5, I2("" + d6), u4, f5, a3, c3, !0));
            continue;
          }
          if (h3[1] == "l") {
            for (let w4 of b2(d6))
              p4.push(...l2(w4, { n: s5, p: (A5 = S3[h3[7]], f5 & ~S3.o | A5), r: h3[7] == "d" ? [] : a3, i: c3 }, u4));
            continue;
          }
          if (h3[1] == "i") {
            p4.push(...b2(d6).map((w4) => ({ p: -1, o: 0, r: [], d: h3 + " " + w4 })));
            continue;
          }
          if (h3[1] == "k") {
            p4.push({ p: S3.d, o: 0, r: [h3], d: l2(d6, { p: S3.d }, u4).map(ne2).join("") });
            continue;
          }
          if (h3[1] == "f") {
            p4.push(...b2(d6).map((w4) => ({ p: S3.d, o: 0, r: [h3], d: l2(w4, { p: S3.d }, u4).map(ne2).join("") })));
            continue;
          }
        }
        if (typeof d6 != "object" || Array.isArray(d6))
          h3 == "label" && d6 ? s5 = d6 + T2(JSON.stringify([f5, c3, o3])) : (d6 || d6 === 0) && (h3 = h3.replace(/[A-Z]/g, (w4) => "-" + w4.toLowerCase()), $5 += 1, y3 = Math.max(y3, (R6 = h3)[0] == "-" ? 0 : Ee(R6) + (/^(?:(border-(?!w|c|sty)|[tlbr].{2,4}m?$|c.{7,8}$)|([fl].{5}l|g.{8}$|pl))/.test(R6) ? +!!RegExp.$1 || -!!RegExp.$2 : 0) + 1), g5 += (g5 ? ";" : "") + b2(d6).map((w4) => u4.s(h3, he("" + w4, u4.theme) + (c3 ? " !important" : ""))).join(";"));
        else if (h3[0] == "@" || h3.includes("&")) {
          let w4 = f5;
          h3[0] == "@" && (h3 = h3.replace(/\bscreen\(([^)]+)\)/g, (x2, M5) => {
            let N5 = u4.theme("screens", M5);
            return N5 ? (w4 |= 67108864, Ce(N5, "")) : x2;
          }), w4 |= re2(h3)), p4.push(...l2(d6, { n: s5, p: w4, r: [...a3, h3], i: c3 }, u4));
        } else
          p4.push(...l2(d6, { p: f5, r: [...a3, h3] }, u4));
      }
      return p4.unshift({ n: s5, p: f5, o: Math.max(0, 15 - $5) + 1.5 * Math.min(y3 || 15, 15), r: a3, d: g5 }), p4.sort(Ne);
    }(e3, ce2(t2, r, i3, n2), r);
  }
  function he(e3, t2) {
    return e3.replace(/theme\((["'`])?(.+?)\1(?:\s*,\s*(["'`])?(.+?)\3)?\)/g, (r, i3, n2, l2, o3 = "") => {
      let s5 = t2(n2, o3);
      return typeof s5 == "function" && /color|fill|stroke/i.test(n2) ? P3(s5) : "" + b2(s5).filter((f5) => Object(f5) !== f5);
    });
  }
  function ye(e3, t2) {
    let r, i3 = [];
    for (let n2 of e3)
      n2.d && n2.n ? r?.p == n2.p && "" + r.r == "" + n2.r ? (r.c = [r.c, n2.c].filter(Boolean).join(" "), r.d = r.d + ";" + n2.d) : i3.push(r = { ...n2, n: n2.n && t2 }) : i3.push({ ...n2, n: n2.n && t2 });
    return i3;
  }
  function W2(e3, t2, r = S3.u, i3, n2) {
    let l2 = [];
    for (let o3 of e3)
      for (let s5 of function(f5, a3, c3, u4, p4) {
        f5 = { ...f5, i: f5.i || p4 };
        let g5 = function(y3, $5) {
          let A5 = pe.get(y3.n);
          return A5 ? A5(y3, $5) : $5.r(y3.n, y3.v[0] == "dark");
        }(f5, a3);
        return g5 ? typeof g5 == "string" ? ({ r: u4, p: c3 } = ce2(f5, a3, c3, u4), ye(W2(I2(g5), a3, c3, u4, f5.i), f5.n)) : Array.isArray(g5) ? g5.map((y3) => {
          var $5, A5;
          return { o: 0, ...y3, r: [...b2(u4), ...b2(y3.r)], p: ($5 = c3, A5 = y3.p ?? c3, $5 & ~S3.o | A5) };
        }) : de(g5, f5, a3, c3, u4) : [{ c: ae(f5), p: 0, o: 0, r: [] }];
      }(o3, t2, r, i3, n2))
        l2.splice(Me(l2, s5), 0, s5);
    return l2;
  }
  function ge(e3, t2, r, i3, n2, l2, o3, s5) {
    return ye((s5 ? r.flatMap((f5) => W2([f5], i3, n2, l2, o3)) : W2(r, i3, n2, l2, o3)).map((f5) => f5.p & S3.o && (f5.n || t2 == S3.b) ? { ...f5, p: f5.p & ~S3.o | t2, o: 0 } : f5), e3);
  }
  function _e2(e3, t2, r, i3) {
    var n2;
    return n2 = (l2, o3) => {
      let { n: s5, p: f5, r: a3, i: c3 } = ce2(l2, o3, t2);
      return r && ge(s5, t2, r, o3, f5, a3, c3, i3);
    }, pe.set(e3, n2), e3;
  }
  function K2(e3, t2, r) {
    if (e3[e3.length - 1] != "(") {
      let i3 = [], n2 = !1, l2 = !1, o3 = "";
      for (let s5 of e3)
        if (!(s5 == "(" || /[~@]$/.test(s5))) {
          if (s5[0] == "!" && (s5 = s5.slice(1), n2 = !n2), s5.endsWith(":")) {
            i3[s5 == "dark:" ? "unshift" : "push"](s5.slice(0, -1));
            continue;
          }
          s5[0] == "-" && (s5 = s5.slice(1), l2 = !l2), s5.endsWith("-") && (s5 = s5.slice(0, -1)), s5 && s5 != "&" && (o3 += (o3 && "-") + s5);
        }
      o3 && (l2 && (o3 = "-" + o3), t2[0].push({ n: o3, v: i3.filter(Be), i: n2 }));
    }
  }
  function Be(e3, t2, r) {
    return r.indexOf(e3) == t2;
  }
  var Se = /* @__PURE__ */ new Map();
  function I2(e3) {
    let t2 = Se.get(e3);
    if (!t2) {
      let r = [], i3 = [[]], n2 = 0, l2 = 0, o3 = null, s5 = 0, f5 = (a3, c3 = 0) => {
        n2 != s5 && (r.push(e3.slice(n2, s5 + c3)), a3 && K2(r, i3)), n2 = s5 + 1;
      };
      for (; s5 < e3.length; s5++) {
        let a3 = e3[s5];
        if (l2)
          e3[s5 - 1] != "\\" && (l2 += +(a3 == "[") || -(a3 == "]"));
        else if (a3 == "[")
          l2 += 1;
        else if (o3)
          e3[s5 - 1] != "\\" && o3.test(e3.slice(s5)) && (o3 = null, n2 = s5 + RegExp.lastMatch.length);
        else if (a3 == "/" && e3[s5 - 1] != "\\" && (e3[s5 + 1] == "*" || e3[s5 + 1] == "/"))
          o3 = e3[s5 + 1] == "*" ? /^\*\// : /^[\r\n]/;
        else if (a3 == "(")
          f5(), r.push(a3);
        else if (a3 == ":")
          e3[s5 + 1] != ":" && f5(!1, 1);
        else if (/[\s,)]/.test(a3)) {
          f5(!0);
          let c3 = r.lastIndexOf("(");
          if (a3 == ")") {
            let u4 = r[c3 - 1];
            if (/[~@]$/.test(u4)) {
              let p4 = i3.shift();
              r.length = c3, K2([...r, "#"], i3);
              let { v: g5 } = i3[0].pop();
              for (let y3 of p4)
                y3.v.splice(+(y3.v[0] == "dark") - +(g5[0] == "dark"), g5.length);
              K2([...r, _e2(u4.length > 1 ? u4.slice(0, -1) + T2(JSON.stringify([u4, p4])) : u4 + "(" + ue(p4) + ")", S3.a, p4, /@$/.test(u4))], i3);
            }
            c3 = r.lastIndexOf("(", c3 - 1);
          }
          r.length = c3 + 1;
        } else
          /[~@]/.test(a3) && e3[s5 + 1] == "(" && i3.unshift([]);
      }
      f5(!0), Se.set(e3, t2 = i3[0]);
    }
    return t2;
  }
  function Ve(e3, t2, r) {
    return t2.reduce((i3, n2, l2) => i3 + r(n2) + e3[l2 + 1], e3[0]);
  }
  function Z2(e3, t2) {
    return Array.isArray(e3) && Array.isArray(e3.raw) ? Ve(e3, t2, (r) => ee2(r).trim()) : t2.filter(Boolean).reduce((r, i3) => r + ee2(i3), e3 ? ee2(e3) : "");
  }
  function ee2(e3) {
    let t2, r = "";
    if (e3 && typeof e3 == "object")
      if (Array.isArray(e3))
        (t2 = Z2(e3[0], e3.slice(1))) && (r += " " + t2);
      else
        for (let i3 in e3)
          e3[i3] && (r += " " + i3);
    else
      e3 != null && typeof e3 != "boolean" && (r += " " + e3);
    return r;
  }
  var pt = ze("@"), dt = ze("~");
  function ze(e3) {
    return new Proxy(function(i3, ...n2) {
      return t2("", i3, n2);
    }, { get(r, i3) {
      return i3 in r ? r[i3] : function(l2, ...o3) {
        return t2(i3, l2, o3);
      };
    } });
    function t2(r, i3, n2) {
      return ue(I2(r + e3 + "(" + Z2(i3, n2) + ")"));
    }
  }
  function G2(e3, t2) {
    return Array.isArray(e3) ? ve(Ve(e3, t2, (r) => r != null && typeof r != "boolean" ? r : "")) : typeof e3 == "string" ? ve(e3) : [e3];
  }
  var We = / *(?:(?:([\u0080-\uFFFF\w-%@]+) *:? *([^{;]+?);|([^;}{]*?) *{)|(}))/g;
  function ve(e3) {
    let t2;
    e3 = e3.replace(/\/\*[^]*?\*\/|\s\s+|\n/gm, " ");
    let r = [{}], i3 = [r[0]], n2 = [];
    for (; t2 = We.exec(e3); )
      t2[4] && (r.shift(), n2.shift()), t2[3] ? (n2.unshift(t2[3]), r.unshift({}), i3.push(n2.reduce((l2, o3) => ({ [o3]: l2 }), r[0]))) : t2[4] || (r[0][t2[1]] && (r.unshift({}), i3.push(n2.reduce((l2, o3) => ({ [o3]: l2 }), r[0]))), r[0][t2[1]] = t2[2]);
    return i3;
  }
  function me(e3, ...t2) {
    var r;
    let i3 = G2(e3, t2), n2 = (i3.find((l2) => l2.label)?.label || "css") + T2(JSON.stringify(i3));
    return r = (l2, o3) => ye(i3.flatMap((s5) => de(s5, l2, o3, S3.o)), n2), pe.set(n2, r), n2;
  }
  var ht = new Proxy(function(e3, t2) {
    return Re("animation", e3, t2);
  }, { get(e3, t2) {
    return t2 in e3 ? e3[t2] : function(i3, n2) {
      return Re(t2, i3, n2);
    };
  } });
  function Re(e3, t2, r) {
    return { toString() {
      return me({ label: e3, "@layer components": { ...typeof t2 == "object" ? t2 : { animation: t2 }, animationName: "" + r } });
    } };
  }
  function yt(e3, t2, r) {
    return [e3, ie(t2, r)];
  }
  function ie(e3, t2) {
    return typeof e3 == "function" ? e3 : typeof e3 == "string" && /^[\w-]+$/.test(e3) ? (r, i3) => ({ [e3]: t2 ? t2(r, i3) : le(r, 1) }) : (r) => e3 || { [r[1]]: le(r, 2) };
  }
  function le(e3, t2, r = e3.slice(t2).find(Boolean) || e3.$$ || e3.input) {
    return e3.input[0] == "-" ? `calc(${r} * -1)` : r;
  }
  function gt(e3, t2, r, i3) {
    return [e3, Ge(t2, r, i3)];
  }
  function Ge(e3, t2, r) {
    let i3 = typeof t2 == "string" ? (n2, l2) => ({ [t2]: r ? r(n2, l2) : n2._ }) : t2 || (({ 1: n2, _: l2 }, o3, s5) => ({ [n2 || s5]: l2 }));
    return (n2, l2) => {
      let o3 = ke(e3 || n2[1]), s5 = l2.theme(o3, n2.$$) ?? oe2(n2.$$, o3, l2);
      if (s5 != null)
        return n2._ = le(n2, 0, s5), i3(n2, l2, o3);
    };
  }
  function mt(e3, t2 = {}, r) {
    return [e3, Ye(t2, r)];
  }
  function Ye(e3 = {}, t2) {
    return (r, i3) => {
      let { section: n2 = ke(r[0]).replace("-", "") + "Color" } = e3, [l2, o3] = Ze(r.$$);
      if (!l2)
        return;
      let s5 = i3.theme(n2, l2) || oe2(l2, n2, i3);
      if (!s5 || typeof s5 == "object")
        return;
      let { opacityVariable: f5 = `--tw-${r[0].replace(/-$/, "")}-opacity`, opacitySection: a3 = n2.replace("Color", "Opacity"), property: c3 = n2, selector: u4 } = e3, p4 = i3.theme(a3, o3 || "DEFAULT") || o3 && oe2(o3, a3, i3), g5 = t2 || (({ _: $5 }) => {
        let A5 = He(c3, $5);
        return u4 ? { [u4]: A5 } : A5;
      });
      r._ = { value: P3(s5, { opacityVariable: f5 || void 0, opacityValue: p4 || void 0 }), color: ($5) => P3(s5, $5), opacityVariable: f5 || void 0, opacityValue: p4 || void 0 };
      let y3 = g5(r, i3);
      if (!r.dark) {
        let $5 = i3.d(n2, l2, s5);
        $5 && $5 !== s5 && (r._ = { value: P3($5, { opacityVariable: f5 || void 0, opacityValue: p4 || "1" }), color: (A5) => P3($5, A5), opacityVariable: f5 || void 0, opacityValue: p4 || void 0 }, y3 = { "&": y3, [i3.v("dark")]: g5(r, i3) });
      }
      return y3;
    };
  }
  function Ze(e3) {
    return (e3.match(/^(\[[^\]]+]|[^/]+?)(?:\/(.+))?$/) || []).slice(1);
  }
  function He(e3, t2) {
    let r = {};
    return typeof t2 == "string" ? r[e3] = t2 : (t2.opacityVariable && t2.value.includes(t2.opacityVariable) && (r[t2.opacityVariable] = t2.opacityValue || "1"), r[e3] = t2.value), r;
  }
  function oe2(e3, t2, r) {
    if (e3[0] == "[" && e3.slice(-1) == "]") {
      if (e3 = se(he(e3.slice(1, -1), r.theme)), !t2)
        return e3;
      if (!(/color|fill|stroke/i.test(t2) && !(/^color:/.test(e3) || /^(#|((hsl|rgb)a?|hwb|lab|lch|color)\(|[a-z]+$)/.test(e3)) || /image/i.test(t2) && !(/^image:/.test(e3) || /^[a-z-]+\(/.test(e3)) || /weight/i.test(t2) && !(/^(number|any):/.test(e3) || /^\d+$/.test(e3)) || /position/i.test(t2) && /^(length|size):/.test(e3)))
        return e3.replace(/^[a-z-]+:/, "");
    }
  }
  function ke(e3) {
    return e3.replace(/-./g, (t2) => t2[1].toUpperCase());
  }
  function se(e3) {
    return e3.includes("url(") ? e3.replace(/(.*?)(url\(.*?\))(.*?)/g, (t2, r = "", i3, n2 = "") => se(r) + i3 + se(n2)) : e3.replace(/(^|[^\\])_+/g, (t2, r) => r + " ".repeat(t2.length - r.length)).replace(/\\_/g, "_").replace(/(calc|min|max|clamp)\(.+\)/g, (t2) => t2.replace(/(-?\d*\.?\d(?!\b-.+[,)](?![^+\-/*])\D)(?:%|[a-z]+)?|\))([+\-/*])/g, "$1 $2 "));
  }
  var Qe = Symbol();
  var D3 = new Proxy(F3, { apply(e3, t2, r) {
    return B3(r[0]);
  }, get(e3, t2) {
    let r = B3[t2];
    return typeof r == "function" ? function() {
      return r.apply(B3, arguments);
    } : r;
  } });
  var Rt = function e(t2) {
    return new Proxy(function(i3, ...n2) {
      return je(t2, "", i3, n2);
    }, { get(r, i3) {
      return i3 === "bind" ? e : i3 in r ? r[i3] : function(l2, ...o3) {
        return je(t2, i3, l2, o3);
      };
    } });
  }();
  function je(e3, t2, r, i3) {
    return { toString() {
      let n2 = G2(r, i3), l2 = Y2(t2 + T2(JSON.stringify([t2, n2])));
      return (typeof e3 == "function" ? e3 : D3)(me({ [`@keyframes ${l2}`]: G2(r, i3) })), l2;
    } };
  }

  // https://esm.sh/v119/@twind/preset-tailwind@1.1.4/deno/preset-tailwind.mjs
  var w3 = { screens: { sm: "640px", md: "768px", lg: "1024px", xl: "1280px", "2xl": "1536px" }, columns: { auto: "auto", "3xs": "16rem", "2xs": "18rem", xs: "20rem", sm: "24rem", md: "28rem", lg: "32rem", xl: "36rem", "2xl": "42rem", "3xl": "48rem", "4xl": "56rem", "5xl": "64rem", "6xl": "72rem", "7xl": "80rem" }, spacing: { px: "1px", 0: "0px", ...d3(4, "rem", 4, 0.5, 0.5), ...d3(12, "rem", 4, 5), 14: "3.5rem", ...d3(64, "rem", 4, 16, 4), 72: "18rem", 80: "20rem", 96: "24rem" }, durations: { 75: "75ms", 100: "100ms", 150: "150ms", 200: "200ms", 300: "300ms", 500: "500ms", 700: "700ms", 1e3: "1000ms" }, animation: { none: "none", spin: "spin 1s linear infinite", ping: "ping 1s cubic-bezier(0,0,0.2,1) infinite", pulse: "pulse 2s cubic-bezier(0.4,0,0.6,1) infinite", bounce: "bounce 1s infinite" }, aspectRatio: { auto: "auto", square: "1/1", video: "16/9" }, backdropBlur: i2("blur"), backdropBrightness: i2("brightness"), backdropContrast: i2("contrast"), backdropGrayscale: i2("grayscale"), backdropHueRotate: i2("hueRotate"), backdropInvert: i2("invert"), backdropOpacity: i2("opacity"), backdropSaturate: i2("saturate"), backdropSepia: i2("sepia"), backgroundColor: i2("colors"), backgroundImage: { none: "none" }, backgroundOpacity: i2("opacity"), backgroundSize: { auto: "auto", cover: "cover", contain: "contain" }, blur: { none: "none", 0: "0", sm: "4px", DEFAULT: "8px", md: "12px", lg: "16px", xl: "24px", "2xl": "40px", "3xl": "64px" }, brightness: { ...d3(200, "", 100, 0, 50), ...d3(110, "", 100, 90, 5), 75: "0.75", 125: "1.25" }, borderColor: ({ theme: e3 }) => ({ DEFAULT: e3("colors.gray.200", "currentColor"), ...e3("colors") }), borderOpacity: i2("opacity"), borderRadius: { none: "0px", sm: "0.125rem", DEFAULT: "0.25rem", md: "0.375rem", lg: "0.5rem", xl: "0.75rem", "2xl": "1rem", "3xl": "1.5rem", "1/2": "50%", full: "9999px" }, borderSpacing: i2("spacing"), borderWidth: { DEFAULT: "1px", ...f2(8, "px") }, boxShadow: { sm: "0 1px 2px 0 rgba(0,0,0,0.05)", DEFAULT: "0 1px 3px 0 rgba(0,0,0,0.1), 0 1px 2px -1px rgba(0,0,0,0.1)", md: "0 4px 6px -1px rgba(0,0,0,0.1), 0 2px 4px -2px rgba(0,0,0,0.1)", lg: "0 10px 15px -3px rgba(0,0,0,0.1), 0 4px 6px -4px rgba(0,0,0,0.1)", xl: "0 20px 25px -5px rgba(0,0,0,0.1), 0 8px 10px -6px rgba(0,0,0,0.1)", "2xl": "0 25px 50px -12px rgba(0,0,0,0.25)", inner: "inset 0 2px 4px 0 rgba(0,0,0,0.05)", none: "0 0 #0000" }, boxShadowColor: i2("colors"), caretColor: i2("colors"), accentColor: ({ theme: e3 }) => ({ auto: "auto", ...e3("colors") }), contrast: { ...d3(200, "", 100, 0, 50), 75: "0.75", 125: "1.25" }, content: { none: "none" }, divideColor: i2("borderColor"), divideOpacity: i2("borderOpacity"), divideWidth: i2("borderWidth"), dropShadow: { sm: "0 1px 1px rgba(0,0,0,0.05)", DEFAULT: ["0 1px 2px rgba(0,0,0,0.1)", "0 1px 1px rgba(0,0,0,0.06)"], md: ["0 4px 3px rgba(0,0,0,0.07)", "0 2px 2px rgba(0,0,0,0.06)"], lg: ["0 10px 8px rgba(0,0,0,0.04)", "0 4px 3px rgba(0,0,0,0.1)"], xl: ["0 20px 13px rgba(0,0,0,0.03)", "0 8px 5px rgba(0,0,0,0.08)"], "2xl": "0 25px 25px rgba(0,0,0,0.15)", none: "0 0 #0000" }, fill: ({ theme: e3 }) => ({ ...e3("colors"), none: "none" }), grayscale: { DEFAULT: "100%", 0: "0" }, hueRotate: { 0: "0deg", 15: "15deg", 30: "30deg", 60: "60deg", 90: "90deg", 180: "180deg" }, invert: { DEFAULT: "100%", 0: "0" }, flex: { 1: "1 1 0%", auto: "1 1 auto", initial: "0 1 auto", none: "none" }, flexBasis: ({ theme: e3 }) => ({ ...e3("spacing"), ...y(2, 6), ...y(12, 12), auto: "auto", full: "100%" }), flexGrow: { DEFAULT: 1, 0: 0 }, flexShrink: { DEFAULT: 1, 0: 0 }, fontFamily: { sans: 'ui-sans-serif,system-ui,-apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,"Noto Sans",sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol","Noto Color Emoji"'.split(","), serif: 'ui-serif,Georgia,Cambria,"Times New Roman",Times,serif'.split(","), mono: 'ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,"Liberation Mono","Courier New",monospace'.split(",") }, fontSize: { xs: ["0.75rem", "1rem"], sm: ["0.875rem", "1.25rem"], base: ["1rem", "1.5rem"], lg: ["1.125rem", "1.75rem"], xl: ["1.25rem", "1.75rem"], "2xl": ["1.5rem", "2rem"], "3xl": ["1.875rem", "2.25rem"], "4xl": ["2.25rem", "2.5rem"], "5xl": ["3rem", "1"], "6xl": ["3.75rem", "1"], "7xl": ["4.5rem", "1"], "8xl": ["6rem", "1"], "9xl": ["8rem", "1"] }, fontWeight: { thin: "100", extralight: "200", light: "300", normal: "400", medium: "500", semibold: "600", bold: "700", extrabold: "800", black: "900" }, gap: i2("spacing"), gradientColorStops: i2("colors"), gridAutoColumns: { auto: "auto", min: "min-content", max: "max-content", fr: "minmax(0,1fr)" }, gridAutoRows: { auto: "auto", min: "min-content", max: "max-content", fr: "minmax(0,1fr)" }, gridColumn: { auto: "auto", "span-full": "1 / -1" }, gridRow: { auto: "auto", "span-full": "1 / -1" }, gridTemplateColumns: { none: "none" }, gridTemplateRows: { none: "none" }, height: ({ theme: e3 }) => ({ ...e3("spacing"), ...y(2, 6), min: "min-content", max: "max-content", fit: "fit-content", auto: "auto", full: "100%", screen: "100vh" }), inset: ({ theme: e3 }) => ({ ...e3("spacing"), ...y(2, 4), auto: "auto", full: "100%" }), keyframes: { spin: { from: { transform: "rotate(0deg)" }, to: { transform: "rotate(360deg)" } }, ping: { "0%": { transform: "scale(1)", opacity: "1" }, "75%,100%": { transform: "scale(2)", opacity: "0" } }, pulse: { "0%,100%": { opacity: "1" }, "50%": { opacity: ".5" } }, bounce: { "0%, 100%": { transform: "translateY(-25%)", animationTimingFunction: "cubic-bezier(0.8,0,1,1)" }, "50%": { transform: "none", animationTimingFunction: "cubic-bezier(0,0,0.2,1)" } } }, letterSpacing: { tighter: "-0.05em", tight: "-0.025em", normal: "0em", wide: "0.025em", wider: "0.05em", widest: "0.1em" }, lineHeight: { ...d3(10, "rem", 4, 3), none: "1", tight: "1.25", snug: "1.375", normal: "1.5", relaxed: "1.625", loose: "2" }, margin: ({ theme: e3 }) => ({ auto: "auto", ...e3("spacing") }), maxHeight: ({ theme: e3 }) => ({ full: "100%", min: "min-content", max: "max-content", fit: "fit-content", screen: "100vh", ...e3("spacing") }), maxWidth: ({ theme: e3, breakpoints: t2 }) => ({ ...t2(e3("screens")), none: "none", 0: "0rem", xs: "20rem", sm: "24rem", md: "28rem", lg: "32rem", xl: "36rem", "2xl": "42rem", "3xl": "48rem", "4xl": "56rem", "5xl": "64rem", "6xl": "72rem", "7xl": "80rem", full: "100%", min: "min-content", max: "max-content", fit: "fit-content", prose: "65ch" }), minHeight: { 0: "0px", full: "100%", min: "min-content", max: "max-content", fit: "fit-content", screen: "100vh" }, minWidth: { 0: "0px", full: "100%", min: "min-content", max: "max-content", fit: "fit-content" }, opacity: { ...d3(100, "", 100, 0, 10), 5: "0.05", 25: "0.25", 75: "0.75", 95: "0.95" }, order: { first: "-9999", last: "9999", none: "0" }, padding: i2("spacing"), placeholderColor: i2("colors"), placeholderOpacity: i2("opacity"), outlineColor: i2("colors"), outlineOffset: f2(8, "px"), outlineWidth: f2(8, "px"), ringColor: ({ theme: e3 }) => ({ ...e3("colors"), DEFAULT: "#3b82f6" }), ringOffsetColor: i2("colors"), ringOffsetWidth: f2(8, "px"), ringOpacity: ({ theme: e3 }) => ({ ...e3("opacity"), DEFAULT: "0.5" }), ringWidth: { DEFAULT: "3px", ...f2(8, "px") }, rotate: { ...f2(2, "deg"), ...f2(12, "deg", 3), ...f2(180, "deg", 45) }, saturate: d3(200, "", 100, 0, 50), scale: { ...d3(150, "", 100, 0, 50), ...d3(110, "", 100, 90, 5), 75: "0.75", 125: "1.25" }, scrollMargin: i2("spacing"), scrollPadding: i2("spacing"), sepia: { 0: "0", DEFAULT: "100%" }, skew: { ...f2(2, "deg"), ...f2(12, "deg", 3) }, space: i2("spacing"), stroke: ({ theme: e3 }) => ({ ...e3("colors"), none: "none" }), strokeWidth: d3(2), textColor: i2("colors"), textDecorationColor: i2("colors"), textDecorationThickness: { "from-font": "from-font", auto: "auto", ...f2(8, "px") }, textUnderlineOffset: { auto: "auto", ...f2(8, "px") }, textIndent: i2("spacing"), textOpacity: i2("opacity"), transitionDuration: ({ theme: e3 }) => ({ ...e3("durations"), DEFAULT: "150ms" }), transitionDelay: i2("durations"), transitionProperty: { none: "none", all: "all", DEFAULT: "color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter", colors: "color,background-color,border-color,text-decoration-color,fill,stroke", opacity: "opacity", shadow: "box-shadow", transform: "transform" }, transitionTimingFunction: { DEFAULT: "cubic-bezier(0.4,0,0.2,1)", linear: "linear", in: "cubic-bezier(0.4,0,1,1)", out: "cubic-bezier(0,0,0.2,1)", "in-out": "cubic-bezier(0.4,0,0.2,1)" }, translate: ({ theme: e3 }) => ({ ...e3("spacing"), ...y(2, 4), full: "100%" }), width: ({ theme: e3 }) => ({ min: "min-content", max: "max-content", fit: "fit-content", screen: "100vw", ...e3("flexBasis") }), willChange: { scroll: "scroll-position" }, zIndex: { ...d3(50, "", 1, 0, 10), auto: "auto" } };
  function y(e3, t2) {
    let a3 = {};
    do
      for (var n2 = 1; n2 < e3; n2++)
        a3[`${n2}/${e3}`] = Number((n2 / e3 * 100).toFixed(6)) + "%";
    while (++e3 <= t2);
    return a3;
  }
  function f2(e3, t2, a3 = 0) {
    let n2 = {};
    for (; a3 <= e3; a3 = 2 * a3 || 1)
      n2[a3] = a3 + t2;
    return n2;
  }
  function d3(e3, t2 = "", a3 = 1, n2 = 0, l2 = 1, c3 = {}) {
    for (; n2 <= e3; n2 += l2)
      c3[n2] = n2 / a3 + t2;
    return c3;
  }
  function i2(e3) {
    return ({ theme: t2 }) => t2(e3);
  }
  var W3 = { "*,::before,::after": { boxSizing: "border-box", borderWidth: "0", borderStyle: "solid", borderColor: "theme(borderColor.DEFAULT, currentColor)" }, "::before,::after": { "--tw-content": "''" }, html: { lineHeight: 1.5, WebkitTextSizeAdjust: "100%", MozTabSize: "4", tabSize: 4, fontFamily: `theme(fontFamily.sans, ${w3.fontFamily.sans})`, fontFeatureSettings: "theme(fontFamily.sans[1].fontFeatureSettings, normal)" }, body: { margin: "0", lineHeight: "inherit" }, hr: { height: "0", color: "inherit", borderTopWidth: "1px" }, "abbr:where([title])": { textDecoration: "underline dotted" }, "h1,h2,h3,h4,h5,h6": { fontSize: "inherit", fontWeight: "inherit" }, a: { color: "inherit", textDecoration: "inherit" }, "b,strong": { fontWeight: "bolder" }, "code,kbd,samp,pre": { fontFamily: `theme(fontFamily.mono, ${w3.fontFamily.mono})`, fontFeatureSettings: "theme(fontFamily.mono[1].fontFeatureSettings, normal)", fontSize: "1em" }, small: { fontSize: "80%" }, "sub,sup": { fontSize: "75%", lineHeight: 0, position: "relative", verticalAlign: "baseline" }, sub: { bottom: "-0.25em" }, sup: { top: "-0.5em" }, table: { textIndent: "0", borderColor: "inherit", borderCollapse: "collapse" }, "button,input,optgroup,select,textarea": { fontFamily: "inherit", fontSize: "100%", lineHeight: "inherit", color: "inherit", margin: "0", padding: "0" }, "button,select": { textTransform: "none" }, "button,[type='button'],[type='reset'],[type='submit']": { WebkitAppearance: "button", backgroundColor: "transparent", backgroundImage: "none" }, ":-moz-focusring": { outline: "auto" }, ":-moz-ui-invalid": { boxShadow: "none" }, progress: { verticalAlign: "baseline" }, "::-webkit-inner-spin-button,::-webkit-outer-spin-button": { height: "auto" }, "[type='search']": { WebkitAppearance: "textfield", outlineOffset: "-2px" }, "::-webkit-search-decoration": { WebkitAppearance: "none" }, "::-webkit-file-upload-button": { WebkitAppearance: "button", font: "inherit" }, summary: { display: "list-item" }, "blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre": { margin: "0" }, fieldset: { margin: "0", padding: "0" }, legend: { padding: "0" }, "ol,ul,menu": { listStyle: "none", margin: "0", padding: "0" }, textarea: { resize: "vertical" }, "input::placeholder,textarea::placeholder": { opacity: 1, color: "theme(colors.gray.400, #9ca3af)" }, 'button,[role="button"]': { cursor: "pointer" }, ":disabled": { cursor: "default" }, "img,svg,video,canvas,audio,iframe,embed,object": { display: "block", verticalAlign: "middle" }, "img,video": { maxWidth: "100%", height: "auto" }, "[hidden]": { display: "none" } }, T3 = [yt("\\[([-\\w]+):(.+)]", ({ 1: e3, 2: t2 }, a3) => ({ "@layer overrides": { "&": { [e3]: oe2(`[${t2}]`, "", a3) } } })), yt("(group|peer)([~/][^-[]+)?", ({ input: e3 }, { h: t2 }) => [{ c: t2(e3) }]), gt("aspect-", "aspectRatio"), yt("container", (e3, { theme: t2 }) => {
    let { screens: a3 = t2("screens"), center: n2, padding: l2 } = t2("container"), c3 = { width: "100%", marginRight: n2 && "auto", marginLeft: n2 && "auto", ...g5("xs") };
    for (let x2 in a3) {
      let p4 = a3[x2];
      typeof p4 == "string" && (c3[Ce(p4)] = { "&": { maxWidth: p4, ...g5(x2) } });
    }
    return c3;
    function g5(x2) {
      let p4 = l2 && (typeof l2 == "string" ? l2 : l2[x2] || l2.DEFAULT);
      if (p4)
        return { paddingRight: p4, paddingLeft: p4 };
    }
  }), gt("content-", "content", ({ _: e3 }) => ({ "--tw-content": e3, content: "var(--tw-content)" })), yt("(?:box-)?decoration-(slice|clone)", "boxDecorationBreak"), yt("box-(border|content)", "boxSizing", ({ 1: e3 }) => e3 + "-box"), yt("hidden", { display: "none" }), yt("table-(auto|fixed)", "tableLayout"), yt(["(block|flex|table|grid|inline|contents|flow-root|list-item)", "(inline-(block|flex|table|grid))", "(table-(caption|cell|column|row|(column|row|footer|header)-group))"], "display"), "(float)-(left|right|none)", "(clear)-(left|right|none|both)", "(overflow(?:-[xy])?)-(auto|hidden|clip|visible|scroll)", "(isolation)-(auto)", yt("isolate", "isolation"), yt("object-(contain|cover|fill|none|scale-down)", "objectFit"), gt("object-", "objectPosition"), yt("object-(top|bottom|center|(left|right)(-(top|bottom))?)", "objectPosition", v), yt("overscroll(-[xy])?-(auto|contain|none)", ({ 1: e3 = "", 2: t2 }) => ({ ["overscroll-behavior" + e3]: t2 })), yt("(static|fixed|absolute|relative|sticky)", "position"), gt("-?inset(-[xy])?(?:$|-)", "inset", ({ 1: e3, _: t2 }) => ({ top: e3 != "-x" && t2, right: e3 != "-y" && t2, bottom: e3 != "-x" && t2, left: e3 != "-y" && t2 })), gt("-?(top|bottom|left|right)(?:$|-)", "inset"), yt("(visible|collapse)", "visibility"), yt("invisible", { visibility: "hidden" }), gt("-?z-", "zIndex"), yt("flex-((row|col)(-reverse)?)", "flexDirection", A2), yt("flex-(wrap|wrap-reverse|nowrap)", "flexWrap"), gt("(flex-(?:grow|shrink))(?:$|-)"), gt("(flex)-"), gt("grow(?:$|-)", "flexGrow"), gt("shrink(?:$|-)", "flexShrink"), gt("basis-", "flexBasis"), gt("-?(order)-"), "-?(order)-(\\d+)", gt("grid-cols-", "gridTemplateColumns"), yt("grid-cols-(\\d+)", "gridTemplateColumns", R3), gt("col-", "gridColumn"), yt("col-(span)-(\\d+)", "gridColumn", E), gt("col-start-", "gridColumnStart"), yt("col-start-(auto|\\d+)", "gridColumnStart"), gt("col-end-", "gridColumnEnd"), yt("col-end-(auto|\\d+)", "gridColumnEnd"), gt("grid-rows-", "gridTemplateRows"), yt("grid-rows-(\\d+)", "gridTemplateRows", R3), gt("row-", "gridRow"), yt("row-(span)-(\\d+)", "gridRow", E), gt("row-start-", "gridRowStart"), yt("row-start-(auto|\\d+)", "gridRowStart"), gt("row-end-", "gridRowEnd"), yt("row-end-(auto|\\d+)", "gridRowEnd"), yt("grid-flow-((row|col)(-dense)?)", "gridAutoFlow", (e3) => v(A2(e3))), yt("grid-flow-(dense)", "gridAutoFlow"), gt("auto-cols-", "gridAutoColumns"), gt("auto-rows-", "gridAutoRows"), gt("gap-x(?:$|-)", "gap", "columnGap"), gt("gap-y(?:$|-)", "gap", "rowGap"), gt("gap(?:$|-)", "gap"), "(justify-(?:items|self))-", yt("justify-", "justifyContent", O2), yt("(content|items|self)-", (e3) => ({ ["align-" + e3[1]]: O2(e3) })), yt("(place-(content|items|self))-", ({ 1: e3, $$: t2 }) => ({ [e3]: ("wun".includes(t2[3]) ? "space-" : "") + t2 })), gt("p([xytrbl])?(?:$|-)", "padding", h("padding")), gt("-?m([xytrbl])?(?:$|-)", "margin", h("margin")), gt("-?space-(x|y)(?:$|-)", "space", ({ 1: e3, _: t2 }) => ({ "&>:not([hidden])~:not([hidden])": { [`--tw-space-${e3}-reverse`]: "0", ["margin-" + { y: "top", x: "left" }[e3]]: `calc(${t2} * calc(1 - var(--tw-space-${e3}-reverse)))`, ["margin-" + { y: "bottom", x: "right" }[e3]]: `calc(${t2} * var(--tw-space-${e3}-reverse))` } })), yt("space-(x|y)-reverse", ({ 1: e3 }) => ({ "&>:not([hidden])~:not([hidden])": { [`--tw-space-${e3}-reverse`]: "1" } })), gt("w-", "width"), gt("min-w-", "minWidth"), gt("max-w-", "maxWidth"), gt("h-", "height"), gt("min-h-", "minHeight"), gt("max-h-", "maxHeight"), gt("font-", "fontWeight"), gt("font-", "fontFamily", ({ _: e3 }) => typeof (e3 = b2(e3))[1] == "string" ? { fontFamily: m2(e3) } : { fontFamily: m2(e3[0]), ...e3[1] }), yt("antialiased", { WebkitFontSmoothing: "antialiased", MozOsxFontSmoothing: "grayscale" }), yt("subpixel-antialiased", { WebkitFontSmoothing: "auto", MozOsxFontSmoothing: "auto" }), yt("italic", "fontStyle"), yt("not-italic", { fontStyle: "normal" }), yt("(ordinal|slashed-zero|(normal|lining|oldstyle|proportional|tabular)-nums|(diagonal|stacked)-fractions)", ({ 1: e3, 2: t2 = "", 3: a3 }) => t2 == "normal" ? { fontVariantNumeric: "normal" } : { ["--tw-" + (a3 ? "numeric-fraction" : "pt".includes(t2[0]) ? "numeric-spacing" : t2 ? "numeric-figure" : e3)]: e3, fontVariantNumeric: "var(--tw-ordinal) var(--tw-slashed-zero) var(--tw-numeric-figure) var(--tw-numeric-spacing) var(--tw-numeric-fraction)", ...b3({ "--tw-ordinal": "var(--tw-empty,/*!*/ /*!*/)", "--tw-slashed-zero": "var(--tw-empty,/*!*/ /*!*/)", "--tw-numeric-figure": "var(--tw-empty,/*!*/ /*!*/)", "--tw-numeric-spacing": "var(--tw-empty,/*!*/ /*!*/)", "--tw-numeric-fraction": "var(--tw-empty,/*!*/ /*!*/)" }) }), gt("tracking-", "letterSpacing"), gt("leading-", "lineHeight"), yt("list-(inside|outside)", "listStylePosition"), gt("list-", "listStyleType"), yt("list-", "listStyleType"), gt("placeholder-opacity-", "placeholderOpacity", ({ _: e3 }) => ({ "&::placeholder": { "--tw-placeholder-opacity": e3 } })), mt("placeholder-", { property: "color", selector: "&::placeholder" }), yt("text-(left|center|right|justify|start|end)", "textAlign"), yt("text-(ellipsis|clip)", "textOverflow"), gt("text-opacity-", "textOpacity", "--tw-text-opacity"), mt("text-", { property: "color" }), gt("text-", "fontSize", ({ _: e3 }) => typeof e3 == "string" ? { fontSize: e3 } : { fontSize: e3[0], ...typeof e3[1] == "string" ? { lineHeight: e3[1] } : e3[1] }), gt("indent-", "textIndent"), yt("(overline|underline|line-through)", "textDecorationLine"), yt("no-underline", { textDecorationLine: "none" }), gt("underline-offset-", "textUnderlineOffset"), mt("decoration-", { section: "textDecorationColor", opacityVariable: !1, opacitySection: "opacity" }), gt("decoration-", "textDecorationThickness"), yt("decoration-", "textDecorationStyle"), yt("(uppercase|lowercase|capitalize)", "textTransform"), yt("normal-case", { textTransform: "none" }), yt("truncate", { overflow: "hidden", whiteSpace: "nowrap", textOverflow: "ellipsis" }), yt("align-", "verticalAlign"), yt("whitespace-", "whiteSpace"), yt("break-normal", { wordBreak: "normal", overflowWrap: "normal" }), yt("break-words", { overflowWrap: "break-word" }), yt("break-all", { wordBreak: "break-all" }), yt("break-keep", { wordBreak: "keep-all" }), mt("caret-", { opacityVariable: !1, opacitySection: "opacity" }), mt("accent-", { opacityVariable: !1, opacitySection: "opacity" }), yt("bg-gradient-to-([trbl]|[tb][rl])", "backgroundImage", ({ 1: e3 }) => `linear-gradient(to ${u2(e3, " ")},var(--tw-gradient-stops))`), mt("from-", { section: "gradientColorStops", opacityVariable: !1, opacitySection: "opacity" }, ({ _: e3 }) => ({ "--tw-gradient-from": e3.value, "--tw-gradient-to": e3.color({ opacityValue: "0" }), "--tw-gradient-stops": "var(--tw-gradient-from),var(--tw-gradient-to)" })), mt("via-", { section: "gradientColorStops", opacityVariable: !1, opacitySection: "opacity" }, ({ _: e3 }) => ({ "--tw-gradient-to": e3.color({ opacityValue: "0" }), "--tw-gradient-stops": `var(--tw-gradient-from),${e3.value},var(--tw-gradient-to)` })), mt("to-", { section: "gradientColorStops", property: "--tw-gradient-to", opacityVariable: !1, opacitySection: "opacity" }), yt("bg-(fixed|local|scroll)", "backgroundAttachment"), yt("bg-origin-(border|padding|content)", "backgroundOrigin", ({ 1: e3 }) => e3 + "-box"), yt(["bg-(no-repeat|repeat(-[xy])?)", "bg-repeat-(round|space)"], "backgroundRepeat"), yt("bg-blend-", "backgroundBlendMode"), yt("bg-clip-(border|padding|content|text)", "backgroundClip", ({ 1: e3 }) => e3 + (e3 == "text" ? "" : "-box")), gt("bg-opacity-", "backgroundOpacity", "--tw-bg-opacity"), mt("bg-", { section: "backgroundColor" }), gt("bg-", "backgroundImage"), gt("bg-", "backgroundPosition"), yt("bg-(top|bottom|center|(left|right)(-(top|bottom))?)", "backgroundPosition", v), gt("bg-", "backgroundSize"), gt("rounded(?:$|-)", "borderRadius"), gt("rounded-([trbl]|[tb][rl])(?:$|-)", "borderRadius", ({ 1: e3, _: t2 }) => {
    let a3 = { t: ["tl", "tr"], r: ["tr", "br"], b: ["bl", "br"], l: ["bl", "tl"] }[e3] || [e3, e3];
    return { [`border-${u2(a3[0])}-radius`]: t2, [`border-${u2(a3[1])}-radius`]: t2 };
  }), yt("border-(collapse|separate)", "borderCollapse"), gt("border-opacity(?:$|-)", "borderOpacity", "--tw-border-opacity"), yt("border-(solid|dashed|dotted|double|none)", "borderStyle"), gt("border-spacing(-[xy])?(?:$|-)", "borderSpacing", ({ 1: e3, _: t2 }) => ({ ...b3({ "--tw-border-spacing-x": "0", "--tw-border-spacing-y": "0" }), ["--tw-border-spacing" + (e3 || "-x")]: t2, ["--tw-border-spacing" + (e3 || "-y")]: t2, "border-spacing": "var(--tw-border-spacing-x) var(--tw-border-spacing-y)" })), mt("border-([xytrbl])-", { section: "borderColor" }, h("border", "Color")), mt("border-"), gt("border-([xytrbl])(?:$|-)", "borderWidth", h("border", "Width")), gt("border(?:$|-)", "borderWidth"), gt("divide-opacity(?:$|-)", "divideOpacity", ({ _: e3 }) => ({ "&>:not([hidden])~:not([hidden])": { "--tw-divide-opacity": e3 } })), yt("divide-(solid|dashed|dotted|double|none)", ({ 1: e3 }) => ({ "&>:not([hidden])~:not([hidden])": { borderStyle: e3 } })), yt("divide-([xy]-reverse)", ({ 1: e3 }) => ({ "&>:not([hidden])~:not([hidden])": { ["--tw-divide-" + e3]: "1" } })), gt("divide-([xy])(?:$|-)", "divideWidth", ({ 1: e3, _: t2 }) => {
    let a3 = { x: "lr", y: "tb" }[e3];
    return { "&>:not([hidden])~:not([hidden])": { [`--tw-divide-${e3}-reverse`]: "0", [`border-${u2(a3[0])}Width`]: `calc(${t2} * calc(1 - var(--tw-divide-${e3}-reverse)))`, [`border-${u2(a3[1])}Width`]: `calc(${t2} * var(--tw-divide-${e3}-reverse))` } };
  }), mt("divide-", { property: "borderColor", selector: "&>:not([hidden])~:not([hidden])" }), gt("ring-opacity(?:$|-)", "ringOpacity", "--tw-ring-opacity"), mt("ring-offset-", { property: "--tw-ring-offset-color", opacityVariable: !1 }), gt("ring-offset(?:$|-)", "ringOffsetWidth", "--tw-ring-offset-width"), yt("ring-inset", { "--tw-ring-inset": "inset" }), mt("ring-", { property: "--tw-ring-color" }), gt("ring(?:$|-)", "ringWidth", ({ _: e3 }, { theme: t2 }) => ({ ...b3({ "--tw-ring-offset-shadow": "0 0 #0000", "--tw-ring-shadow": "0 0 #0000", "--tw-shadow": "0 0 #0000", "--tw-shadow-colored": "0 0 #0000", "&": { "--tw-ring-inset": "var(--tw-empty,/*!*/ /*!*/)", "--tw-ring-offset-width": t2("ringOffsetWidth", "", "0px"), "--tw-ring-offset-color": P3(t2("ringOffsetColor", "", "#fff")), "--tw-ring-color": P3(t2("ringColor", "", "#93c5fd"), { opacityVariable: "--tw-ring-opacity" }), "--tw-ring-opacity": t2("ringOpacity", "", "0.5") } }), "--tw-ring-offset-shadow": "var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color)", "--tw-ring-shadow": `var(--tw-ring-inset) 0 0 0 calc(${e3} + var(--tw-ring-offset-width)) var(--tw-ring-color)`, boxShadow: "var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow)" })), mt("shadow-", { section: "boxShadowColor", opacityVariable: !1, opacitySection: "opacity" }, ({ _: e3 }) => ({ "--tw-shadow-color": e3.value, "--tw-shadow": "var(--tw-shadow-colored)" })), gt("shadow(?:$|-)", "boxShadow", ({ _: e3 }) => ({ ...b3({ "--tw-ring-offset-shadow": "0 0 #0000", "--tw-ring-shadow": "0 0 #0000", "--tw-shadow": "0 0 #0000", "--tw-shadow-colored": "0 0 #0000" }), "--tw-shadow": m2(e3), "--tw-shadow-colored": m2(e3).replace(/([^,]\s+)(?:#[a-f\d]+|(?:(?:hsl|rgb)a?|hwb|lab|lch|color|var)\(.+?\)|[a-z]+)(,|$)/g, "$1var(--tw-shadow-color)$2"), boxShadow: "var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow)" })), gt("(opacity)-"), yt("mix-blend-", "mixBlendMode"), ...$2(), ...$2("backdrop-"), gt("transition(?:$|-)", "transitionProperty", (e3, { theme: t2 }) => ({ transitionProperty: m2(e3), transitionTimingFunction: e3._ == "none" ? void 0 : m2(t2("transitionTimingFunction", "")), transitionDuration: e3._ == "none" ? void 0 : m2(t2("transitionDuration", "")) })), gt("duration(?:$|-)", "transitionDuration", "transitionDuration", m2), gt("ease(?:$|-)", "transitionTimingFunction", "transitionTimingFunction", m2), gt("delay(?:$|-)", "transitionDelay", "transitionDelay", m2), gt("animate(?:$|-)", "animation", (e3, { theme: t2, h: a3, e: n2 }) => {
    let l2 = m2(e3), c3 = l2.split(" "), g5 = t2("keyframes", c3[0]);
    return g5 ? { ["@keyframes " + (c3[0] = n2(a3(c3[0])))]: g5, animation: c3.join(" ") } : { animation: l2 };
  }), "(transform)-(none)", yt("transform", F4), yt("transform-(cpu|gpu)", ({ 1: e3 }) => ({ "--tw-transform": U2(e3 == "gpu") })), gt("scale(-[xy])?-", "scale", ({ 1: e3, _: t2 }) => ({ ["--tw-scale" + (e3 || "-x")]: t2, ["--tw-scale" + (e3 || "-y")]: t2, ...F4() })), gt("-?(rotate)-", "rotate", C3), gt("-?(translate-[xy])-", "translate", C3), gt("-?(skew-[xy])-", "skew", C3), yt("origin-(center|((top|bottom)(-(left|right))?)|left|right)", "transformOrigin", v), "(appearance)-", gt("(columns)-"), "(columns)-(\\d+)", "(break-(?:before|after|inside))-", gt("(cursor)-"), "(cursor)-", yt("snap-(none)", "scroll-snap-type"), yt("snap-(x|y|both)", ({ 1: e3 }) => ({ ...b3({ "--tw-scroll-snap-strictness": "proximity" }), "scroll-snap-type": e3 + " var(--tw-scroll-snap-strictness)" })), yt("snap-(mandatory|proximity)", "--tw-scroll-snap-strictness"), yt("snap-(?:(start|end|center)|align-(none))", "scroll-snap-align"), yt("snap-(normal|always)", "scroll-snap-stop"), yt("scroll-(auto|smooth)", "scroll-behavior"), gt("scroll-p([xytrbl])?(?:$|-)", "padding", h("scroll-padding")), gt("-?scroll-m([xytrbl])?(?:$|-)", "scroll-margin", h("scroll-margin")), yt("touch-(auto|none|manipulation)", "touch-action"), yt("touch-(pinch-zoom|pan-(?:(x|left|right)|(y|up|down)))", ({ 1: e3, 2: t2, 3: a3 }) => ({ ...b3({ "--tw-pan-x": "var(--tw-empty,/*!*/ /*!*/)", "--tw-pan-y": "var(--tw-empty,/*!*/ /*!*/)", "--tw-pinch-zoom": "var(--tw-empty,/*!*/ /*!*/)", "--tw-touch-action": "var(--tw-pan-x) var(--tw-pan-y) var(--tw-pinch-zoom)" }), [`--tw-${t2 ? "pan-x" : a3 ? "pan-y" : e3}`]: e3, "touch-action": "var(--tw-touch-action)" })), yt("outline-none", { outline: "2px solid transparent", "outline-offset": "2px" }), yt("outline", { outlineStyle: "solid" }), yt("outline-(dashed|dotted|double)", "outlineStyle"), gt("-?(outline-offset)-"), mt("outline-", { opacityVariable: !1, opacitySection: "opacity" }), gt("outline-", "outlineWidth"), "(pointer-events)-", gt("(will-change)-"), "(will-change)-", ["resize(?:-(none|x|y))?", "resize", ({ 1: e3 }) => ({ x: "horizontal", y: "vertical" })[e3] || e3 || "both"], yt("select-(none|text|all|auto)", "userSelect"), mt("fill-", { section: "fill", opacityVariable: !1, opacitySection: "opacity" }), mt("stroke-", { section: "stroke", opacityVariable: !1, opacitySection: "opacity" }), gt("stroke-", "strokeWidth"), yt("sr-only", { position: "absolute", width: "1px", height: "1px", padding: "0", margin: "-1px", overflow: "hidden", whiteSpace: "nowrap", clip: "rect(0,0,0,0)", borderWidth: "0" }), yt("not-sr-only", { position: "static", width: "auto", height: "auto", padding: "0", margin: "0", overflow: "visible", whiteSpace: "normal", clip: "auto" })];
  function v(e3) {
    return (typeof e3 == "string" ? e3 : e3[1]).replace(/-/g, " ").trim();
  }
  function A2(e3) {
    return (typeof e3 == "string" ? e3 : e3[1]).replace("col", "column");
  }
  function u2(e3, t2 = "-") {
    let a3 = [];
    for (let n2 of e3)
      a3.push({ t: "top", r: "right", b: "bottom", l: "left" }[n2]);
    return a3.join(t2);
  }
  function m2(e3) {
    return e3 && "" + (e3._ || e3);
  }
  function O2({ $$: e3 }) {
    return ({ r: "flex-", "": "flex-", w: "space-", u: "space-", n: "space-" }[e3[3] || ""] || "") + e3;
  }
  function h(e3, t2 = "") {
    return ({ 1: a3, _: n2 }) => {
      let l2 = { x: "lr", y: "tb" }[a3] || a3 + a3;
      return l2 ? { ...He(e3 + "-" + u2(l2[0]) + t2, n2), ...He(e3 + "-" + u2(l2[1]) + t2, n2) } : He(e3 + t2, n2);
    };
  }
  function $2(e3 = "") {
    let t2 = ["blur", "brightness", "contrast", "grayscale", "hue-rotate", "invert", e3 && "opacity", "saturate", "sepia", !e3 && "drop-shadow"].filter(Boolean), a3 = {};
    for (let n2 of t2)
      a3[`--tw-${e3}${n2}`] = "var(--tw-empty,/*!*/ /*!*/)";
    return a3 = { ...b3(a3), [`${e3}filter`]: t2.map((n2) => `var(--tw-${e3}${n2})`).join(" ") }, [`(${e3}filter)-(none)`, yt(`${e3}filter`, a3), ...t2.map((n2) => gt(`${n2[0] == "h" ? "-?" : ""}(${e3}${n2})(?:$|-)`, n2, ({ 1: l2, _: c3 }) => ({ [`--tw-${l2}`]: b2(c3).map((g5) => `${n2}(${g5})`).join(" "), ...a3 })))];
  }
  function C3({ 1: e3, _: t2 }) {
    return { ["--tw-" + e3]: t2, ...F4() };
  }
  function F4() {
    return { ...b3({ "--tw-translate-x": "0", "--tw-translate-y": "0", "--tw-rotate": "0", "--tw-skew-x": "0", "--tw-skew-y": "0", "--tw-scale-x": "1", "--tw-scale-y": "1", "--tw-transform": U2() }), transform: "var(--tw-transform)" };
  }
  function U2(e3) {
    return [e3 ? "translate3d(var(--tw-translate-x),var(--tw-translate-y),0)" : "translateX(var(--tw-translate-x)) translateY(var(--tw-translate-y))", "rotate(var(--tw-rotate))", "skewX(var(--tw-skew-x))", "skewY(var(--tw-skew-y))", "scaleX(var(--tw-scale-x))", "scaleY(var(--tw-scale-y))"].join(" ");
  }
  function E({ 1: e3, 2: t2 }) {
    return `${e3} ${t2} / ${e3} ${t2}`;
  }
  function R3({ 1: e3 }) {
    return `repeat(${e3},minmax(0,1fr))`;
  }
  function b3(e3) {
    return { "@layer defaults": { "*,::before,::after": e3, "::backdrop": e3 } };
  }

  // https://esm.sh/v119/file-saver@2.0.5/deno/file-saver.mjs
  var __global$ = globalThis || (typeof window < "u" ? window : self), O3 = Object.create, y2 = Object.defineProperty, T4 = Object.getOwnPropertyDescriptor, U3 = Object.getOwnPropertyNames, _ = Object.getPrototypeOf, M3 = Object.prototype.hasOwnProperty, S4 = (a3, n2) => () => (n2 || a3((n2 = { exports: {} }).exports, n2), n2.exports), k2 = (a3, n2) => {
    for (var r in n2)
      y2(a3, r, { get: n2[r], enumerable: !0 });
  }, m3 = (a3, n2, r, l2) => {
    if (n2 && typeof n2 == "object" || typeof n2 == "function")
      for (let i3 of U3(n2))
        !M3.call(a3, i3) && i3 !== r && y2(a3, i3, { get: () => n2[i3], enumerable: !(l2 = T4(n2, i3)) || l2.enumerable });
    return a3;
  }, f3 = (a3, n2, r) => (m3(a3, n2, "default"), r && m3(r, n2, "default")), A3 = (a3, n2, r) => (r = a3 != null ? O3(_(a3)) : {}, m3(n2 || !a3 || !a3.__esModule ? y2(r, "default", { value: a3, enumerable: !0 }) : r, a3)), b4 = S4((h3, E4) => {
    (function(a3, n2) {
      typeof define == "function" && define.amd ? define([], n2) : typeof h3 < "u" ? n2() : (n2(), a3.FileSaver = {});
    })(h3, function() {
      "use strict";
      function a3(e3, t2) {
        return typeof t2 > "u" ? t2 = { autoBom: !1 } : typeof t2 != "object" && (t2 = { autoBom: !t2 }), t2.autoBom && /^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(e3.type) ? new Blob(["\uFEFF", e3], { type: e3.type }) : e3;
      }
      function n2(e3, t2, c3) {
        var o3 = new XMLHttpRequest();
        o3.open("GET", e3), o3.responseType = "blob", o3.onload = function() {
          p4(o3.response, t2, c3);
        }, o3.onerror = function() {
        }, o3.send();
      }
      function r(e3) {
        var t2 = new XMLHttpRequest();
        t2.open("HEAD", e3, !1);
        try {
          t2.send();
        } catch {
        }
        return 200 <= t2.status && 299 >= t2.status;
      }
      function l2(e3) {
        try {
          e3.dispatchEvent(new MouseEvent("click"));
        } catch {
          var t2 = document.createEvent("MouseEvents");
          t2.initMouseEvent("click", !0, !0, window, 0, 0, 0, 80, 20, !1, !1, !1, !1, 0, null), e3.dispatchEvent(t2);
        }
      }
      var i3 = typeof window == "object" && window.window === window ? window : typeof self == "object" && self.self === self ? self : typeof __global$ == "object" && __global$.global === __global$ ? __global$ : void 0, L6 = i3.navigator && /Macintosh/.test(navigator.userAgent) && /AppleWebKit/.test(navigator.userAgent) && !/Safari/.test(navigator.userAgent), p4 = i3.saveAs || (typeof window != "object" || window !== i3 ? function() {
      } : "download" in HTMLAnchorElement.prototype && !L6 ? function(e3, t2, c3) {
        var o3 = i3.URL || i3.webkitURL, s5 = document.createElement("a");
        t2 = t2 || e3.name || "download", s5.download = t2, s5.rel = "noopener", typeof e3 == "string" ? (s5.href = e3, s5.origin === location.origin ? l2(s5) : r(s5.href) ? n2(e3, t2, c3) : l2(s5, s5.target = "_blank")) : (s5.href = o3.createObjectURL(e3), setTimeout(function() {
          o3.revokeObjectURL(s5.href);
        }, 4e4), setTimeout(function() {
          l2(s5);
        }, 0));
      } : "msSaveOrOpenBlob" in navigator ? function(e3, t2, c3) {
        if (t2 = t2 || e3.name || "download", typeof e3 != "string")
          navigator.msSaveOrOpenBlob(a3(e3, c3), t2);
        else if (r(e3))
          n2(e3, t2, c3);
        else {
          var o3 = document.createElement("a");
          o3.href = e3, o3.target = "_blank", setTimeout(function() {
            l2(o3);
          });
        }
      } : function(e3, t2, c3, o3) {
        if (o3 = o3 || open("", "_blank"), o3 && (o3.document.title = o3.document.body.innerText = "downloading..."), typeof e3 == "string")
          return n2(e3, t2, c3);
        var s5 = e3.type === "application/octet-stream", x2 = /constructor/i.test(i3.HTMLElement) || i3.safari, R6 = /CriOS\/[\d]+/.test(navigator.userAgent);
        if ((R6 || s5 && x2 || L6) && typeof FileReader < "u") {
          var v5 = new FileReader();
          v5.onloadend = function() {
            var u4 = v5.result;
            u4 = R6 ? u4 : u4.replace(/^data:[^;]*;/, "data:attachment/file;"), o3 ? o3.location.href = u4 : location = u4, o3 = null;
          }, v5.readAsDataURL(e3);
        } else {
          var j4 = i3.URL || i3.webkitURL, w4 = j4.createObjectURL(e3);
          o3 ? o3.location = w4 : location.href = w4, o3 = null, setTimeout(function() {
            j4.revokeObjectURL(w4);
          }, 4e4);
        }
      });
      i3.saveAs = p4.saveAs = p4, typeof E4 < "u" && (E4.exports = p4);
    });
  }), d4 = {};
  k2(d4, { default: () => H3 });
  var B4 = A3(b4());
  f3(d4, A3(b4()));
  var { default: g2, ...F5 } = B4, H3 = g2 !== void 0 ? g2 : F5;

  // locales/zh-CN.json
  var zh_CN_default = {
    lineBreakMaxTextCount: "\u6362\u884C\u540E\uFF0C\u6BCF\u53E5\u8BDD\u5141\u8BB8\u7684\u6700\u5927\u5B57\u7B26\u6570\u91CF",
    "translate-pdf": "\u70B9\u51FB\u7FFB\u8BD1 PDF",
    "noSupportTranslate-pdf": "\u811A\u672C\u4E0D\u652F\u6301\u8BF7\u4F7F\u7528\u63D2\u4EF6",
    "translate-firefox-local-pdf": "\u70B9\u51FB\u53BB\u4E0A\u4F20PDF",
    enableLineBreak: "\u5F00\u542F\u957F\u6BB5\u843D\u81EA\u52A8\u6362\u884C",
    sponsorLabel: "$1 \u8D77\u8D5E\u52A9\u5F00\u53D1\u8005",
    help: "\u5E2E\u52A9",
    browserShortcutsNoteForFirefox: "Firefox \u6D4F\u89C8\u5668\u4FEE\u6539\u5FEB\u6377\u952E\u9700\u8981\u6253\u5F00\u6269\u5C55\u7BA1\u7406\u9875\u9762 `about:addons`\uFF0C\u7136\u540E\u70B9\u51FB\u300C\u8BBE\u7F6E\u300D\uFF0C\u518D\u70B9\u51FB\u300C\u7BA1\u7406\u5FEB\u6377\u952E\u300D\u5373\u53EF\u8BBE\u7F6E",
    browserShortcutsNoteForChrome: "\u7C7BChrome \u6D4F\u89C8\u5668\u4FEE\u6539\u5FEB\u6377\u952E\u9700\u8981\u6253\u5F00\u6269\u5C55\u7BA1\u7406\u9875\u9762\uFF0C\u5728`\u7BA1\u7406\u5FEB\u6377\u952E`\u9762\u677F(`chrome://extensions/shortcuts`)\u8BBE\u7F6E\uFF0C\u70B9\u51FB\u4E0B\u65B9\u6309\u94AE\u8DF3\u8F6C\u5230\u5FEB\u6377\u952E\u7BA1\u7406\u9875\u9762\u3002",
    browserShortcutsSucks: "\u81EA\u5B9A\u4E49\u5FEB\u6377\u952E\u683C\u5F0F\u4E3A\uFF1A",
    enableLineBreakDescription: "\u5F00\u542F\u540E\uFF0C\u5C06\u4F1A\u5728\u957F\u6BB5\u843D\u4E2D\u6BCF\u53E5\u8BDD\u7ED3\u675F\u63D2\u5165\u6362\u884C\u7B26\uFF0C\u4EE5\u4FBF\u4E8E\u9605\u8BFB",
    "browser.brandName": "\u6C89\u6D78\u5F0F\u7FFB\u8BD1",
    "browser.brandDescription": "\u6C89\u6D78\u5F0F\u7F51\u9875\u53CC\u8BED\u7FFB\u8BD1\u6269\u5C55\uFF0C\u514D\u8D39\u4F7F\u7528\uFF0C\u652F\u6301 Deepl/Google/\u6709\u9053/\u817E\u8BAF\u7FFB\u8BD1\u7B49\u591A\u4E2A\u7FFB\u8BD1\u670D\u52A1\uFF0C\u652F\u6301 Firefox/Chrome/\u6CB9\u7334\u811A\u672C\uFF0C\u4EA6\u53EF\u5728 iOS Safari \u4E0A\u4F7F\u7528\u3002",
    "browser.toggleTranslatePage": "\u7FFB\u8BD1\u7F51\u9875/\u663E\u793A\u539F\u6587",
    "browser.toggleTranslateTheWholePage": "\u7FFB\u8BD1\u9875\u9762\u5168\u90E8\u533A\u57DF/\u663E\u793A\u539F\u6587",
    "browser.toggleTranslateToThePageEndImmediately": "\u7ACB\u5373\u7FFB\u8BD1\u5230\u9875\u9762\u5E95\u90E8/\u663E\u793A\u539F\u6587",
    "browser.toggleTranslateTheMainPage": "\u7FFB\u8BD1\u9875\u9762\u4E3B\u8981\u533A\u57DF/\u663E\u793A\u539F\u6587",
    "browser.openOptionsPage": "\u6253\u5F00\u8BBE\u7F6E\u9875",
    "browser.toggleTranslationMask": "\u663E\u793A/\u9690\u85CF\u8BD1\u6587\u6A21\u7CCA\u6548\u679C",
    "browser.translateLocalPdfFile": "\u7FFB\u8BD1\u672C\u5730 PDF \u6587\u4EF6",
    "browser.openEbookViewer": "\u9605\u8BFB\u672C\u5730\u7535\u5B50\u4E66",
    "browser.openEbookBuilder": "\u5236\u4F5C\u53CC\u8BED Epub \u7535\u5B50\u4E66",
    "browser.translateLocalHtmlFile": "\u7FFB\u8BD1 HTML/txt \u6587\u4EF6",
    "browser.donateContext": "\u4E86\u89E3\u8D5E\u52A9\u798F\u5229",
    "browser.translateLocalSubtitleFile": "\u7FFB\u8BD1\u672C\u5730\u5B57\u5E55\u6587\u4EF6",
    confirmResetConfig: "\u4F60\u786E\u5B9A\u8981\u91CD\u7F6E\u8BBE\u7F6E\u5417\uFF1F",
    translationLineBreakSettingTitle: "\u8BD1\u6587\u6362\u884C\u8BBE\u7F6E",
    smartLineBreak: "\u667A\u80FD\u6362\u884C",
    alwaysLineBreak: "\u603B\u662F\u6362\u884C",
    isShowContextMenu: "\u5C06\u7FFB\u8BD1\u7F51\u9875\u52A0\u5165\u53F3\u952E\u83DC\u5355\u9879",
    toggleBeta: "\u5F00\u542F Beta \u6D4B\u8BD5\u7279\u6027",
    betaDescription: "\u542F\u7528\u4ECD\u5728\u5B9E\u9A8C\u6027\u7684\u529F\u80FD\uFF0C\u4EE5\u53CA\u6D4B\u8BD5\u4E2D\u7684\u7FFB\u8BD1\u670D\u52A1\u3002\u52A0\u5165 <1>Telegram \u7FA4\u7EC4</1>\u4E86\u89E3\u66F4\u591A\u3002",
    translationLineBreakSettingDescription: "\u603B\u662F\u6362\u884C\u9002\u7528\u4E8E\u8F83\u5C11\u5185\u5BB9\u7684\u7248\u9762\uFF0C\u66F4\u6574\u9F50\u3002\uFF08\u5728\u5185\u5BB9\u8F83\u591A\u7684\u957F\u6BB5\u843D(\u8D85\u8FC7{count}\u4E2A\u5B57\u7B26) \u4F7F\u7528\u667A\u80FD\u6362\u884C\uFF0C\u66F4\u7701\u7A7A\u95F4\uFF09",
    tempTranslateDomainTitle: "\u4E34\u65F6\u5F00\u542F\u7F51\u7AD9\u7FFB\u8BD1\u7684\u65F6\u957F",
    tempTranslateDomainDescription: "\u5F53\u624B\u52A8\u7FFB\u8BD1\u67D0\u4E2A\u7F51\u9875\u7684\u65F6\u5019\uFF0C\u4E34\u65F6\u5F00\u542F\u8BE5\u7F51\u7AD9\u4E3A\u81EA\u52A8\u7FFB\u8BD1\uFF0C\u53EF\u8BBE\u7F6E\u4E34\u65F6\u65F6\u957F",
    xMinutes: "{count} \u5206\u949F",
    disabled: "\u7981\u7528",
    changelog: "\u66F4\u65B0\u65E5\u5FD7",
    toggleTranslatePageWhenThreeFingersOnTheScreen: "\u591A\u6307\u540C\u65F6\u89E6\u6478\u5C4F\u5E55\u5219\u7FFB\u8BD1\u7F51\u9875/\u663E\u793A\u539F\u6587",
    toggleTranslationMaskWhenThreeFingersOnTheScreen: "\u591A\u6307\u540C\u65F6\u89E6\u6478\u5219\u663E\u793A/\u9690\u85CF\u8BD1\u6587\u6A21\u7CCA\u6548\u679C",
    addUrlDescription: "\u53EF\u4EE5\u4E3A\u57DF\u540D\uFF0C\u540C\u65F6\u652F\u6301\u901A\u914D\u7B26\uFF0C\u5982\uFF1A*.google.com, google.com/mail/*, https://www.google.com/*",
    general: "\u57FA\u672C\u8BBE\u7F6E",
    clickToExpandConfig: "\u5C55\u5F00\u5F53\u524D\u914D\u7F6E",
    import: "\u4ECE\u6587\u4EF6\u5BFC\u5165",
    export: "\u5BFC\u51FA\u5230\u6587\u4EF6",
    toggleDebug: "\u5728\u63A7\u5236\u53F0\u6253\u5370\u8C03\u8BD5\u65E5\u5FD7",
    "fingers.0": "\u5173\u95ED",
    "fingers.2": "\u53CC\u6307\u89E6\u6478",
    "fingers.3": "\u4E09\u6307\u89E6\u6478",
    "fingers.4": "\u56DB\u6307\u89E6\u6478",
    "fingers.5": "\u4E94\u6307\u89E6\u6478",
    mouseHoldKey: "+ {key} \u7FFB\u8BD1\u8BE5\u6BB5",
    mouseHoldKeyAuto: "\u76F4\u63A5\u7FFB\u8BD1\u8BE5\u6BB5",
    mouseHoldKeyOff: "\u4E0D\u505A\u4EFB\u4F55\u4E8B\u60C5",
    mouseHoldKeyOther: "\u81EA\u5B9A\u4E49\u5FEB\u6377\u952E(\u6253\u5F00\u8BBE\u7F6E)",
    mouseHoldKeyCustomKey: "{key} \u7FFB\u8BD1\u8BE5\u6BB5",
    mouseHoverHoldKey: "\u9F20\u6807\u6ED1\u8FC7\u540C\u65F6\u6309\u4E0B X \u952E\u7FFB\u8BD1\u6BB5\u843D",
    "mouse-translate": "\u5F53\u9F20\u6807\u6ED1\u8FC7",
    document: "\u6587\u6863",
    resetSuccess: "\u91CD\u7F6E\u6240\u6709\u8BBE\u7F6E\u6210\u529F",
    resetThisSuccess: "\u91CD\u7F6E\u6210\u529F",
    saved: "\u4FDD\u5B58\u6210\u529F",
    successImportConfig: "\u6210\u529F\u5BFC\u5165\u914D\u7F6E",
    goAdvancedSettings: "\u53BB\u8FDB\u9636\u8BBE\u7F6E\u9875",
    goAdvancedInterfaceSettings: "\u53BB\u9AD8\u7EA7\u81EA\u5B9A\u4E49\u8BBE\u7F6E\u9875\u9762",
    advanced: "\u8FDB\u9636\u8BBE\u7F6E",
    advancedDescription: "\u4E00\u822C\u65E0\u9700\u8BBE\u7F6E\uFF0C\u4FDD\u6301\u9ED8\u8BA4\u5373\u53EF\u3002\u4EC5\u5BF9\u4E8E\u66F4\u4E13\u4E1A\u7684\u7528\u6237\uFF0C\u63D0\u4F9B\u66F4\u4E2A\u6027\u5316\u7684\u8BBE\u7F6E\u9879\u3002",
    developer: "\u5F00\u53D1\u8005\u8BBE\u7F6E",
    donateCafe: "\u4EF7\u683C",
    "translate to the bottom of the page": "\u8FDB\u5165\u7F51\u9875\u540E\uFF0C\u662F\u5426\u7ACB\u5373\u7FFB\u8BD1\u5230\u9875\u9762\u5E95\u90E8\uFF1F",
    feedback: "\u95EE\u9898\u53CD\u9988",
    toggleTranslatePage: "\u7FFB\u8BD1\u7F51\u9875/\u663E\u793A\u539F\u6587",
    translateToThePageEndImmediatelyDescription: "\u5F00\u542F\u540E\uFF0C\u8FDB\u5165\u7F51\u9875\u5C06\u7ACB\u5373\u7FFB\u8BD1\u4ECE\u9876\u90E8\u5230\u5E95\u90E8\u7684\u5185\u5BB9\u3002\u5173\u95ED\u5219\u8FB9\u770B\u8FB9\u8BD1\u3002\uFF08\u4E0D\u63A8\u8350\u5F00\u542F\uFF09",
    "translate all areas of the page": "\u662F\u5426\u7FFB\u8BD1\u7F51\u9875\u6240\u6709\u533A\u57DF",
    translationAreaDescription: "\u5F00\u542F\u540E\uFF0C\u6574\u4E2A\u7F51\u9875\u7684\u6240\u6709\u533A\u57DF\u90FD\u4F1A\u88AB\u7FFB\u8BD1\u3002\u5173\u95ED\u5219\u4F7F\u7528\u9ED8\u8BA4\u7684\u667A\u80FD\u8BC6\u522B\uFF0C\u4EC5\u7FFB\u8BD1\u4E3B\u8981\u533A\u57DF\u3002\uFF08\u4E0D\u63A8\u8350\u5F00\u542F\uFF09",
    "the number of characters to be translated first": "\u76F4\u63A5\u7FFB\u8BD1\u9875\u9762\u524D\u591A\u5C11\u4E2A\u5B57\u7B26\uFF0C\u800C\u65E0\u9700\u7B49\u5F85\u6EDA\u52A8\u5230\u53EF\u89C6\u533A\u57DF",
    "interface language": "\u754C\u9762\u8BED\u8A00",
    "display both the original text and the translation": "\u540C\u65F6\u663E\u793A\u539F\u6587\u548C\u8BD1\u6587",
    "keyboard shortcuts": "\u952E\u76D8\u5FEB\u6377\u952E",
    modify: "\u4FEE\u6539\u5FEB\u6377\u952E",
    reset: "\u91CD\u7F6E",
    close: "\u5173\u95ED",
    homepage: "\u4E3B\u9875",
    more: "\u66F4\u591A",
    moreOptions: "\u5C55\u5F00\u66F4\u591A\u81EA\u5B9A\u4E49\u9009\u9879",
    translateTheWholePage: "\u7FFB\u8BD1\u9875\u9762\u5168\u90E8\u533A\u57DF\uFF08\u533A\u522B\u4E8E\u667A\u80FD\u8BC6\u522B\u4E3B\u8981\u533A\u57DF\uFF09",
    changeToTranslateTheWholePage: "\u5207\u6362\u4E3A\u7FFB\u8BD1\u6240\u6709\u533A\u57DF",
    changeToTranslateTheMainPage: "\u5207\u6362\u4E3A\u7FFB\u8BD1\u4E3B\u8981\u533A\u57DF",
    translateToThePageEndImmediately: "\u7ACB\u5373\u7FFB\u8BD1\u5230\u9875\u9762\u5E95\u90E8",
    translateTheMainPage: "\u667A\u80FD\u7FFB\u8BD1\u4E3B\u8981\u533A\u57DF",
    "The local rules are up to date": "\u672C\u5730\u9002\u914D\u89C4\u5219\u5DF2\u662F\u6700\u65B0:",
    "Successfully synchronized with the latest official rules:": "\u6210\u529F\u540C\u6B65\u6700\u65B0\u5B98\u65B9\u9002\u914D\u89C4\u5219:",
    "Checking for updates": "\u6B63\u5728\u68C0\u67E5\u66F4\u65B0",
    "Rules are being synchronized": "\u6B63\u5728\u540C\u6B65\u9002\u914D\u89C4\u5219",
    localVersionIsTooOld: "\u672C\u5730\u6269\u5C55\u7248\u672C\u8FC7\u65E7\uFF0C\u8BF7\u5347\u7EA7\u6269\u5C55\u5230 {minVersion} \u6216\u66F4\u65B0\u7684\u7248\u672C\u518D\u5C1D\u8BD5\u540C\u6B65",
    badUserscriptBrowser: "\u5F53\u524D\u6D4F\u89C8\u5668\u6CA1\u6709\u6B63\u786E\u5B9E\u73B0\u6CB9\u7334\u6269\u5C55\u7684\u63A5\u53E3\uFF08\u6BD4\u5982\u83B7\u53D6\u6CB9\u7334\u811A\u672C\u81EA\u8EAB\u7684\u7248\u672C\u53F7\u4FE1\u606F\uFF09\uFF0C\u8BF7\u4F7F\u7528\u5176\u4ED6<1>\u652F\u6301\u6CB9\u7334\u6269\u5C55</1>\u7684\u6D4F\u89C8\u5668\u5982 Firefox",
    foundNewVersion: "\u53D1\u73B0\u65B0\u7248\u672C",
    theLocalExtensionIsUpToUpdate: "\u5F53\u524D\u6269\u5C55\u5DF2\u662F\u6700\u65B0\u7248\u672C\u3002",
    failToSyncRules: "\u540C\u6B65\u6700\u65B0\u9002\u914D\u89C4\u5219\u5931\u8D25",
    retry: "\u70B9\u6B64\u91CD\u8BD5",
    failedReason: "\u5931\u8D25\u539F\u56E0",
    currentRuleVersion: "\u5F53\u524D\u89C4\u5219\u7248\u672C",
    calculating: "\u8BA1\u7B97\u4E2D",
    unknownError: "\u672A\u77E5\u9519\u8BEF",
    canNotFetchRemoteRule: "\u65E0\u6CD5\u83B7\u53D6\u8FDC\u7A0B\u89C4\u5219",
    enableAlphaSuccess: "\u5DF2\u5F00\u542FAlpha\u529F\u80FD",
    disableAlphaSuccess: "\u5DF2\u5173\u95EDAlpha\u529F\u80FD",
    cacheSize: "\u7F13\u5B58\u5927\u5C0F\uFF1A",
    cleaning: "\u6E05\u7406\u4E2D",
    cleanCache: "\u6E05\u9664\u7F13\u5B58",
    options: "\u8BBE\u7F6E",
    about: "\u5173\u4E8E",
    service: "\u7FFB\u8BD1\u670D\u52A1",
    needAction: "(\u53BB\u8BBE\u7F6E)",
    goSettings: "\u53BB\u8BBE\u7F6E",
    needActionForOptions: "(\u9700\u8BBE\u7F6E)",
    translationEngine: "\u5F15\u64CE\u9009\u9879",
    sourceLanguage: "\u539F\u6587\u8BED\u8A00",
    target: "\u76EE\u6807\u8BED\u8A00",
    popupSourceLanguage: "\u539F\u6587\u8BED\u8A00",
    popupTarget: "\u76EE\u6807\u8BED\u8A00",
    popupService: "\u7FFB\u8BD1\u670D\u52A1",
    forThisSite: "\u9488\u5BF9\u8BE5\u7F51\u7AD9\uFF1A",
    alwaysTranslateSomeLanguage: "\u603B\u662F\u7FFB\u8BD1 {language}",
    neverTranslateSomeLanguage: "\u6C38\u4E0D\u7FFB\u8BD1 {language}",
    alwaysTranslateSomeSite: "\u603B\u662F\u7FFB\u8BD1 {hostname}",
    neverTranslateSomeSite: "\u6C38\u4E0D\u7FFB\u8BD1 {hostname}",
    add: "\u6DFB\u52A0",
    default: "\u9ED8\u8BA4",
    forThisLanguage: "\u9488\u5BF9\u8BE5\u8BED\u8A00\uFF1A",
    "add url": "\u8F93\u5165URL",
    edit: "\u7F16\u8F91",
    "translate other languages into specific language": "\u5C06\u5176\u4ED6\u8BED\u8A00\u7FFB\u8BD1\u4E3A\u4F60\u8BBE\u7F6E\u7684\u8BED\u8A00",
    "select translation service": "\u9009\u62E9\u4E00\u9879\u7FFB\u8BD1\u670D\u52A1",
    language: "\u8BED\u8A00",
    "show-original": "\u663E\u793A\u539F\u6587",
    translate: "\u7FFB\u8BD1",
    Translated: "\u5DF2\u7FFB\u8BD1",
    Translating: "\u7FFB\u8BD1\u4E2D",
    Error: "\u9519\u8BEF",
    allowCacheTranslations: "\u5F00\u542F\u672C\u5730\u7FFB\u8BD1\u7F13\u5B58\uFF08\u51CF\u5C11\u91CD\u590D\u6BB5\u843D\u7684\u7FFB\u8BD1\u8BF7\u6C42\uFF09",
    "translation display": "\u8BD1\u6587\u663E\u793A\u6837\u5F0F",
    "select diplay style": "\u533A\u5206\u8BD1\u6587\u7684\u6837\u5F0F\uFF0C\u5177\u4F53\u53EF\u53C2\u8003\u4E0B\u5217\u793A\u4F8B",
    interface: "\u754C\u9762\u8BBE\u7F6E",
    import_export: "\u5BFC\u5165/\u5BFC\u51FA",
    import_export_title: "\u5BFC\u5165/\u5BFC\u51FA\u914D\u7F6E",
    syncToGoogleDrive: "\u7ACB\u5373\u4E0E Google Drive \u540C\u6B65",
    previewAllThemes: "\u9884\u89C8\u5168\u90E8\u6837\u5F0F",
    "translationTheme.none": "\u65E0",
    "translationTheme.grey": "\u9ED1\u7070\u8272",
    "translationTheme.dashed": "\u865A\u7EBF\u4E0B\u5212\u7EBF",
    "translationTheme.dotted": "\u70B9\u72B6\u4E0B\u5212\u7EBF",
    "translationTheme.dashedBorder": "\u865A\u7EBF\u8FB9\u6846",
    "translationTheme.solidBorder": "\u5B9E\u7EBF\u8FB9\u6846",
    "translationTheme.underline": "\u76F4\u7EBF\u4E0B\u5212\u7EBF",
    "translationTheme.mask": "\u6A21\u7CCA\u6548\u679C",
    "translationTheme.opacity": "\u900F\u660E\u6548\u679C",
    "translationTheme.paper": "\u767D\u7EB8\u9634\u5F71\u6548\u679C",
    "translationTheme.dividingLine": "\u5206\u5272\u7EBF",
    "translationTheme.highlight": "\u9AD8\u4EAE",
    "translationTheme.marker": "\u9A6C\u514B\u7B14",
    "translationTheme.marker2": "\u9A6C\u514B\u7B142",
    "translationTheme.blockquote": "\u5F15\u7528\u6837\u5F0F",
    "translationTheme.weakening": "\u5F31\u5316",
    "translationTheme.italic": "\u659C\u4F53",
    "translationTheme.bold": "\u52A0\u7C97",
    "translationTheme.thinDashed": "\u7EC6\u865A\u7EBF\u4E0B\u5212\u7EBF",
    "translationTheme.nativeDashed": "\u7CFB\u7EDF\u81EA\u5E26\u865A\u7EBF\u4E0B\u5212\u7EBF",
    "translationTheme.nativeDotted": "\u7CFB\u7EDF\u81EA\u5E26\u70B9\u72B6\u4E0B\u5212\u7EBF",
    "translationTheme.nativeUnderline": "\u7CFB\u7EDF\u81EA\u5E26\u76F4\u7EBF\u4E0B\u5212\u7EBF",
    "translationTheme.wavy": "\u6CE2\u6D6A\u7EBF",
    "translationServices.tencent": "\u817E\u8BAF\u7FFB\u8BD1\u541B",
    "translationServices.tenAlpha": "\u817E\u8BAF\u7FFB\u8BD1\u541B(Alpha)",
    "translationServices.google": "\u8C37\u6B4C\u7FFB\u8BD1",
    "translationServices.bai": "\u767E\u5EA6(Alpha)",
    "translationServices.baidu": "\u767E\u5EA6\u7FFB\u8BD1",
    "translationServices.aliyun": "\u963F\u91CC\u4E91\u7FFB\u8BD1",
    "translationServices.volc": "\u706B\u5C71\u7FFB\u8BD1",
    "translationServices.deeplx": "DeeplX(Beta)",
    "translationServices.bing": "\u5FAE\u8F6F\u7FFB\u8BD1",
    "translationServices.deepl": "Deepl",
    "translationServices.wechat": "\u5FAE\u4FE1\u7FFB\u8BD1",
    "translationServices.azure": "Azure \u7FFB\u8BD1",
    "translationServices.ibm": "IBM Watson",
    "translationServices.aws": "\u4E9A\u9A6C\u900A\u7FFB\u8BD1",
    "translationServices.mock": "\u6A21\u62DF\u7FFB\u8BD1",
    "translationServices.mock2": "\u6A21\u62DF\u7FFB\u8BD12",
    "translationServices.caiyun": "\u5F69\u4E91\u5C0F\u8BD1",
    "translationServices.cai": "\u5F69\u4E91\u5C0F\u8BD1 (Alpha)",
    "translationServices.volcAlpha": "\u706B\u5C71 (Alpha)",
    "translationServices.openl": "OpenL",
    "translationServices.youdao": "\u6709\u9053\u7FFB\u8BD1",
    "translationServices.you": "\u6709\u9053\u7FFB\u8BD1 (Alpha)",
    "translationServices.transmart": "\u817E\u8BAF\u4EA4\u4E92\u7FFB\u8BD1",
    "translationServices.niu": "\u5C0F\u725B\u7FFB\u8BD1",
    "translationServices.papago": "Papago \u7FFB\u8BD1",
    "translationServices.d": "D (Alpha)",
    "translationServices.dpro": "D Pro (Canary)",
    "translationServices.openai": "OpenAI",
    "translationServices.chatgpt": "ChatGPT Plus",
    "translate title": "\u7FFB\u8BD1\u9875\u9762\u6807\u9898",
    "always languages": "\u603B\u662F\u7FFB\u8BD1\u7684\u8BED\u8A00",
    neverTranslateLanguagesLabel: "\u6C38\u4E0D\u7FFB\u8BD1\u7684\u8BED\u8A00",
    neverTranslateTheFollowingLanguagesDescription: "\u5F53\u9875\u9762\u4E2D\u67D0\u4E00\u6BB5\u843D\u7684\u8BED\u8A00\u4E3A\u4E0B\u5217\u8BED\u8A00\u65F6\uFF0C\u5C06\u8DF3\u8FC7\u7FFB\u8BD1",
    enableUserscriptPagePopup: "\u5728\u9875\u9762\u4E0A\u663E\u793A\u60AC\u6D6E\u7403",
    enableUserscriptPagePopupDescription: "\u5173\u95ED\u60AC\u6D6E\u7403\u540E\uFF0C\u53EF\u4EE5\u7528\u5FEB\u6377\u952E/{touch}\u5524\u8D77\u3002\u4E3A\u9632\u6B62\u4E0D\u614E\u5173\u95ED\u8BE5\u9009\u9879\u540E\u627E\u4E0D\u5230\u60AC\u6D6E\u7403\uFF0C\u5F3A\u70C8\u5EFA\u8BAE\u6536\u85CF\u672C\u8BBE\u7F6E\u9875",
    "always translate the following languages": "\u5F53\u9875\u9762\u8BED\u8A00\u4E3A\u4E0B\u5217\u8BED\u8A00\u65F6\uFF0C\u4F1A\u81EA\u52A8\u7FFB\u8BD1\u4E3A\u76EE\u6807\u8BED\u8A00",
    "always sites": "\u603B\u662F\u7FFB\u8BD1\u7684\u7F51\u5740",
    "always translate the following sites": "\u5F53\u7F51\u7AD9\u4E3A\u4E0B\u5217\u57DF\u540D\u65F6\uFF0C\u4F1A\u81EA\u52A8\u7FFB\u8BD1\u4E3A\u76EE\u6807\u8BED\u8A00",
    "never sites": "\u6C38\u4E0D\u7FFB\u8BD1\u7684\u7F51\u5740",
    "never translate the following sites": "\u5F53\u7F51\u7AD9\u4E3A\u4E0B\u5217\u57DF\u540D\u65F6\uFF0C\u5C06\u4E0D\u4F1A\u8FDB\u884C\u7FFB\u8BD1",
    "please refer to": "\u9700\u8981\u586B\u5199\u5BC6\u94A5\u540E\u624D\u53EF\u7528\uFF0C\u8BE6\u60C5\u53C2\u8003",
    KeyAndConfigurationTutorial: "\u300A\u5BC6\u94A5\u7533\u8BF7\u548C\u914D\u7F6E\u6559\u7A0B\u300B",
    useAboveStyleForTheseSites: "\u5F53\u7F51\u7AD9\u4E3A\u4E0B\u5217\u57DF\u540D\u65F6\uFF0C\u603B\u662F\u4F7F\u7528 \u2308{theme}\u230B \u8BD1\u6587\u6837\u5F0F",
    currentUrl: "\u5F53\u524D\u7F51\u5740",
    confirm: "\u4FDD\u5B58",
    cancel: "\u53D6\u6D88",
    delete: "\u5220\u9664",
    "languages.auto": "\u81EA\u52A8\u68C0\u6D4B\u8BED\u8A00",
    syncToCloud: "\u540C\u6B65\u5230\u4E91\u7AEF",
    syncToCloudDescription: "\u4E0A\u4F20\u5230\u4E91\u7AEF\uFF0C\u53EF\u4EE5\u5728\u4E0D\u540C\u7684\u6D4F\u89C8\u5668/\u6CB9\u7334\u811A\u672C\u4E4B\u95F4\u540C\u6B65\u914D\u7F6E\uFF0C\u4EE5\u6700\u540E\u4FEE\u6539\u65F6\u95F4\u4E3A\u51C6\u3002",
    authFail: "\u6388\u6743\u5931\u8D25",
    syncTitle: "\u624B\u52A8\u5907\u4EFD\u7BA1\u7406",
    import_hint: "\u5BFC\u5165",
    upload: "\u4E0A\u4F20",
    revokeAuth: "\u64A4\u9500\u6388\u6743",
    uploadFail: "\u4E0A\u4F20\u5931\u8D25",
    download: "\u4E0B\u8F7D",
    importSuccess: "\u5BFC\u5165\u6210\u529F",
    importFail: "\u5BFC\u5165\u5931\u8D25",
    deleteFail: "\u5220\u9664\u5931\u8D25",
    backupToCloud: "\u624B\u52A8\u7BA1\u7406\u5907\u4EFD\u6587\u4EF6",
    create_new_backup: "\u65B0\u589E\u5907\u4EFD\u8282\u70B9",
    maxBackupFiles: "\u6700\u591A\u53EF\u4EE5\u5907\u4EFD{count}\u4E2A\u4E0D\u540C\u7684\u8282\u70B9, \u8BF7\u5220\u9664\u4E0D\u9700\u8981\u7684\u8282\u70B9",
    backupToCloudDescription: "\u624B\u52A8\u4E0A\u4F20\u6216\u6062\u590D\u5907\u4EFD\u6587\u4EF6\uFF0C\u6700\u591A\u5141\u8BB83\u4E2A\u4E0D\u540C\u7684\u5907\u4EFD",
    successSyncConfig: "\u6210\u529F\u4E0E\u4E91\u7AEF\u4FDD\u6301\u540C\u6B65",
    syncFail: "\u540C\u6B65\u5931\u8D25",
    updatedAt: "\u66F4\u65B0\u4E8E {date}",
    lastSyncedAt: "\u4E0A\u6B21\u68C0\u67E5\u4E8E {date}",
    downloadFail: "\u4E0B\u8F7D\u5931\u8D25",
    clickToDownload: "\u70B9\u51FB\u4E0B\u8F7D",
    aboutLabel: "\u5173\u4E8E - \u53CD\u9988 - \u8D5E\u52A9\u798F\u5229",
    "browser.openAboutPage": "\u5173\u4E8E/\u53CD\u9988",
    aboutLabelWithoutSponsor: "\u5173\u4E8E - \u53CD\u9988",
    aboutIntro: "\u8BE5\u6269\u5C55\u514D\u8D39\u4F7F\u7528\uFF0C\u5E0C\u671B\u6211\u4EEC\u90FD\u80FD\u66F4\u52A0\u5BB9\u6613\u4E14\u6109\u60A6\u5730\u83B7\u53D6\u4E92\u8054\u7F51\u4E0A\u5DE8\u5927\u7684\u5916\u8BED\u4FE1\u606F \u2764\uFE0F <br/><br/>\u611F\u8C22\u8FD9\u4E9B<1>\u8D5E\u52A9\u8005\u4EEC</1>, \u7531\u4E8E\u4ED6/\u5979\u4EEC\u7684\u652F\u6301\uFF0C\u66F4\u591A\u7684\u4EBA\u53EF\u4EE5\u514D\u8D39\u5730\u4F7F\u7528\u8FD9\u4E2A\u5DE5\u5177\u3002<br/><br/>\u514D\u8D39\u5DE5\u5177\u4F5C\u8005\u4F3C\u4E4E\u53EF\u4EE5\u548C\u8D5E\u52A9\u8005\u4E4B\u95F4\u5EFA\u7ACB\u4E00\u79CD\u53CC\u8D62\u7684\u5173\u7CFB\uFF01\u6211\u4E3A\u8D5E\u52A9\u8005\u63D0\u4F9B\u4E86\u4E00\u4E9B\u9650\u65F6\u798F\u5229\uFF0C\u6BD4\u5982<6>DeepL\u7FFB\u8BD1\u670D\u52A1</6>\uFF0C\u4F60\u53EF\u4EE5<2>\u70B9\u51FB\u8FD9\u91CC\u4E86\u89E3\u8D5E\u52A9\u65B9\u6848</2>\uFF0C\u4F60\u8FD8\u53EF\u4EE5\u5173\u6CE8\u6211\u7684<3>\u63A8\u7279</3>\uFF0C<4>Telegram \u9891\u9053</4>\u4EE5\u53CA\u4E0B\u65B9\u7684<5>\u90AE\u4EF6\u8BA2\u9605</5>\u8FFD\u8E2A\u66F4\u65B0\u3002",
    aboutIntroWithoutSponsor: "\u8BE5\u6269\u5C55\u514D\u8D39\u4F7F\u7528\uFF0C\u5E0C\u671B\u6211\u4EEC\u90FD\u80FD\u66F4\u52A0\u5BB9\u6613\u4E14\u6109\u60A6\u5730\u83B7\u53D6\u4E92\u8054\u7F51\u4E0A\u5DE8\u5927\u7684\u5916\u8BED\u4FE1\u606F \u2764\uFE0F ",
    projectHomepage: "\u9879\u76EE\u4E3B\u9875",
    joinTelegramGroup: "\u52A0\u5165 Telegram \u7FA4\u53C2\u4E0E\u529F\u80FD\u8BA8\u8BBA",
    joinTelegramChannel: "\u5173\u6CE8 Telegram \u9891\u9053\u83B7\u53D6\u6700\u65B0\u66F4\u65B0",
    feedbackAndJoin: "\u95EE\u9898\u53CD\u9988/\u52A0\u7FA4",
    autoSync: "\u81EA\u52A8\u5B9A\u65F6\u540C\u6B65",
    loadingThemeTitle: "Loading \u6837\u5F0F",
    loadingThemeDescription: "\u8BBE\u7F6E\u7B49\u5F85\u8BD1\u6587\u52A0\u8F7D\u65F6\u7684\u6837\u5F0F",
    "loadingTheme.spinner": "\u8F6C\u5708\u52A8\u753B",
    "loadingTheme.text": "\u9759\u6001\u6587\u5B57 ... ",
    "loadingTheme.none": "\u4E0D\u663E\u793A",
    developerDescription: "\u53EF\u4EE5\u70B9\u51FB<1>\u8FD9\u91CC</1>\u67E5\u770B\u9AD8\u7EA7\u81EA\u5B9A\u4E49\u76F8\u5173\u7684\u6587\u6863",
    "edit border color": "\u4FEE\u6539\u8FB9\u6846\u989C\u8272",
    successSyncButNoChange: "\u5F53\u524D\u914D\u7F6E\u4E0E\u4E91\u7AEF\u4E00\u81F4",
    customTheme: "\u81EA\u5B9A\u4E49\u989C\u8272\u548C\u5927\u5C0F",
    "customThemeLabel.borderColor": "\u8FB9\u6846\u989C\u8272",
    "customThemeLabel.borderRadius": "\u8FB9\u6846\u5706\u89D2",
    "customThemeLabel.textColor": "\u6587\u5B57\u989C\u8272",
    "customThemeLabel.backgroundColor": "\u80CC\u666F\u989C\u8272",
    "customThemeLabel.zoom": "\u5B57\u4F53\u7F29\u653E\u6BD4\u4F8B (%)",
    resetToDefaultColor: "\u6062\u590D\u4E3A\u9ED8\u8BA4\u989C\u8272",
    resetToDefaultSettings: "\u6062\u590D\u4E3A\u9ED8\u8BA4\u8BBE\u7F6E",
    isTranslateTitle: "\u5F00\u542F\u7FFB\u8BD1\u7F51\u9875\u6807\u9898",
    isTranslateTitleDescription: "\u5F00\u542F\u540E\uFF0C\u7F51\u9875\u6807\u9898\u4F1A\u88AB\u7FFB\u8BD1",
    verifyService: "\u70B9\u6B64\u6D4B\u8BD5\u670D\u52A1",
    verified: "\u9A8C\u8BC1\u6210\u529F",
    "field.model": "\u6A21\u578B",
    "field.translationEngine": "\u7FFB\u8BD1\u5F15\u64CE",
    "field.limitPerMinute": "\u6BCF\u5206\u949F\u6700\u5927\u8BF7\u6C42\u6570",
    "field.limitPerSecond": "\u6BCF\u79D2\u6700\u5927\u8BF7\u6C42\u6570",
    "field.maxTextLengthPerRequest": "\u6BCF\u6B21\u8BF7\u6C42\u6700\u5927\u6587\u672C\u957F\u5EA6",
    "field.maxTextGroupLengthPerRequest": "\u6BCF\u6B21\u8BF7\u6C42\u6700\u5927\u6BB5\u843D\u6570",
    "field.apiUrl": "\u81EA\u5B9A\u4E49 API \u63A5\u53E3\u5730\u5740",
    "description.limitPerMinute": "\u8BF7\u6C42\u6570\u8D85\u8FC7\u8BE5\u9650\u5236\u65F6\u4F1A\u8FDB\u5165\u6392\u961F\u72B6\u6001\uFF0C\u76F4\u5230\u4E0B\u4E00\u5206\u949F\u5F00\u59CB\u3002\u7531\u4E8EOpenAI\u76EE\u524D\u670D\u52A1\u7684\u5404\u79CD\u9650\u5236\uFF0C\u8BF7\u70B9\u51FB<1>\u8FD9\u91CC</1>\u67E5\u770B\u6700\u65B0\u5EFA\u8BAE\u7684\u6570\u503C",
    "description.limitPerSecond": "\u8BF7\u6C42\u6570\u8D85\u8FC7\u8BE5\u9650\u5236\u65F6\u4F1A\u8FDB\u5165\u6392\u961F\u72B6\u6001\uFF0C\u76F4\u5230\u4E0B\u4E00\u79D2\u949F\u5F00\u59CB\u3002\u7531\u4E8EOpenAI\u76EE\u524D\u670D\u52A1\u7684\u5404\u79CD\u9650\u5236\uFF0C\u8BF7\u70B9\u51FB<1>\u8FD9\u91CC</1>\u67E5\u770B\u6700\u65B0\u5EFA\u8BAE\u7684\u6570\u503C",
    "description.prompt": "\u4EE5\u7528\u6237\u8EAB\u4EFD\u53D1\u9001\u7ED9 OpenAI \u7684\u5BF9\u8BDD\uFF0C\u5176\u4E2D {{text}} \u8868\u793A\u6BB5\u843D\u7684\u6587\u672C\u5185\u5BB9\uFF0C{{from}} \u8868\u793A\u6BB5\u843D\u7684\u8BED\u8A00\uFF0C{{to}} \u8868\u793A\u76EE\u6807\u8BED\u8A00,\u53EF\u4EE5\u7701\u7565 {{text}} \uFF08\u63A8\u8350\uFF09, \u5C06\u4F1A\u5728\u5355\u72EC\u4F5C\u4E3A\u4E00\u6BB5\u53D1\u9001\u7ED9 OpenAI",
    "description.maxTextLengthPerRequest": "\u6BCF\u6B21\u8BF7\u6C42\u6700\u5927\u5B57\u7B26\u6570\uFF0C\u592A\u5927\u4F1A\u5BFC\u81F4\u63A5\u53E3\u7684\u54CD\u5E94\u53D8\u6162\uFF0C\u56E0\u6B64\u53EF\u4EE5\u5C1D\u8BD5\u8C03\u6574\u8BE5\u9009\u9879\u6765\u4F18\u5316\u901F\u5EA6",
    "description.systemPrompt": "\u4EE5\u7CFB\u7EDF\u8EAB\u4EFD\u53D1\u9001\u7ED9 OpenAI \u7684\u5BF9\u8BDD\uFF0C\u5176\u4E2D {{text}} \u8868\u793A\u6BB5\u843D\u7684\u6587\u672C\u5185\u5BB9\uFF0C{{from}} \u8868\u793A\u6BB5\u843D\u7684\u8BED\u8A00\uFF0C{{to}} \u8868\u793A\u76EE\u6807\u8BED\u8A00",
    "description.model": "OpenAI \u7684\u6A21\u578B\uFF0C\u53EF\u4EE5\u4E3A gpt-3.5-turbo, gpt-4 \u7B49",
    "description.maxTextGroupLengthPerRequest": "\u6BCF\u6B21\u53D1\u9001\u7ED9 OpenAI \u7684\u6BB5\u843D\u6570\u91CF\uFF0C\u5982\u679C\u6BB5\u843D\u6570\u91CF\u8FC7\u591A\uFF0C\u53EF\u80FD\u4F1A\u5BFC\u81F4\u63A5\u53E3\u7684\u54CD\u5E94\u53D8\u6162\uFF0C\u8BBE\u7F6E\u4E3A 1 \u4E2A\u6BB5\u843D\u65F6\uFF0C\u4F53\u9A8C\u6700\u597D",
    "description.apiUrl": "\u8BF7\u6DFB\u52A0\u5177\u4F53\u5E26\u6709\u8DEF\u5F84\u7684\u7F51\u5740",
    enabledExtension: "\u542F\u7528\u6269\u5C55",
    clickToDisableExtension: "\u70B9\u51FB\u7981\u7528\u6269\u5C55",
    clickToEnableExtension: "\u70B9\u51FB\u542F\u7528\u6269\u5C55",
    hasBeenDisabled: "\u5DF2\u7981\u7528",
    "show password": "\u663E\u793A\u5BC6\u7801",
    customContent: "\u8F93\u5165\u81EA\u5B9A\u4E49\u6A21\u578B\u540D\u79F0"
  };

  // locales/zh-TW.json
  var zh_TW_default = {
    lineBreakMaxTextCount: "\u63DB\u884C\u5F8C\uFF0C\u6BCF\u53E5\u8A71\u5141\u8A31\u7684\u6700\u5927\u5B57\u5143\u6578\u91CF",
    "translate-pdf": "\u9EDE\u9078\u7FFB\u8B6F PDF",
    "translate-firefox-local-pdf": "\u9EDE\u9078\u4E0A\u50B3 PDF",
    enableLineBreak: "\u958B\u555F\u9577\u6BB5\u843D\u81EA\u52D5\u63DB\u884C",
    sponsorLabel: "$1 \u8D77\u8D0A\u52A9\u958B\u767C\u8005 (\u6708\u4ED8\u6216\u50C5\u8D0A\u52A9\u4E00\u6B21\u5747\u53EF)",
    help: "\u8AAA\u660E",
    browserShortcutsNoteForFirefox: "Firefox \u700F\u89BD\u5668\u8B8A\u66F4\u5FEB\u901F\u9375\u9700\u8981\u958B\u555F\u9644\u52A0\u5143\u4EF6\u7BA1\u7406\u9801\u9762 \u300Cabout:addons\u300D\uFF0C\u7136\u5F8C\u9EDE\u9078\u300C\u8A2D\u5B9A\u5716\u793A\u300D\uFF0C\u518D\u9EDE\u9078\u300C\u7BA1\u7406\u64F4\u5145\u5957\u4EF6\u5FEB\u901F\u9375\u300D\u5373\u53EF\u8A2D\u5B9A",
    browserShortcutsNoteForChrome: "Chromium \u6838\u5FC3\u700F\u89BD\u5668\u8B8A\u66F4\u5FEB\u901F\u9375\u9700\u8981\u958B\u555F\u64F4\u5145\u529F\u80FD\u7BA1\u7406\u9801\u9762\uFF0C\u5728\u300C\u9375\u76E4\u5FEB\u901F\u9375\u300D\u9801\u9762(chrome://extensions/shortcuts)\u8A2D\u5B9A\uFF0C\u9EDE\u9078\u4E0B\u65B9\u6309\u9215\u524D\u5F80\u5FEB\u901F\u9375\u7BA1\u7406\u9801\u9762\u3002",
    browserShortcutsSucks: "\u81EA\u5B9A\u4E49\u5FEB\u901F\u9375\u683C\u5F0F\u70BA\uFF1A",
    enableLineBreakDescription: "\u555F\u7528\u5F8C\uFF0C\u5C07\u6703\u5728\u9577\u6BB5\u843D\u4E2D\u6BCF\u53E5\u8A71\u7D50\u675F\u63D2\u5165\u63DB\u884C\u5B57\u5143\uFF0C\u4EE5\u4FBF\u65BC\u95B1\u8B80",
    "browser.brandName": "\u6C89\u6D78\u5F0F\u7FFB\u8B6F",
    "browser.brandDescription": "\u6C89\u6D78\u5F0F\u7DB2\u9801\u96D9\u8A9E\u7FFB\u8B6F\u5957\u4EF6\uFF0C\u5B8C\u5168\u514D\u8CBB\u4F7F\u7528\uFF0C\u652F\u63F4 Deepl/Google/\u9A30\u8A0A/\u706B\u5C71\u7FFB\u8B6F\u7B49\u591A\u500B\u7FFB\u8B6F\u670D\u52D9\uFF0C\u652F\u63F4 Firefox/Chrome/\u6CB9\u7334\u8173\u672C\uFF0C\u4EA6\u53EF\u5728 iOS Safari \u4E0A\u4F7F\u7528\u3002",
    "browser.toggleTranslatePage": "\u7FFB\u8B6F\u7DB2\u9801/\u986F\u793A\u539F\u6587",
    "browser.toggleTranslateTheWholePage": "\u7FFB\u8B6F\u9801\u9762\u5168\u90E8\u5340\u57DF/\u986F\u793A\u539F\u6587",
    "browser.toggleTranslateToThePageEndImmediately": "\u7ACB\u5373\u7FFB\u8B6F\u5230\u9801\u9762\u5E95\u90E8/\u986F\u793A\u539F\u6587",
    "browser.toggleTranslateTheMainPage": "\u7FFB\u8B6F\u9801\u9762\u4E3B\u8981\u5340\u57DF/\u986F\u793A\u539F\u6587",
    "browser.openOptionsPage": "\u958B\u555F\u8A2D\u5B9A\u9801\u9762",
    "browser.toggleTranslationMask": "\u986F\u793A/\u96B1\u85CF\u8B6F\u6587\u6A21\u7CCA\u6548\u679C",
    "browser.translateLocalPdfFile": "\u7FFB\u8B6F\u672C\u6A5F PDF \u6A94\u6848",
    "browser.openEbookViewer": "\u95B1\u8B80\u672C\u6A5F\u96FB\u5B50\u66F8",
    "browser.openEbookBuilder": "\u88FD\u4F5C\u96D9\u8A9E Epub \u96FB\u5B50\u66F8",
    "browser.translateLocalHtmlFile": "\u7FFB\u8B6F HTML/txt \u6A94\u6848",
    "browser.translateLocalSubtitleFile": "\u7FFB\u8B6F\u5B57\u5E55\u6A94\u6848",
    "browser.donateContext": "\u4E86\u89E3\u8D0A\u52A9\u798F\u5229",
    confirmResetConfig: "\u4F60\u78BA\u5B9A\u8981\u91CD\u8A2D\u8A2D\u5B9A\u55CE\uFF1F",
    translationLineBreakSettingTitle: "\u8B6F\u6587\u63DB\u884C\u8A2D\u5B9A",
    smartLineBreak: "\u667A\u6167\u63DB\u884C",
    alwaysLineBreak: "\u7E3D\u662F\u63DB\u884C",
    isShowContextMenu: "\u5C07\u7DB2\u9801\u7FFB\u8B6F\u529F\u80FD\u52A0\u5165\u53F3\u9375\u9078\u55AE",
    toggleBeta: "\u958B\u555F Beta \u6E2C\u8A66\u529F\u80FD",
    betaDescription: "\u555F\u7528\u4ECD\u5728\u5BE6\u9A57\u7684\u529F\u80FD\u4EE5\u53CA\u6E2C\u8A66\u4E2D\u7684\u7FFB\u8B6F\u670D\u52D9\u3002\u52A0\u5165 <1>Telegram \u7FA4\u7D44</1>\u4E86\u89E3\u66F4\u591A\u3002",
    translationLineBreakSettingDescription: "\u7E3D\u662F\u63DB\u884C\u9069\u7528\u65BC\u8F03\u5C11\u5167\u5BB9\u7684\u7248\u9762\uFF0C\u66F4\u6574\u9F4A\u3002(\u5728\u5167\u5BB9\u8F03\u591A\u7684\u9577\u6BB5\u843D(\u8D85\u904E {count} \u500B\u5B57\u5143) \u4F7F\u7528\u667A\u6167\u63DB\u884C\u6703\u66F4\u7701\u7A7A\u9593)",
    tempTranslateDomainTitle: "\u81E8\u6642\u958B\u555F\u7DB2\u7AD9\u7FFB\u8B6F\u7684\u6642\u9577",
    tempTranslateDomainDescription: "\u7576\u624B\u52D5\u7FFB\u8B6F\u67D0\u500B\u7DB2\u9801\u7684\u6642\u5019\uFF0C\u81E8\u6642\u958B\u555F\u8A72\u7DB2\u7AD9\u70BA\u81EA\u52D5\u7FFB\u8B6F",
    xMinutes: "{count} \u5206\u9418",
    disabled: "\u505C\u7528",
    changelog: "\u66F4\u65B0\u8A18\u9304",
    toggleTranslatePageWhenThreeFingersOnTheScreen: "\u591A\u6307\u540C\u6642\u89F8\u6478\u87A2\u5E55\u5247\u7FFB\u8B6F\u7DB2\u9801/\u986F\u793A\u539F\u6587",
    toggleTranslationMaskWhenThreeFingersOnTheScreen: "\u591A\u6307\u540C\u6642\u89F8\u6478\u5247\u986F\u793A/\u96B1\u85CF\u8B6F\u6587\u6A21\u7CCA\u6548\u679C",
    addUrlDescription: "\u53EF\u4EE5\u70BA\u7DB2\u57DF\u540D\u7A31\uFF0C\u540C\u6642\u652F\u63F4\u842C\u7528\u5B57\u5143\uFF0C\u5982\uFF1A*.google.com, google.com/mail/*, https://www.google.com/*",
    general: "\u57FA\u672C\u8A2D\u5B9A",
    clickToExpandConfig: "\u5C55\u958B\u76EE\u524D\u8A2D\u5B9A",
    import: "\u5F9E\u6A94\u6848\u532F\u5165",
    export: "\u532F\u51FA\u70BA\u6A94\u6848",
    toggleDebug: "\u5728\u4E3B\u63A7\u53F0\u986F\u793A\u5075\u932F\u8A18\u9304",
    "fingers.0": "\u95DC\u9589",
    "fingers.2": "\u96D9\u6307\u89F8\u6478",
    "fingers.3": "\u4E09\u6307\u89F8\u6478",
    "fingers.4": "\u56DB\u6307\u89F8\u6478",
    "fingers.5": "\u4E94\u6307\u89F8\u6478",
    document: "\u8AAA\u660E\u6587\u4EF6",
    resetSuccess: "\u91CD\u8A2D\u6240\u6709\u8A2D\u5B9A\u6210\u529F",
    resetThisSuccess: "\u91CD\u8A2D\u6210\u529F",
    saved: "\u5132\u5B58\u6210\u529F",
    successImportConfig: "\u6210\u529F\u532F\u5165\u8A2D\u5B9A",
    goAdvancedSettings: "\u524D\u5F80\u9032\u968E\u8A2D\u5B9A\u9801\u9762",
    goAdvancedInterfaceSettings: "\u524D\u5F80\u81EA\u8A02\u8A2D\u5B9A\u9801\u9762",
    advanced: "\u9032\u968E\u8A2D\u5B9A",
    advancedDescription: "\u6B63\u5E38\u60C5\u6CC1\u7121\u9700\u8A2D\u5B9A\uFF0C\u4FDD\u6301\u9810\u8A2D\u5373\u53EF\u3002\u50C5\u91DD\u5C0D\u66F4\u5C08\u696D\u7684\u4F7F\u7528\u8005\uFF0C\u63D0\u4F9B\u66F4\u500B\u4EBA\u5316\u7684\u8A2D\u5B9A\u9805\u76EE\u3002",
    developer: "\u958B\u767C\u8005\u8A2D\u5B9A",
    donateCafe: "\u50F9\u683C",
    "translate to the bottom of the page": "\u9032\u5165\u7DB2\u9801\u5F8C\uFF0C\u662F\u5426\u7ACB\u5373\u7FFB\u8B6F\u5230\u9801\u9762\u5E95\u90E8\uFF1F",
    feedback: "\u554F\u984C\u56DE\u5831",
    toggleTranslatePage: "\u7FFB\u8B6F\u7DB2\u9801/\u986F\u793A\u539F\u6587",
    "mouse-translate": "\u7576\u9F20\u6A19\u6ED1\u904E",
    mouseHoldKey: "+ {key} \u7FFB\u8B6F\u8A72\u6BB5",
    mouseHoldKeyAuto: "\u76F4\u63A5\u7FFB\u8B6F\u8A72\u6BB5",
    mouseHoldKeyOff: "\u4E0D\u505A\u4EFB\u4F55\u4E8B\u60C5",
    mouseHoldKeyOther: "\u81EA\u5B9A\u7FA9\u5FEB\u6377\u9375(\u6253\u958B\u8A2D\u7F6E)",
    mouseHoldKeyCustomKey: "{key} \u7FFB\u8B6F\u8A72\u6BB5",
    mouseHoverHoldKey: "\u9F20\u6A19\u6ED1\u904E\u540C\u6642\u6309\u4E0B X \u9375\u7FFB\u8B6F\u6BB5\u843D",
    translateToThePageEndImmediatelyDescription: "\u555F\u7528\u5F8C\uFF0C\u9032\u5165\u7DB2\u9801\u5C07\u7ACB\u5373\u7FFB\u8B6F\u5F9E\u9802\u90E8\u5230\u5E95\u90E8\u7684\u5167\u5BB9\u3002\u95DC\u9589\u5247\u908A\u770B\u908A\u8B6F\u3002\uFF08\u4E0D\u63A8\u85A6\u958B\u555F\uFF09",
    "translate all areas of the page": "\u662F\u5426\u7FFB\u8B6F\u7DB2\u9801\u6240\u6709\u5340\u57DF",
    translationAreaDescription: "\u555F\u7528\u5F8C\uFF0C\u7DB2\u9801\u7684\u6240\u6709\u5340\u57DF\u90FD\u6703\u88AB\u7FFB\u8B6F\u3002\u95DC\u9589\u5247\u4F7F\u7528\u9810\u8A2D\u7684\u667A\u6167\u8FA8\u8B58\uFF0C\u50C5\u7FFB\u8B6F\u4E3B\u8981\u5340\u57DF\u3002(\u4E0D\u63A8\u85A6\u958B\u555F)",
    "the number of characters to be translated first": "\u76F4\u63A5\u7FFB\u8B6F\u9801\u9762\u524D\u591A\u5C11\u500B\u5B57\u5143\uFF0C\u800C\u7121\u9700\u7B49\u5F85\u6372\u52D5\u81F3\u53EF\u898B\u5340\u57DF",
    "interface language": "\u4ECB\u9762\u8A9E\u8A00",
    "display both the original text and the translation": "\u540C\u6642\u986F\u793A\u539F\u6587\u548C\u8B6F\u6587",
    "keyboard shortcuts": "\u9375\u76E4\u5FEB\u901F\u9375",
    modify: "\u8B8A\u66F4\u5FEB\u901F\u9375",
    reset: "\u91CD\u8A2D",
    close: "\u95DC\u9589",
    homepage: "\u9996\u9801",
    more: "\u66F4\u591A",
    translateTheWholePage: "\u7FFB\u8B6F\u9801\u9762\u5168\u90E8\u5340\u57DF\uFF08\u5340\u5206\u65BC\u53EA\u7FFB\u8B6F\u4E3B\u8981\u5340\u57DF\uFF09",
    changeToTranslateTheWholePage: "\u5207\u63DB\u70BA\u7FFB\u8B6F\u6240\u6709\u5340\u57DF",
    changeToTranslateTheMainPage: "\u5207\u63DB\u70BA\u7FFB\u8B6F\u4E3B\u8981\u5340\u57DF",
    translateToThePageEndImmediately: "\u7ACB\u5373\u7FFB\u8B6F\u5230\u5E95\u90E8\uFF08\u5340\u5206\u65BC\u770B\u54EA\u8B6F\u54EA\uFF09",
    translateTheMainPage: "\u667A\u6167\u7FFB\u8B6F\u4E3B\u8981\u5340\u57DF",
    "The local rules are up to date": "\u672C\u6A5F\u898F\u5247\u5DF2\u70BA\u6700\u65B0\uFF1A",
    "Successfully synchronized with the latest official rules:": "\u6210\u529F\u540C\u6B65\u6700\u65B0\u5B98\u65B9\u898F\u5247\uFF1A",
    "Checking for updates": "\u6B63\u5728\u6AA2\u67E5\u66F4\u65B0",
    "Rules are being synchronized": "\u6B63\u5728\u540C\u6B65\u5B98\u65B9\u898F\u5247",
    localVersionIsTooOld: "\u672C\u6A5F\u5957\u4EF6\u7248\u672C\u904E\u820A\uFF0C\u8ACB\u5347\u7D1A\u5957\u4EF6\u81F3 {minVersion} \u6216\u66F4\u65B0\u7684\u7248\u672C\u518D\u5617\u8A66\u540C\u6B65",
    badUserscriptBrowser: "\u76EE\u524D\u700F\u89BD\u5668\u7121\u6CD5\u6B63\u78BA\u5BE6\u73FE\u6CB9\u7334\u5957\u4EF6\u7684\u4ECB\u9762\uFF0C\u8ACB\u4F7F\u7528\u5176\u4ED6<1>\u652F\u63F4\u6CB9\u7334\u5957\u4EF6</1>\u7684\u700F\u89BD\u5668\u5982(Firefox Nightly \u7248\u672C)",
    foundNewVersion: "\u6709\u65B0\u7248\u672C\u53EF\u7528",
    theLocalExtensionIsUpToUpdate: "\u76EE\u524D\u5957\u4EF6\u5DF2\u662F\u6700\u65B0\u7248\u672C",
    failToSyncRules: "\u540C\u6B65\u6700\u65B0\u5B98\u65B9\u898F\u5247\u5931\u6557",
    retry: "\u9EDE\u6B64\u91CD\u8A66",
    failedReason: "\u5931\u6557\u539F\u56E0",
    currentRuleVersion: "\u76EE\u524D\u898F\u5247\u7248\u672C",
    calculating: "\u6B63\u5728\u8A08\u7B97",
    unknownError: "\u672A\u77E5\u7684\u932F\u8AA4",
    canNotFetchRemoteRule: "\u7121\u6CD5\u53D6\u5F97\u9060\u7AEF\u898F\u5247",
    enableAlphaSuccess: "\u5DF2\u555F\u7528 Alpha \u529F\u80FD",
    disableAlphaSuccess: "\u5DF2\u505C\u7528 Alpha \u529F\u80FD",
    cacheSize: "\u5FEB\u53D6\u5927\u5C0F\uFF1A",
    cleaning: "\u6B63\u5728\u6E05\u7406",
    cleanCache: "\u6E05\u9664\u5FEB\u53D6",
    options: "\u9078\u9805",
    about: "\u95DC\u65BC",
    service: "\u7FFB\u8B6F\u670D\u52D9",
    needAction: "(\u524D\u5F80\u8A2D\u5B9A)",
    goSettings: "\u524D\u5F80\u8A2D\u5B9A",
    needActionForOptions: "(\u9700\u8A2D\u5B9A)",
    translationEngine: "\u5F15\u64CE\u9078\u9805",
    sourceLanguage: "\u539F\u6587\u8A9E\u8A00",
    target: "\u76EE\u6A19\u8A9E\u8A00",
    popupSourceLanguage: "\u539F\u6587\u8A9E\u8A00",
    popupTarget: "\u76EE\u6A19\u8A9E\u8A00",
    popupService: "\u7FFB\u8B6F\u670D\u52D9",
    forThisSite: "\u91DD\u5C0D\u8A72\u7DB2\u7AD9\uFF1A",
    alwaysTranslateSomeLanguage: "\u7E3D\u662F\u7FFB\u8B6F {language}",
    neverTranslateSomeLanguage: "\u6C38\u4E0D\u7FFB\u8B6F {language}",
    alwaysTranslateSomeSite: "\u7E3D\u662F\u7FFB\u8B6F {hostname}",
    neverTranslateSomeSite: "\u6C38\u4E0D\u7FFB\u8B6F {hostname}",
    add: "\u65B0\u589E",
    default: "\u9810\u8A2D",
    forThisLanguage: "\u91DD\u5C0D\u8A72\u8A9E\u8A00\uFF1A",
    "add url": "\u8F38\u5165 URL",
    edit: "\u7DE8\u8F2F",
    "translate other languages into specific language": "\u5C07\u5176\u5B83\u8A9E\u8A00\u7FFB\u8B6F\u70BA\u4F60\u8A2D\u5B9A\u7684\u8A9E\u8A00",
    "select translation service": "\u9078\u64C7\u4F60\u60F3\u7528\u7684\u7FFB\u8B6F\u670D\u52D9",
    language: "\u8A9E\u8A00",
    "show-original": "\u986F\u793A\u539F\u6587",
    translate: "\u7FFB\u8B6F",
    Translated: "\u5DF2\u7FFB\u8B6F",
    Translating: "\u6B63\u5728\u7FFB\u8B6F",
    Error: "\u932F\u8AA4",
    allowCacheTranslations: "\u555F\u7528\u672C\u6A5F\u7FFB\u8B6F\u5FEB\u53D6\uFF08\u6E1B\u5C11\u91CD\u8907\u6BB5\u843D\u7684\u7FFB\u8B6F\u8981\u6C42\uFF09",
    "translation display": "\u8B6F\u6587\u986F\u793A\u6A23\u5F0F",
    "select diplay style": "\u5340\u5206\u8B6F\u6587\u7684\u6A23\u5F0F\uFF0C\u5177\u9AD4\u53EF\u53C3\u8003\u4E0B\u5217\u7BC4\u4F8B",
    interface: "\u4ECB\u9762\u8A2D\u5B9A",
    import_export: "\u532F\u5165/\u532F\u51FA",
    import_export_title: "\u532F\u5165/\u532F\u51FA\u8A2D\u5B9A",
    syncToGoogleDrive: "\u7ACB\u5373\u8207 Google Drive \u540C\u6B65",
    previewAllThemes: "\u9810\u89BD\u5168\u90E8\u6A23\u5F0F",
    "translationTheme.none": "\u7121",
    "translationTheme.grey": "\u9ED1\u7070\u8272",
    "translationTheme.dashed": "\u7834\u6298\u865F\u5E95\u7DDA",
    "translationTheme.dotted": "\u9EDE\u72C0\u5E95\u7DDA",
    "translationTheme.dashedBorder": "\u865B\u7DDA\u6846\u7DDA",
    "translationTheme.solidBorder": "\u5BE6\u7DDA\u6846\u7DDA",
    "translationTheme.underline": "\u76F4\u7DDA\u5E95\u7DDA",
    "translationTheme.mask": "\u6A21\u7CCA\u6548\u679C",
    "translationTheme.opacity": "\u900F\u660E\u6548\u679C",
    "translationTheme.paper": "\u767D\u7D19\u9670\u5F71\u6548\u679C",
    "translationTheme.dividingLine": "\u5206\u9694\u7DDA",
    "translationTheme.highlight": "\u9192\u76EE\u63D0\u793A",
    "translationTheme.marker": "\u99AC\u514B\u7B46",
    "translationTheme.marker2": "\u99AC\u514B\u7B462",
    "translationTheme.blockquote": "\u5F15\u7528\u6A23\u5F0F",
    "translationTheme.weakening": "\u5F31\u5316",
    "translationTheme.italic": "\u659C\u9AD4",
    "translationTheme.bold": "\u7C97\u9AD4",
    "translationTheme.thinDashed": "\u7D30\u7834\u6298\u865F\u5E95\u7DDA",
    "translationTheme.nativeDashed": "\u7CFB\u7D71\u5167\u5EFA\u7834\u6298\u865F\u5E95\u7DDA",
    "translationTheme.nativeDotted": "\u7CFB\u7D71\u5167\u5EFA\u9EDE\u72C0\u5E95\u7DDA",
    "translationTheme.nativeUnderline": "\u7CFB\u7D71\u5167\u5EFA\u76F4\u7DDA\u5E95\u7DDA",
    "translationTheme.wavy": "\u6CE2\u5F62\u66F2\u7DDA",
    "translationServices.tencent": "\u9A30\u8A0A\u7FFB\u8B6F\u541B",
    "translationServices.tenAlpha": "\u9A30\u8A0A\u7FFB\u8B6F\u541B(Alpha)",
    "translationServices.google": "Google \u7FFB\u8B6F",
    "translationServices.bai": "\u767E\u5EA6(Alpha)",
    "translationServices.baidu": "\u767E\u5EA6\u7FFB\u8B6F",
    "translationServices.aliyun": "\u963F\u91CC\u96F2\u7FFB\u8B6F",
    "translationServices.volc": "\u706B\u5C71\u7FFB\u8B6F",
    "translationServices.deeplx": "DeeplX(Beta)",
    "translationServices.bing": "\u5FAE\u8F6F\u7FFB\u8B6F",
    "translationServices.deepl": "Deepl",
    "translationServices.wechat": "\u5FAE\u4FE1\u7FFB\u8B6F",
    "translationServices.azure": "Azure \u7FFB\u8B6F",
    "translationServices.ibm": "IBM Watson",
    "translationServices.aws": "\u4E9E\u99AC\u905C\u7FFB\u8B6F",
    "translationServices.mock": "\u6A21\u64EC\u7FFB\u8B6F",
    "translationServices.mock2": "\u6A21\u64EC\u7FFB\u8B6F2",
    "translationServices.caiyun": "\u5F69\u96F2\u5C0F\u8B6F",
    "translationServices.cai": "\u5F69\u96F2\u5C0F\u8B6F (Alpha)",
    "translationServices.volcAlpha": "\u706B\u5C71\u7FFB\u8B6F(Alpha)",
    "translationServices.openl": "OpenL",
    "translationServices.youdao": "\u6709\u9053\u7FFB\u8B6F",
    "translationServices.you": "\u6709\u9053\u7FFB\u8B6F (Alpha)",
    "translationServices.transmart": "\u9A30\u8A0A\u4EA4\u4E92\u7FFB\u8B6F",
    "translationServices.niu": "\u5C0F\u725B\u7FFB\u8B6F",
    "translationServices.papago": "Papago \u7FFB\u8B6F",
    "translationServices.d": "Deepl(Alpha)",
    "translationServices.dpro": "D Pro (Canary)",
    "translationServices.openai": "OpenAI",
    "translationServices.chatgpt": "ChatGPT Plus",
    "translate title": "\u7FFB\u8B6F\u9801\u9762\u6A19\u984C",
    "always languages": "\u7E3D\u662F\u7FFB\u8B6F\u7684\u8A9E\u8A00",
    neverTranslateLanguagesLabel: "\u6C38\u4E0D\u7FFB\u8B6F\u7684\u8A9E\u8A00",
    neverTranslateTheFollowingLanguagesDescription: "\u7576\u9801\u9762\u4E2D\u67D0\u4E00\u6BB5\u843D\u7684\u8A9E\u8A00\u70BA\u4E0B\u5217\u8A9E\u8A00\u6642\uFF0C\u5C07\u8DF3\u904E\u7FFB\u8B6F",
    enableUserscriptPagePopup: "\u5728\u9801\u9762\u4E0A\u986F\u793A\u61F8\u6D6E\u7403",
    enableUserscriptPagePopupDescription: "\u95DC\u9589\u61F8\u6D6E\u7403\u5F8C\uFF0C\u53EF\u4EE5\u7528\u5FEB\u901F\u9375/{touch}\u518D\u6B21\u986F\u793A\u3002\u70BA\u9632\u6B62\u4E0D\u614E\u95DC\u9589\u8A72\u9078\u9805\u5F8C\u627E\u4E0D\u5230\u61F8\u6D6E\u7403\uFF0C\u5EFA\u8B70\u5C07\u672C\u8A2D\u5B9A\u9801\u9762\u52A0\u5165\u81F3\u6211\u7684\u6700\u611B",
    "always translate the following languages": "\u7576\u9801\u9762\u8A9E\u8A00\u70BA\u4E0B\u5217\u8A9E\u8A00\u6642\uFF0C\u6703\u81EA\u52D5\u7FFB\u8B6F\u70BA\u76EE\u6A19\u8A9E\u8A00",
    "always sites": "\u7E3D\u662F\u7FFB\u8B6F\u7684\u7DB2\u5740",
    "always translate the following sites": "\u7576\u7DB2\u7AD9\u70BA\u4E0B\u5217\u7DB2\u57DF\u540D\u7A31\u6642\uFF0C\u6703\u81EA\u52D5\u7FFB\u8B6F\u70BA\u76EE\u6A19\u8A9E\u8A00",
    "never sites": "\u6C38\u4E0D\u7FFB\u8B6F\u7684\u7DB2\u5740",
    "never translate the following sites": "\u7576\u7DB2\u7AD9\u70BA\u4E0B\u5217\u7DB2\u57DF\u540D\u7A31\u6642\uFF0C\u5C07\u4E0D\u6703\u9032\u884C\u7FFB\u8B6F",
    "please refer to": "\u9700\u8981\u586B\u5BEB\u91D1\u9470\u5F8C\u624D\u53EF\u4F7F\u7528\uFF0C\u8A73\u7D30\u8CC7\u8A0A\u8ACB\u53C3\u8003",
    KeyAndConfigurationTutorial: "\u300A\u91D1\u9470\u7533\u8ACB\u548C\u8A2D\u5B9A\u6559\u5B78\u300B",
    useAboveStyleForTheseSites: "\u7576\u7DB2\u7AD9\u70BA\u4E0B\u5217\u7DB2\u57DF\u540D\u7A31\u6642\uFF0C\u7E3D\u662F\u4F7F\u7528 \u2308{theme}\u230B \u8B6F\u6587\u6A23\u5F0F",
    currentUrl: "\u76EE\u524D\u7DB2\u5740",
    confirm: "\u5132\u5B58",
    cancel: "\u53D6\u6D88",
    delete: "\u522A\u9664",
    "languages.auto": "\u81EA\u52D5\u5075\u6E2C\u8A9E\u8A00",
    syncToCloud: "\u540C\u6B65\u81F3\u96F2\u7AEF",
    syncToCloudDescription: "\u4E0A\u50B3\u81F3\u96F2\u7AEF\u5F8C\uFF0C\u53EF\u4EE5\u5728\u4E0D\u540C\u7684\u700F\u89BD\u5668/\u6CB9\u7334\u8173\u672C\u4E4B\u9593\u540C\u6B65\u8A2D\u5B9A\uFF0C\u4EE5\u6700\u5F8C\u8B8A\u66F4\u6642\u9593\u70BA\u6E96\u3002",
    authFail: "\u6388\u6B0A\u5931\u6557",
    syncTitle: "\u624B\u52D5\u5099\u4EFD\u7BA1\u7406",
    import_hint: "\u532F\u5165",
    upload: "\u4E0A\u50B3",
    revokeAuth: "\u64A4\u92B7\u6388\u6B0A",
    uploadFail: "\u4E0A\u50B3\u5931\u6557",
    download: "\u4E0B\u8F09",
    importSuccess: "\u532F\u5165\u6210\u529F",
    importFail: "\u532F\u5165\u5931\u6557",
    deleteFail: "\u522A\u9664\u5931\u6557",
    backupToCloud: "\u624B\u52D5\u7BA1\u7406\u5099\u4EFD\u6A94\u6848",
    create_new_backup: "\u65B0\u589E\u5099\u4EFD\u7BC0\u9EDE",
    maxBackupFiles: "\u6700\u591A\u53EF\u4EE5\u5099\u4EFD{count}\u500B\u4E0D\u540C\u7684\u7BC0\u9EDE\uFF0C\u8ACB\u522A\u9664\u4E0D\u9700\u8981\u7684\u7BC0\u9EDE",
    backupToCloudDescription: "\u624B\u52D5\u4E0A\u50B3\u6216\u9084\u539F\u5099\u4EFD\u6A94\u6848\uFF0C\u6700\u591A\u5141\u8A31 3 \u500B\u4E0D\u540C\u7684\u5099\u4EFD",
    successSyncConfig: "\u6210\u529F\u8207\u96F2\u7AEF\u4FDD\u6301\u540C\u6B65",
    syncFail: "\u540C\u6B65\u5931\u6557",
    updatedAt: "\u66F4\u65B0\u65BC {date}",
    lastSyncedAt: "\u4E0A\u6B21\u6AA2\u67E5\u65BC {date}",
    downloadFail: "\u4E0B\u8F09\u5931\u6557",
    clickToDownload: "\u9EDE\u9078\u4E0B\u8F09",
    aboutLabel: "\u95DC\u65BC - \u554F\u984C\u56DE\u5831 - \u8D0A\u52A9",
    aboutLabelWithoutSponsor: "\u95DC\u65BC - \u554F\u984C\u56DE\u5831",
    "browser.openAboutPage": "\u95DC\u65BC/\u554F\u984C\u56DE\u5831/\u8D0A\u52A9",
    aboutIntro: "\u672C\u5957\u4EF6\u70BA\u514D\u8CBB\u5957\u4EF6\uFF0C\u5E0C\u671B\u6211\u5011\u90FD\u80FD\u66F4\u52A0\u5BB9\u6613\u4E14\u6109\u6085\u5730\u7372\u53D6\u7DB2\u969B\u7DB2\u8DEF\u4E0A\u66F4\u591A\u7684\u5916\u8A9E\u8CC7\u8A0A \u2764\uFE0F <br/><br/>\u611F\u8B1D\u9019\u4E9B<1>\u8D0A\u52A9\u8005\u5011</1>, \u7531\u65BC\u4ED6/\u5979\u5011\u7684\u652F\u63F4\uFF0C\u66F4\u591A\u7684\u4EBA\u53EF\u4EE5\u514D\u8CBB\u5730\u4F7F\u7528\u9019\u500B\u5DE5\u5177\u3002<br/><br/>\u514D\u8CBB\u5DE5\u5177\u4F5C\u8005\u4F3C\u4E4E\u53EF\u4EE5\u548C\u8B9A\u52A9\u8005\u4E4B\u9593\u5EFA\u7ACB\u4E00\u7A2E\u96D9\u8D0F\u7684\u95DC\u4FC2\uFF01\u6211\u70BA\u8D0A\u52A9\u8005\u63D0\u4F9B\u4E86\u4E00\u4E9B\u9650\u6642\u798F\u5229\uFF0C\u6BD4\u5982<6>DeepL\u7FFB\u8B6F\u670D\u52D9</6>\uFF0C\u4F60\u53EF\u4EE5<2>\u9EDE\u64CA\u9019\u88E1\u4E86\u89E3\u8D0A\u52A9\u65B9\u6848</2>\uFF0C\u4F60\u9084\u53EF\u4EE5\u95DC\u6CE8\u6211\u7684<3>Twitter</3>\uFF0C<4>Telegram \u983B\u9053</4>\u4EE5\u53CA\u4E0B\u65B9\u7684<5>\u90F5\u4EF6\u8A02\u95B1</5>\u8FFD\u8E64\u66F4\u65B0\u3002",
    aboutIntroWithoutSponsor: "\u672C\u5957\u4EF6\u70BA\u514D\u8CBB\u5957\u4EF6\uFF0C\u5E0C\u671B\u6211\u5011\u90FD\u80FD\u66F4\u52A0\u5BB9\u6613\u4E14\u6109\u6085\u5730\u7372\u53D6\u7DB2\u969B\u7DB2\u8DEF\u4E0A\u66F4\u591A\u7684\u5916\u8A9E\u8CC7\u8A0A \u2764\uFE0F ",
    projectHomepage: "\u5C08\u6848\u9996\u9801",
    joinTelegramGroup: "\u52A0\u5165 Telegram \u7FA4\u7D44\u53C3\u8207\u529F\u80FD\u8A0E\u8AD6",
    joinTelegramChannel: "\u95DC\u6CE8 Telegram \u983B\u9053\u77AD\u89E3\u66F4\u65B0\u8CC7\u8A0A",
    feedbackAndJoin: "\u554F\u984C\u56DE\u5831/\u52A0\u5165\u7FA4\u7D44",
    autoSync: "\u81EA\u52D5\u5B9A\u6642\u540C\u6B65",
    loadingThemeTitle: "Loading \u6A23\u5F0F",
    loadingThemeDescription: "\u8A2D\u5B9A\u7B49\u5F85\u8B6F\u6587\u8F09\u5165\u6642\u7684\u6A23\u5F0F",
    "loadingTheme.spinner": "\u8F49\u5708\u52D5\u756B",
    "loadingTheme.text": "\u975C\u614B\u6587\u5B57 ... ",
    "loadingTheme.none": "\u4E0D\u986F\u793A",
    developerDescription: "\u53EF\u4EE5\u9EDE\u9078<1>\u6B64\u8655</1>\u6AA2\u8996\u9032\u968E\u81EA\u8A02\u529F\u80FD\u76F8\u95DC\u7684\u8AAA\u660E\u6587\u4EF6",
    "edit border color": "\u8B8A\u66F4\u908A\u6846\u8272\u5F69",
    successSyncButNoChange: "\u76EE\u524D\u8A2D\u5B9A\u8207\u96F2\u7AEF\u4E00\u81F4",
    customTheme: "\u81EA\u8A02\u8272\u5F69\u548C\u5927\u5C0F",
    "customThemeLabel.borderColor": "\u908A\u6846\u8272\u5F69",
    "customThemeLabel.borderRadius": "\u908A\u6846\u5713\u89D2",
    "customThemeLabel.textColor": "\u6587\u5B57\u8272\u5F69",
    "customThemeLabel.backgroundColor": "\u80CC\u666F\u8272\u5F69",
    "customThemeLabel.zoom": "\u5B57\u578B\u7E2E\u653E\u6BD4\u4F8B (%)",
    resetToDefaultColor: "\u9084\u539F\u70BA\u9810\u8A2D\u8272\u5F69",
    isTranslateTitle: "\u555F\u7528\u7DB2\u9801\u6A19\u984C\u7FFB\u8B6F",
    isTranslateTitleDescription: "\u555F\u7528\u5F8C\uFF0C\u7DB2\u9801\u7684\u6A19\u984C\u6703\u88AB\u7FFB\u8B6F",
    verifyService: "\u9EDE\u6B64\u6E2C\u8A66\u670D\u52D9",
    verified: "\u9A57\u8B49\u6210\u529F",
    "field.model": "\u6A21\u578B",
    "field.translationEngine": "\u7FFB\u8B6F\u5F15\u64CE",
    "field.limitPerMinute": "\u6BCF\u5206\u9418\u6700\u5927\u8981\u6C42\u6578",
    "field.limitPerSecond": "\u6BCF\u79D2\u6700\u5927\u8981\u6C42\u6578",
    "field.maxTextLengthPerRequest": "\u6BCF\u6B21\u8981\u6C42\u7684\u6700\u5927\u6587\u5B57\u9577\u5EA6",
    "field.apiUrl": "\u81EA\u8A02 API \u4F4D\u5740",
    "description.limitPerMinute": "\u8981\u6C42\u6578\u8D85\u904E\u8A72\u9650\u5236\u6642\u6703\u88AB\u66AB\u6642\u505C\u7528\uFF0C\u76F4\u81F3\u4E0B\u4E00\u5206\u9418\u958B\u59CB\u3002\u7531\u4E8EOpenAI\u76EE\u524D\u670D\u52A1\u7684\u5404\u79CD\u9650\u5236\uFF0C\u8BF7\u70B9\u51FB<1>\u8FD9\u91CC</1>\u67E5\u770B\u6700\u65B0\u5EFA\u8BAE\u7684\u6570\u503C",
    "description.limitPerSecond": "\u8981\u6C42\u6578\u8D85\u904E\u8A72\u9650\u5236\u6642\u6703\u88AB\u66AB\u6642\u505C\u7528\uFF0C\u76F4\u81F3\u4E0B\u4E00\u79D2\u9418\u958B\u59CB\u3002\u7531\u4E8EOpenAI\u76EE\u524D\u670D\u52A1\u7684\u5404\u79CD\u9650\u5236\uFF0C\u8BF7\u70B9\u51FB<1>\u8FD9\u91CC</1>\u67E5\u770B\u6700\u65B0\u5EFA\u8BAE\u7684\u6570\u503C",
    "description.prompt": "\u4EE5\u7528\u6237\u8EAB\u4EFD\u53D1\u9001\u7ED9 OpenAI \u7684\u5BF9\u8BDD\uFF0C\u5176\u4E2D {{text}} \u8868\u793A\u6BB5\u843D\u7684\u6587\u672C\u5185\u5BB9\uFF0C{{from}} \u8868\u793A\u6BB5\u843D\u7684\u8BED\u8A00\uFF0C{{to}} \u8868\u793A\u76EE\u6807\u8BED\u8A00,\u53EF\u4EE5\u7701\u7565 {{text}} \uFF08\u63A8\u8350\uFF09, \u5C06\u4F1A\u5728\u5355\u72EC\u4F5C\u4E3A\u4E00\u6BB5\u53D1\u9001\u7ED9 OpenAI",
    "description.maxTextLengthPerRequest": "\u9810\u8A2D\u6703\u5408\u4F75\u591A\u500B\u6BB5\u843D\uFF0C\u4EE5\u6E1B\u5C11\u8ACB\u8981\u6C42\u6578\uFF0C\u4F46\u662F\u5982\u679C\u6BB5\u843D\u7E3D\u9577\u5EA6\u904E\u9577\uFF0C\u4E5F\u53EF\u80FD\u6703\u5C0E\u81F4 API \u7684\u56DE\u61C9\u6642\u9593\u589E\u52A0\uFF0C\u56E0\u6B64\u53EF\u4EE5\u5617\u8A66\u8ABF\u6574\u8A72\u9078\u9805\u4F86\u63D0\u5347\u901F\u5EA6",
    enabledExtension: "\u555F\u7528\u5957\u4EF6",
    clickToDisableExtension: "\u9EDE\u9078\u505C\u7528\u5957\u4EF6",
    clickToEnableExtension: "\u9EDE\u9078\u555F\u7528\u5957\u4EF6",
    hasBeenDisabled: "\u5DF2\u505C\u7528",
    "show password": "\u986F\u793A\u5BC6\u78BC",
    customContent: "\u8F38\u5165\u81EA\u5B9A\u7FA9\u6A21\u578B"
  };

  // locales/en.json
  var en_default = {
    lineBreakMaxTextCount: "Maximum number of characters allowed per sentence after line break",
    "translate-pdf": "Click to translate PDF",
    "translate-firefox-local-pdf": "Click to upload Pdf",
    enableLineBreak: "Whether to turn on automatic line wrapping for long paragraphs",
    sponsorLabel: "Sponsoring developers from $1 (monthly or one-time)",
    help: "Help",
    browserShortcutsNoteForFirefox: `To modify the shortcut key in Firefox browser, you need to open the extension management page 'about: addons', then click "Settings", and then click "Management shortcut key" to set it`,
    browserShortcutsNoteForChrome: "To modify the shortcut key in Chrome browser, you need to open the extension management page` chrome://extensions/shortcuts `) Settings, click the button below to jump to the shortcut key management page.",
    browserShortcutsSucks: "Please enter the shortcut key manually in the format:",
    enableLineBreakDescription: "After opening, a line break will be inserted at the end of each sentence in a long paragraph for easy reading",
    "browser.brandName": "Immersive Translate",
    "browser.brandDescription": "Web bilingual translation, completely free to use, supports Deepl/Google/Bing/Tencent/Youdao, etc.",
    "browser.toggleTranslatePage": "Toggle translate webpage ",
    "browser.toggleTranslateTheWholePage": "Toggle translate the whole page",
    "browser.toggleTranslateToThePageEndImmediately": "Toggle translate to the bottom of the page immediately",
    "browser.toggleTranslateTheMainPage": "Toggle translate the main page",
    "browser.openOptionsPage": "Open Settings Page",
    "browser.toggleTranslationMask": "Toggle translation mask style",
    "browser.translateLocalPdfFile": "Translate local PDF File",
    "browser.openEbookViewer": "Read local e-book",
    "browser.openEbookBuilder": "Make Dual Epub ebook",
    "browser.translateLocalHtmlFile": "Translate HTML/txt File",
    "browser.donateContext": "Sponsor Benefits",
    "browser.translateLocalSubtitleFile": "Translate Subtitle File",
    confirmResetConfig: "Are you sure you want to reset the settings?",
    translationLineBreakSettingTitle: "Line break setting",
    smartLineBreak: "Smart Wrap",
    alwaysLineBreak: "Always Wrap",
    isShowContextMenu: "Create right button menu",
    toggleBeta: "Enable Beta experimental features",
    betaDescription: "Enable features that are still experimental, and translation services that are in testing. Join the <1>Telegram group</1> to learn more.",
    translationLineBreakSettingDescription: "The always line break feature is suitable for layouts with less content, making the layout more neat and tidy. (Use smart line breaks for long paragraphs with more content (more than {count} characters) for saving space)",
    tempTranslateDomainTitle: "Open the translation time temporarily",
    tempTranslateDomainDescription: "When a page is translated manually, turn it temporarily on as automatic translation",
    xMinutes: "{count} minutes",
    disabled: "Disable",
    changelog: "Change Log",
    toggleTranslatePageWhenThreeFingersOnTheScreen: "Three-finger touch to show/hide translation display",
    toggleTranslationMaskWhenThreeFingersOnTheScreen: "Multi-finger touch to show/hide the blur effect of the translation",
    addUrlDescription: "The domain name is available and wildcard is supported e.g.: *.google.com, google.com/mail/*, https://www.google.com/*",
    general: "General",
    clickToExpandConfig: "Expand current configuration",
    import: "Import configuration from file",
    export: "Export to file",
    toggleDebug: "Print debug logs on the console",
    "fingers.0": "Close",
    "fingers.2": "Two-finger touch",
    "fingers.3": "Three-finger touch",
    "fingers.4": "Four-finger touch",
    "fingers.5": "Five-finger touch",
    document: "Document",
    resetSuccess: "All settings reset successful",
    resetThisSuccess: "Reset successful",
    saved: "Saved successfully",
    successImportConfig: "Configuration imported successfully",
    goAdvancedSettings: "Go to Advanced Settings Page",
    goAdvancedInterfaceSettings: "Go to Advanced Custom Settings Page",
    advanced: "Advanced",
    advancedDescription: "Normally no settings are needed, keep the default. More personalized settings are provided for professional users only.",
    developer: "Developer settings",
    donateCafe: "Pricing",
    "translate to the bottom of the page": "Translate to the bottom of the page immediately after opening the page?",
    feedback: "Feedback",
    toggleTranslatePage: "Toggle Translate",
    "mouse-translate": "Mouse Hover",
    mouseHoldKey: "+ {key} translate this paragraph",
    mouseHoldKeyAuto: "Translate the paragraph directly",
    mouseHoldKeyOff: "Do nothing",
    mouseHoldKeyOther: "Custom shortcut key (open settings)",
    mouseHoldKeyCustomKey: "{key} translate this paragraph",
    mouseHoverHoldKey: "Mouse over and press X key to translate paragraph",
    translateToThePageEndImmediatelyDescription: "Enabled will translate from the top to the bottom of the page immediately after opening. Disable will translate while reading. (Not recommended to enable)",
    "translate all areas of the page": "Whether to translate all areas of the web page",
    translationAreaDescription: "When enabled, all areas of the entire web page will be translated. Disabled will use the default smart recognition and translate only the main areas. (Not recommended to enable)",
    "the number of characters to be translated first": "Directly translate the number of characters in front of the page without waiting to scroll to the visible area",
    "interface language": "Interface language",
    "display both the original text and the translation": "Display both the original text and the translation",
    "keyboard shortcuts": "Keyboard shortcuts",
    modify: "Edit",
    reset: "Reset",
    close: "Close",
    homepage: "Home Page",
    more: "More",
    moreOptions: "Expand more custom settings",
    translateTheWholePage: "Translate the whole page area (different from only the main area)",
    changeToTranslateTheWholePage: "Translate the whole page",
    changeToTranslateTheMainPage: "Translate main only",
    translateToThePageEndImmediately: "Immediately translate to the bottom (different from translating the current visible area)",
    translateTheMainPage: "Main areas of intelligent translation",
    "The local rules are up to date": "Local  rules are up to date:",
    "Successfully synchronized with the latest official rules:": "Successfully synced latest official rules:",
    "Checking for updates": "Checking for update",
    "Rules are being synchronized": "Syncing official rules",
    localVersionIsTooOld: "The local extension version is too old, please upgrade the extension to {minVersion} or a newer version and try to sync again.",
    badUserscriptBrowser: "The current browser does not correctly implement the interface of the Greasemonkey extension, please use another browser that <1>supports the Greasemonkey extension</1> such as (Firefox Nightly version)",
    foundNewVersion: "New version available",
    theLocalExtensionIsUpToUpdate: "The current extension version is up to date.",
    failToSyncRules: "Failed to sync latest adaptive rules",
    retry: "Retry",
    failedReason: "Failure reason",
    currentRuleVersion: "Current Rule Version",
    calculating: "Calculating",
    unknownError: "Unknown Error",
    canNotFetchRemoteRule: "Unable to fetch remote rule",
    enableAlphaSuccess: "Alpha enabled successfully",
    disableAlphaSuccess: "Alpha has been disabled",
    cacheSize: "Cache size:",
    cleaning: "Cleaning",
    cleanCache: "Clear cache",
    options: "Options",
    about: "About",
    service: "Translation Service",
    needAction: "(to set up)",
    goSettings: "to set up",
    needActionForOptions: "(need to set)",
    translationEngine: "Engine Options",
    sourceLanguage: "Original language",
    target: "Target Language",
    popupSourceLanguage: "Source",
    popupTarget: "Target",
    popupService: "Service",
    forThisSite: "For This Site:",
    alwaysTranslateSomeLanguage: "Always translate {language}",
    neverTranslateSomeLanguage: "Never translate {language}",
    alwaysTranslateSomeSite: "Always translate {hostname}",
    neverTranslateSomeSite: "Never translate {hostname}",
    add: "Add",
    default: "Default",
    forThisLanguage: "For This Language:",
    "add url": "Add URL",
    edit: "Edit",
    "translate other languages into specific language": "Translate other languages into the language you set",
    "select translation service": "Select a translation service",
    language: "Language",
    "show-original": "Show Original",
    translate: "Translate",
    Translated: "Translated",
    Translating: "Translating",
    Error: "Error",
    allowCacheTranslations: "Enable local translation caching (reduce translation requests for duplicate paragraphs)",
    "translation display": "Translation display style",
    "select diplay style": "Please refer to the following examples",
    interface: "Interface Settings",
    import_export: "Import/Export",
    import_export_title: "Import/Export Configuration",
    syncToGoogleDrive: "Sync Now with Google Drive",
    previewAllThemes: "Preview all themes",
    "translationTheme.none": "None",
    "translationTheme.grey": "Black Gray",
    "translationTheme.dashed": "Dashed underline",
    "translationTheme.dotted": "Dotted Underline",
    "translationTheme.dashedBorder": "Dashed Border",
    "translationTheme.solidBorder": "Dashed Border",
    "translationTheme.underline": "Straight underline",
    "translationTheme.mask": "Blur effect",
    "translationTheme.opacity": "Opacity effect",
    "translationTheme.paper": "White paper shadow effect",
    "translationTheme.dividingLine": "Dividing line",
    "translationTheme.highlight": "Highlight",
    "translationTheme.marker": "Marker",
    "translationTheme.marker2": "Maker2",
    "translationTheme.blockquote": "quote style",
    "translationTheme.weakening": "Weakening",
    "translationTheme.italic": "Italic",
    "translationTheme.bold": "Bold",
    "translationTheme.thinDashed": "Thin dashed underline",
    "translationTheme.nativeDashed": "System Dash Underline",
    "translationTheme.nativeDotted": "System Dotted Underline",
    "translationTheme.nativeUnderline": "System Straight Line Underline",
    "translationTheme.wavy": "Squiggle",
    "translationServices.tencent": "Tencent Translator",
    "translationServices.tenAlpha": "Tencent Translator (Alpha)",
    "translationServices.google": "Google Translate",
    "translationServices.bai": "Baidu (Alpha)",
    "translationServices.baidu": "Baidu translation",
    "translationServices.aliyun": "Aliyun Translator",
    "translationServices.volc": "Volcano Translation",
    "translationServices.deeplx": "DeeplX (Alpha)",
    "translationServices.bing": "Microsoft Translator",
    "translationServices.deepl": "DeepL",
    "translationServices.wechat": "Wechat translation",
    "translationServices.azure": "Azure Translator",
    "translationServices.ibm": "IBM Watson",
    "translationServices.aws": "Amazon Translate",
    "translationServices.mock": "Mock translation",
    "translationServices.mock2": "Mock Translation2",
    "translationServices.caiyun": "Caiyun Translation",
    "translationServices.cai": "Caiyun Translation (Alpha)",
    "translationServices.volcAlpha": "Volcano Translation (Alpha)",
    "translationServices.openl": "OpenL",
    "translationServices.youdao": "Youdao Translation",
    "translationServices.you": "Youdao Translation (Alpha)",
    "translationServices.transmart": "Tencent Smart Translation",
    "translationServices.niu": "Niu Translation",
    "translationServices.papago": "Papago Translation",
    "translationServices.d": "DeeplX (Alpha)",
    "translationServices.dpro": "D Pro (Canary)",
    "translationServices.openai": "OpenAI",
    "translationServices.chatgpt": "ChatGPT Plus",
    "translate title": "Translate page title",
    "always languages": "Always translate the following languages",
    neverTranslateLanguagesLabel: "Never Translated Languages",
    neverTranslateTheFollowingLanguagesDescription: "When a paragraph on a page is in one of the following languages, the translation will be skipped",
    enableUserscriptPagePopup: "Always show Popup windows on the page",
    enableUserscriptPagePopupDescription: "Three-finger touch to show the Popup.",
    "always translate the following languages": "The following languages will always be translated",
    "always sites": "Always translate the following sites",
    "always translate the following sites": "The following sites will always be translated",
    "never sites": "Never translate the following sites",
    "never translate the following sites": "The following sites will never be translated",
    "please refer to": "It can only be used after filling in the key. For details, please refer to",
    KeyAndConfigurationTutorial: "Key Application and Configuration Tutorial",
    useAboveStyleForTheseSites: "Sites that always use the {theme} translation style",
    currentUrl: "Current URL",
    confirm: "Save",
    cancel: "Cancel",
    delete: "Delete",
    "languages.auto": "Detect Language",
    syncToCloud: "Sync to cloud",
    syncToCloudDescription: "Upload the configuration to the cloud server, and you can synchronize the configuration between different browsers or Tampermonkey scripts, based on the last modification time.",
    authFail: "Authorization Failed",
    syncTitle: "Please select a file operation",
    import_hint: "Import",
    upload: "Upload",
    revokeAuth: "Revoke Authorization",
    uploadFail: "Upload Failed",
    download: "Download",
    importSuccess: "Upload Success",
    importFail: "Import Failed",
    deleteFail: "Delete Failed",
    backupToCloud: "Manage backup files manually",
    create_new_backup: "Add backup node",
    maxBackupFiles: "Up to{count}different nodes can be backed up. Please delete unneeded nodes",
    backupToCloudDescription: "Upload or restore backup files manually, up to 3 different backups",
    successSyncConfig: "Successfully synced with cloud",
    syncFail: "Synchronization failed",
    updatedAt: "Updated at {date}",
    lastSyncedAt: "Last checked at {date}",
    downloadFail: "Download failed",
    clickToDownload: "Click to download",
    aboutLabel: "About - Feedback - Sponsor",
    aboutLabelWithoutSponsor: "About - Feedback",
    "browser.openAboutPage": "About / Feedback",
    aboutIntro: "The extension is completely free and we hope that users will all have more accessible and more enjoyable access to the enormous amount of foreign language information available on the Internet \u2764\uFE0F. <br/><br/>Thanks to these <1>sponsors</1>, thanks to his/her support, more people can use this tool for free. You can <2>sponsor</2> my work by clicking here, and you can also follow my <3>Twitter</3>, <4>Telegram Channel</4>, and <5>Email Subscription</5> below to track updates.",
    aboutIntroWithoutSponsor: "The extension is completely free and we hope that users will all have more accessible and more enjoyable access to the enormous amount of foreign language information available on the Internet \u2764\uFE0F. ",
    projectHomepage: "Project Homepage",
    joinTelegramGroup: "Join Telegram group for feature discussion",
    joinTelegramChannel: "Subscribe to our Telegram channel to get the latest updates",
    feedbackAndJoin: "Issue feedback/group",
    autoSync: "Auto-Time Sync",
    loadingThemeTitle: "Loading Style",
    loadingThemeDescription: "Set the style of waiting for the translation to load",
    "loadingTheme.spinner": "Spinning icon",
    "loadingTheme.text": "Static Text... ",
    "loadingTheme.none": "Disabled",
    developerDescription: "You can click <1>here</1> to see the documentation related to advanced customization",
    "edit border color": "Edit border color",
    successSyncButNoChange: "The current configuration is consistent with that in the cloud server",
    customTheme: "Customize colors and sizes",
    "customThemeLabel.borderColor": "Border color",
    "customThemeLabel.borderRadius": "Border Round Corner",
    "customThemeLabel.textColor": "Text color",
    "customThemeLabel.backgroundColor": "Background color",
    "customThemeLabel.zoom": "Font scale (%)",
    resetToDefaultColor: "Reset to default colors",
    isTranslateTitle: "Enable translate page title",
    isTranslateTitleDescription: "When enabled, the page title will be translated",
    verifyService: "Click on this test service",
    verified: "Successful",
    "field.model": "Model",
    "field.translationEngine": "Translation engine",
    "field.limitPerMinute": "Max requests per minute",
    "field.limitPerSecond": "Max requests per second",
    "field.maxTextLengthPerRequest": "Maximum text length per request",
    "field.apiUrl": "Custom API interface address",
    "description.limitPerMinute": "When the number of requests exceeds this limit, it will be temporarily suspended until the beginning of the next minute. Due to various limitations of OpenAI's current services, please click <1>here</1> to view the latest suggested values",
    "description.limitPerSecond": "When the number of requests exceeds this limit, it will be temporarily suspended until the beginning of the next second. Due to various limitations of OpenAI's current services, please click <1>here</1> to view the latest suggested values",
    "description.prompt": "Send as a user to OpenAI conversation, where {{text}} indicates the text of the paragraph,{{from}} indicates the language of the paragraph,{{to}} indicates the target language, you can omit {{text}}, if so, it'll be sent as a separated message",
    "description.maxTextLengthPerRequest": "By default multiple paragraphs will be merged to reduce the number of requests, but if the total length of the paragraphs is too long, it may also cause the interface to respond slowly, so you can try to adjust this option to optimize speed",
    enabledExtension: "Enable extensions",
    clickToDisableExtension: "Click to disable extension",
    clickToEnableExtension: "Click to enable the extension",
    hasBeenDisabled: "Disabled",
    "show password": "Show password",
    resetToDefaultSettings: "Reset to default settings",
    customContent: "Enter customization content"
  };

  // constant.ts
  var interfaceTranslations = [
    {
      code: "zh-CN",
      messages: zh_CN_default
    },
    {
      code: "zh-TW",
      messages: zh_TW_default
    },
    {
      code: "en",
      messages: en_default
    }
  ];
  var translations = {};
  for (let translation of interfaceTranslations)
    translations[translation.code] = translation.messages;
  var brandName = "Immersive Translate", brandId = "immersive-translate";
  var brandIdForJs = "immersiveTranslate";
  var GOOGLE_ACCESS_TOKEN_KEY = brandIdForJs + "GoogleAccessToken", AUTH_FLOW_FLAG = brandIdForJs + "AuthFlow";
  var AUTH_STATE_FLAG = brandIdForJs + "AuthState", iframeMessageIdentifier = brandIdForJs + "IframeMessage", iframeMessageRateIdentifier = brandIdForJs + "WaitForRateLimit", documentMessageTypeIdentifierForAsk = brandIdForJs + "DocumentMessageAsk", documentMessageTypeIdentifierForTellThirdParty = brandIdForJs + "DocumentMessageTellThirdParty", documentMessageTypeIdentifierForThirdPartyTell = brandIdForJs + "DocumentMessageThirdPartyTell", documentMessageTypeIdentifierForHandler = brandIdForJs + "DocumentMessageHandler", targetContainerElementAttributeName = `${brandIdForJs}Container`, specifiedTargetContainerElementAttributeName = `${brandIdForJs}SpecifiedContainer`;
  var pageTranslatedStatusEventName = `${brandIdForJs}PageTranslatedStatus`, pageUrlChangedEventName = `${brandIdForJs}PageUrlChanged`, userscriptCommandEventName = `${brandIdForJs}ReceiveCommand`, popupReceiveMessageEventName = `${brandIdForJs}PopupReceiveMessage`, hostname = "immersive-translate.owenyoung.com", homepage = `https://${hostname}/`, buildinConfigSyncUrl = `https://${hostname}/buildin_config.json`, sourceElementMarkAttributeName = `${brandIdForJs}Mark`;
  var elementMarkRootKey = `${brandIdForJs}Root`, sourceElementEffectAttributeName = `data-${brandId}-effect`, sourceElementTranslatedMarkAttributeName = `${brandIdForJs}TranslatedMark`, sourceElementParagraphAttributeName = `${brandIdForJs}ParagraphId`, sourceAtomicBlockElementMarkAttributeName = `${brandIdForJs}AtomicBlockMark`, sourceElementExcludeAttributeName = `${brandIdForJs}ExcludeMark`, sourceElementExcludeAttributeNameForSelector = `data-${brandId}-exclude-mark`, sourceElementStayOriginalAttributeName = `${brandIdForJs}StayOriginalMark`, sourcePreWhitespaceMarkAttributeName = `${brandIdForJs}PreWhitespaceMark`, sourceInlineElementMarkAttributeName = `${brandIdForJs}InlineMark`, sourceBlockElementMarkAttributeName = `${brandIdForJs}BlockMark`, sourceElementLeft = `${brandIdForJs}Left`, sourceElementRight = `${brandIdForJs}Right`, sourceElementWidth = `${brandIdForJs}Width`, sourceElementHeight = `${brandIdForJs}Height`, sourceElementTop = `${brandIdForJs}Top`, sourceElementFontSize = `${brandIdForJs}FontSize`;
  var sourceElementWithGlobalStyleMarkAttributeName = `${brandIdForJs}GlobalStyleMark`;
  var translationTargetElementWrapperClass = `${brandId}-target-wrapper`, translationPdfTargetContainerClass = `${brandId}-pdf-target-container`, translationTargetInnerElementWrapperClass = `${brandId}-target-inner`, translationSourceElementsWrapperClass = `${brandId}-source-wrapper`, translationTargetTranslationElementBlockWrapperClass = `${brandId}-target-translation-block-wrapper`, translationFrameRootThemeAttributeName = `${brandId}-root-translation-theme`, translationFrameRootThemeAttributeNameForJs = `${brandIdForJs}RootTranslationTheme`, translationTargetTranslationElementVerticalBlockClass = `${brandId}-target-translation-vertical-block-wrapper`, translationTargetTranslationPdfElementBlockWrapperClass = `${brandId}-target-translation-pdf-block-wrapper`, translationTargetTranslationElementPreWhitespaceWrapperClass = `${brandId}-target-translation-pre-whitespace`, translationTargetTranslationElementInlineWrapperClass = `${brandId}-target-translation-inline-wrapper`;
  var openlProps = [
    {
      type: "select",
      name: "codename",
      labelKey: "field.translationEngine",
      default: "youdao",
      required: !1,
      options: [
        {
          label: "translationServices.google",
          value: "google"
        },
        {
          label: "translationServices.deepl",
          value: "deepl"
        },
        {
          label: "translationServices.youdao",
          value: "youdao"
        },
        {
          label: "translationServices.tencent",
          value: "tencent"
        },
        {
          label: "translationServices.aliyun",
          value: "aliyun"
        },
        {
          label: "translationServices.baidu",
          value: "baidu"
        },
        {
          label: "translationServices.caiyun",
          value: "caiyun"
        },
        {
          label: "translationServices.wechat",
          value: "wechat"
        },
        {
          label: "translationServices.ibm",
          value: "ibm"
        },
        {
          label: "translationServices.azure",
          value: "azure"
        },
        {
          label: "translationServices.aws",
          value: "aws"
        }
      ]
    }
  ], PureTranslationServices = {
    bing: {
      name: "\u5FAE\u8F6F\u7FFB\u8BD1",
      homepage: "https://www.bing.com/translator"
    },
    google: {
      name: "Google",
      homepage: "https://translate.google.com/"
    },
    deepl: {
      name: "DeepL",
      homepage: "https://www.deepl.com/translator",
      docUrl: "https://immersive-translate.owenyoung.com/services/deepL",
      allProps: [
        {
          name: "authKey",
          label: "Auth Key",
          required: !0,
          type: "password"
        }
      ]
    },
    transmart: {
      name: "Transmart",
      homepage: "https://transmart.qq.com/"
    },
    openai: {
      name: "Open AI",
      homepage: "https://openai.com/api/",
      docUrl: "https://immersive-translate.owenyoung.com/services/openai",
      allProps: [
        {
          name: "APIKEY",
          required: !0,
          type: "password"
        },
        {
          name: "model",
          labelKey: "field.model",
          descriptionKey: "description.model",
          required: !1,
          type: "select",
          default: "gpt-3.5-turbo",
          options: [
            {
              label: "gpt-3.5-turbo",
              value: "gpt-3.5-turbo"
            },
            {
              label: "gpt-4",
              value: "gpt-4"
            }
          ]
        },
        {
          name: "limit",
          required: !1,
          labelKey: "field.limitPerSecond",
          descriptionKey: "description.limitPerSecond",
          descriptionLink1: "https://immersive-translate.owenyoung.com/services/openai",
          type: "number",
          default: 5
        },
        {
          name: "maxTextLengthPerRequest",
          required: !1,
          labelKey: "field.maxTextLengthPerRequest",
          descriptionKey: "description.maxTextLengthPerRequest",
          type: "number",
          default: 1200,
          optional: !0
        },
        {
          name: "maxTextGroupLengthPerRequest",
          required: !1,
          labelKey: "field.maxTextGroupLengthPerRequest",
          descriptionKey: "description.maxTextGroupLengthPerRequest",
          type: "number",
          default: 1,
          optional: !0
        },
        {
          name: "apiUrl",
          labelKey: "field.apiUrl",
          required: !1,
          type: "text",
          default: "https://api.openai.com/v1/chat/completions",
          descriptionKey: "description.apiUrl",
          optional: !0
        },
        {
          name: "systemPrompt",
          label: "System Prompt",
          required: !1,
          descriptionKey: "description.systemPrompt",
          type: "text",
          optional: !0,
          default: "You are a translation engine, you can only translate text and cannot interpret it, and do not explain."
        },
        {
          name: "prompt",
          label: "Prompt",
          required: !1,
          descriptionKey: "description.prompt",
          type: "textarea",
          default: `Translate the text below to {{to}}:

{{text}}`,
          optional: !0
        }
      ]
    },
    chatgpt: {
      name: "ChatGPT Plus",
      homepage: "https://chat.openai.com",
      beta: !0
    },
    youdao: {
      name: "Youdao",
      homepage: "https://immersive-translate.owenyoung.com/services/youdao",
      docUrl: "https://immersive-translate.owenyoung.com/services/youdao",
      allProps: [
        {
          name: "appId",
          required: !0,
          type: "text"
        },
        {
          name: "appSecret",
          required: !0,
          type: "password"
        }
      ]
    },
    tencent: {
      name: "Tencent",
      homepage: "https://fanyi.qq.com/",
      docUrl: "https://immersive-translate.owenyoung.com/services/tencent",
      allProps: [
        {
          name: "secretId",
          required: !0,
          type: "text"
        },
        {
          name: "secretKey",
          required: !0,
          type: "password"
        }
      ]
    },
    azure: {
      name: "azure",
      homepage: "https://learn.microsoft.com/en-us/azure/cognitive-services/translator/text-translation-overview",
      docUrl: "https://immersive-translate.owenyoung.com/services/azure",
      allProps: [
        {
          name: "region",
          required: !0,
          default: "eastasia",
          type: "text"
        },
        {
          name: "APIKEY",
          required: !0,
          type: "password"
        }
      ]
    },
    papago: {
      name: "Papago",
      homepage: "https://translate.google.com/",
      canary: !0
    },
    baidu: {
      name: "Baidu",
      homepage: "https://fanyi.baidu.com/",
      docUrl: "https://immersive-translate.owenyoung.com/services/baidu",
      allProps: [
        {
          name: "appid",
          required: !0,
          type: "text"
        },
        {
          name: "key",
          required: !0,
          type: "password"
        }
      ]
    },
    volc: {
      name: "Volc",
      homepage: "https://www.volcengine.com/",
      docUrl: "https://immersive-translate.owenyoung.com/services/volcano",
      allProps: [
        {
          name: "accessKeyId",
          required: !0,
          type: "text"
        },
        {
          name: "secretAccessKey",
          required: !0,
          type: "password"
        }
      ]
    },
    caiyun: {
      name: "Caiyun",
      homepage: "https://fanyi.caiyunapp.com/",
      docUrl: "https://immersive-translate.owenyoung.com/services/caiyun",
      allProps: [
        {
          name: "token",
          required: !0,
          type: "password"
        }
      ]
    },
    cai: {
      name: "Cai",
      homepage: "https://fanyi.caiyunapp.com/",
      alpha: !0
    },
    mock: {
      name: "Mock",
      homepage: "https://www.google.com"
    },
    mock2: {
      name: "Mock2",
      homepage: "https://www.google.com"
    },
    tenAlpha: {
      name: "TenAlpha",
      homepage: "https://fanyi.qq.com/",
      alpha: !0
    },
    you: {
      name: "You",
      alpha: !0,
      homepage: "https://immersive-translate.owenyoung.com/services/youdao"
    },
    openl: {
      name: "Openl",
      homepage: "https://openl.club/",
      docUrl: "https://immersive-translate.owenyoung.com/services/openL",
      allProps: [
        ...openlProps,
        {
          type: "password",
          name: "apikey",
          required: !0
        }
      ],
      props: openlProps
    },
    volcAlpha: {
      name: "Volc Alpha",
      alpha: !0,
      homepage: "https://www.volcengine.com/"
    },
    d: {
      name: "D () ",
      alpha: !0,
      homepage: "https://www.deepl.com/translator"
    },
    dpro: {
      name: "DPro (Canary) ",
      canary: !0,
      homepage: "https://www.deepl.com/translator"
    },
    deeplx: {
      name: "DeepLX (Beta)",
      beta: !0,
      homepage: "https://www.deepl.com/translator",
      allProps: [
        {
          name: "url",
          label: "API URL",
          required: !0,
          type: "text"
        }
      ]
    },
    niu: {
      name: "niutrans",
      homepage: "https://niutrans.com/",
      docUrl: "https://immersive-translate.owenyoung.com/services/niu",
      allProps: [
        {
          name: "APIKEY",
          required: !0,
          type: "password"
        }
      ]
    }
  }, childFrameToRootFrameIdentifier = { type: brandIdForJs + "ChildFrameToRootFrameIdentifier" };

  // libs/subtitle/subtitle_page.tsx
  var totalParagraphsCount = 0, currentTranslatedParagraphsOkCount = 0, currentTranslatedParagraphsErrorCount = 0;
  function Page(props) {
    let { data } = props, { parsed, file } = data, ext = file.name.split(".").pop(), arr = [], arrMap = {}, [isExporting, setIsExporting] = P2(!1), [pageLanguage, setPageLanguage] = P2("auto"), [successProgress, setSuccessProgress] = P2(0), [errorCount, setErrorCount] = P2(0);
    j2(() => {
      document.addEventListener(
        documentMessageTypeIdentifierForTellThirdParty,
        (e3) => {
          let { detail } = e3;
          if (detail)
            try {
              let detailObj = JSON.parse(detail);
              if (detailObj && detailObj.type && detailObj.payload)
                if (detailObj.type === "retryFailedParagraphsStart")
                  currentTranslatedParagraphsErrorCount = 0, setErrorCount(0);
                else if (detailObj.type === "targetLanguage")
                  setPageLanguage(detailObj.payload.targetLanguage);
                else if (detailObj.type === "paragraphTranslated") {
                  let { ok } = detailObj.payload;
                  if (ok ? currentTranslatedParagraphsOkCount++ : currentTranslatedParagraphsErrorCount++, totalParagraphsCount) {
                    let translatedCount = currentTranslatedParagraphsOkCount, totalTranslatedCount = currentTranslatedParagraphsOkCount + currentTranslatedParagraphsErrorCount, accuracy = translatedCount / totalParagraphsCount * 100, successProgress2 = Math.floor(accuracy), totalProgress = Math.floor(
                      totalTranslatedCount / totalParagraphsCount * 100
                    );
                    successProgress2 > 100 && (successProgress2 = 100), totalProgress > 100 && (totalProgress = 100), setSuccessProgress(successProgress2), totalProgress === 100 && currentTranslatedParagraphsErrorCount > 0 && setErrorCount(currentTranslatedParagraphsErrorCount);
                  }
                } else
                  detailObj.type === "totalParagraphsCount" ? detailObj.payload.totalParagraphsCount && (totalParagraphsCount = detailObj.payload.totalParagraphsCount) : detailObj.type === "translateStart" ? (currentTranslatedParagraphsOkCount = 0, currentTranslatedParagraphsErrorCount = 0) : detailObj.type === "restorePage" && (setSuccessProgress(0), setErrorCount(0));
            } catch {
            }
        }
      ), document.dispatchEvent(
        new CustomEvent("immersiveTranslateEbookLoaded")
      );
    }, []);
    for (let i3 = 0; i3 < parsed.length; i3++) {
      let item = parsed[i3];
      if (item.type === "caption") {
        let { start, end } = item;
        if (arrMap[`${start}-${end}`] === void 0) {
          let nextIndex = arr.length;
          arrMap[`${start}-${end}`] = nextIndex;
          let text = item.text;
          arr.push({
            source: item
          });
        }
      }
    }
    let handleRetryAll = (e3) => {
      e3.preventDefault(), document.dispatchEvent(
        new CustomEvent(documentMessageTypeIdentifierForThirdPartyTell, {
          detail: JSON.stringify({
            type: "retryFailedParagraphs"
          })
        })
      );
    }, handleExport = async (e3) => {
      setIsExporting(!0), e3.preventDefault();
      var options = { format: ext, verbose: !0 };
      let newParsed = [], handledMap = {};
      for (let i3 = 0; i3 < parsed.length; i3++) {
        let item = parsed[i3], { type } = item;
        if (type !== "caption")
          newParsed.push(item);
        else {
          let index2 = item.index || i3;
          if (!handledMap[index2]) {
            handledMap[index2] = !0;
            let sourceElement = document.querySelector(
              `.source-text[data-start="${item.start}"][data-end="${item.end}"]`
            );
            newParsed.push({
              ...item,
              text: sourceElement?.textContent || ""
            });
            let target = document.querySelector(
              `.target-text[data-start="${item.start}"][data-end="${item.end}"]`
            );
            if (target) {
              let text = target.textContent;
              text && newParsed.push({
                ...item,
                text
              });
            }
          }
        }
      }
      var content = subsrt_default.build(newParsed, options);
      let contentBlob = new Blob([content], { type: "text/plain" }), newName = file.name, index = newName.lastIndexOf(".");
      newName = newName.substring(0, index) + "." + pageLanguage + newName.substring(index), await H3.saveAs(contentBlob, newName), setIsExporting(!1);
    };
    return /* @__PURE__ */ p2("main", { children: [
      /* @__PURE__ */ p2("h3", { style: { marginBottom: 0 }, children: [
        "\u6B63\u5728\u7528",
        " ",
        /* @__PURE__ */ p2(
          "a",
          {
            class: "notranslate contrast",
            href: "https://immersive-translate.owenyoung.com/",
            target: "_blank",
            children: "\u6C89\u6D78\u5F0F\u53CC\u8BED\u7FFB\u8BD1\u6269\u5C55"
          }
        ),
        "\xA0\u7FFB\u8BD1 ",
        file.name,
        /* @__PURE__ */ p2("span", { id: "progress-number", children: successProgress ? ` ${successProgress}%` : "" })
      ] }),
      /* @__PURE__ */ p2("div", { children: currentTranslatedParagraphsErrorCount ? /* @__PURE__ */ p2("span", { children: [
        currentTranslatedParagraphsErrorCount,
        " failed(\u5931\u8D25).",
        " ",
        /* @__PURE__ */ p2("a", { href: "#", class: "link", onClick: handleRetryAll, children: "Retry failed paragraphs" })
      ] }) : null }),
      /* @__PURE__ */ p2("nav", { children: /* @__PURE__ */ p2("ul", { children: [
        /* @__PURE__ */ p2("li", { children: /* @__PURE__ */ p2(
          "a",
          {
            href: "#",
            onClick: (e3) => {
              e3.preventDefault(), globalThis.location.reload();
            },
            children: "New"
          }
        ) }),
        /* @__PURE__ */ p2("li", { children: /* @__PURE__ */ p2("a", { href: "#", "aria-busy": isExporting, onClick: handleExport, children: "Export (\u5BFC\u51FA)" }) })
      ] }) }),
      /* @__PURE__ */ p2("p", { style: { fontSize: 14, color: "#666" }, children: "Tips: \u624B\u52A8\u70B9\u51FB\u6C89\u6D78\u5F0F\u7FFB\u8BD1\u6269\u5C55\u7684\u7FFB\u8BD1\u6309\u94AE\u5F00\u59CB\u7FFB\u8BD1" }),
      /* @__PURE__ */ p2("table", { children: [
        /* @__PURE__ */ p2("thead", { children: /* @__PURE__ */ p2("tr", { children: [
          /* @__PURE__ */ p2("th", { children: "Start" }),
          /* @__PURE__ */ p2("th", { children: "End" }),
          /* @__PURE__ */ p2("th", { children: "Source" }),
          /* @__PURE__ */ p2("th", { children: "Target(\u53EF\u7F16\u8F91)" })
        ] }) }),
        /* @__PURE__ */ p2("tbody", { children: arr.map((item, index) => {
          let { source, target } = item;
          return /* @__PURE__ */ p2("tr", { children: [
            /* @__PURE__ */ p2("td", { children: millSecondToTime(source.start) }),
            /* @__PURE__ */ p2("td", { children: millSecondToTime(source.end) }),
            /* @__PURE__ */ p2("td", { children: /* @__PURE__ */ p2(
              "span",
              {
                "data-start": source.start,
                "data-end": source.end,
                class: "source-text pre-white notranslate",
                children: source.text
              }
            ) }),
            /* @__PURE__ */ p2("td", { children: /* @__PURE__ */ p2(
              "span",
              {
                contentEditable: !0,
                "data-start": source.start,
                "data-end": source.end,
                spellcheck: !1,
                class: "target-text notranslate input-border pre-white",
                children: target?.text || ""
              }
            ) })
          ] }, index);
        }) })
      ] })
    ] });
  }
  function millSecondToTime(millSecond) {
    let second = millSecond / 1e3, minute = second / 60, hour = minute / 60, secondStr = second % 60, minuteStr = minute % 60, hourStr = hour % 60;
    return `${addZero(Math.floor(hourStr))}:${addZero(Math.floor(minuteStr))}:${addZero(Math.floor(secondStr))}`;
  }
  function addZero(num) {
    return num < 10 ? "0" + num : num;
  }

  // locales.ts
  var internalLocaleMap = {
    "zh-CN": {
      "languages.en": "\u82F1\u8BED",
      "languages.ja": "\u65E5\u8BED",
      "languages.ko": "\u97E9\u8BED",
      "languages.es": "\u897F\u73ED\u7259\u8BED",
      "languages.fr": "\u6CD5\u8BED",
      "languages.de": "\u5FB7\u8BED",
      "languages.it": "\u610F\u5927\u5229\u8BED",
      "languages.pt": "\u8461\u8404\u7259\u8BED",
      "languages.ru": "\u4FC4\u8BED",
      "languages.wyw": "\u6587\u8A00\u6587",
      "languages.<all>": "\u5168\u90E8"
    },
    "zh-TW": {
      "languages.en": "\u82F1\u8A9E",
      "languages.ja": "\u65E5\u8A9E",
      "languages.ko": "\u97D3\u8A9E",
      "languages.es": "\u897F\u73ED\u7259\u8A9E",
      "languages.fr": "\u6CD5\u8A9E",
      "languages.de": "\u5FB7\u8A9E",
      "languages.it": "\u610F\u5927\u5229\u8A9E",
      "languages.pt": "\u8461\u8404\u7259\u8A9E",
      "languages.ru": "\u4FC4\u8A9E",
      "languages.wyw": "\u6587\u8A00\u6587",
      "languages.<all>": "\u5168\u90E8"
    }
  }, finalTranslations = {
    ...translations,
    "zh-CN": {
      ...internalLocaleMap["zh-CN"],
      ...translations["zh-CN"]
    },
    "zh-TW": {
      ...internalLocaleMap["zh-TW"],
      ...translations["zh-TW"]
    }
  }, locales_default = finalTranslations;

  // https://deno.land/std@0.171.0/async/deferred.ts
  function deferred() {
    let methods, state = "pending", promise = new Promise((resolve, reject) => {
      methods = {
        async resolve(value) {
          await value, state = "fulfilled", resolve(value);
        },
        // deno-lint-ignore no-explicit-any
        reject(reason) {
          state = "rejected", reject(reason);
        }
      };
    });
    return Object.defineProperty(promise, "state", { get: () => state }), Object.assign(promise, methods);
  }

  // https://deno.land/std@0.171.0/async/mux_async_iterator.ts
  var MuxAsyncIterator = class {
    #iteratorCount = 0;
    #yields = [];
    // deno-lint-ignore no-explicit-any
    #throws = [];
    #signal = deferred();
    add(iterable) {
      ++this.#iteratorCount, this.#callIteratorNext(iterable[Symbol.asyncIterator]());
    }
    async #callIteratorNext(iterator) {
      try {
        let { value, done } = await iterator.next();
        done ? --this.#iteratorCount : this.#yields.push({ iterator, value });
      } catch (e3) {
        this.#throws.push(e3);
      }
      this.#signal.resolve();
    }
    async *iterate() {
      for (; this.#iteratorCount > 0; ) {
        await this.#signal;
        for (let i3 = 0; i3 < this.#yields.length; i3++) {
          let { iterator, value } = this.#yields[i3];
          yield value, this.#callIteratorNext(iterator);
        }
        if (this.#throws.length) {
          for (let e3 of this.#throws)
            throw e3;
          this.#throws.length = 0;
        }
        this.#yields.length = 0, this.#signal = deferred();
      }
    }
    [Symbol.asyncIterator]() {
      return this.iterate();
    }
  };

  // https://deno.land/std@0.167.0/fmt/colors.ts
  var colors_exports = {};
  __export(colors_exports, {
    bgBlack: () => bgBlack,
    bgBlue: () => bgBlue,
    bgBrightBlack: () => bgBrightBlack,
    bgBrightBlue: () => bgBrightBlue,
    bgBrightCyan: () => bgBrightCyan,
    bgBrightGreen: () => bgBrightGreen,
    bgBrightMagenta: () => bgBrightMagenta,
    bgBrightRed: () => bgBrightRed,
    bgBrightWhite: () => bgBrightWhite,
    bgBrightYellow: () => bgBrightYellow,
    bgCyan: () => bgCyan,
    bgGreen: () => bgGreen,
    bgMagenta: () => bgMagenta,
    bgRed: () => bgRed,
    bgRgb24: () => bgRgb24,
    bgRgb8: () => bgRgb8,
    bgWhite: () => bgWhite,
    bgYellow: () => bgYellow,
    black: () => black,
    blue: () => blue,
    bold: () => bold,
    brightBlack: () => brightBlack,
    brightBlue: () => brightBlue,
    brightCyan: () => brightCyan,
    brightGreen: () => brightGreen,
    brightMagenta: () => brightMagenta,
    brightRed: () => brightRed,
    brightWhite: () => brightWhite,
    brightYellow: () => brightYellow,
    cyan: () => cyan,
    dim: () => dim,
    getColorEnabled: () => getColorEnabled,
    gray: () => gray,
    green: () => green,
    hidden: () => hidden,
    inverse: () => inverse,
    italic: () => italic,
    magenta: () => magenta,
    red: () => red,
    reset: () => reset,
    rgb24: () => rgb24,
    rgb8: () => rgb8,
    setColorEnabled: () => setColorEnabled,
    strikethrough: () => strikethrough,
    stripColor: () => stripColor,
    underline: () => underline,
    white: () => white,
    yellow: () => yellow
  });
  var { Deno: Deno2 } = globalThis, noColor = typeof Deno2?.noColor == "boolean" ? Deno2.noColor : !0, enabled = !noColor;
  function setColorEnabled(value) {
    noColor || (enabled = value);
  }
  function getColorEnabled() {
    return enabled;
  }
  function code(open3, close) {
    return {
      open: `\x1B[${open3.join(";")}m`,
      close: `\x1B[${close}m`,
      regexp: new RegExp(`\\x1b\\[${close}m`, "g")
    };
  }
  function run(str, code2) {
    return enabled ? `${code2.open}${str.replace(code2.regexp, code2.open)}${code2.close}` : str;
  }
  function reset(str) {
    return run(str, code([0], 0));
  }
  function bold(str) {
    return run(str, code([1], 22));
  }
  function dim(str) {
    return run(str, code([2], 22));
  }
  function italic(str) {
    return run(str, code([3], 23));
  }
  function underline(str) {
    return run(str, code([4], 24));
  }
  function inverse(str) {
    return run(str, code([7], 27));
  }
  function hidden(str) {
    return run(str, code([8], 28));
  }
  function strikethrough(str) {
    return run(str, code([9], 29));
  }
  function black(str) {
    return run(str, code([30], 39));
  }
  function red(str) {
    return run(str, code([31], 39));
  }
  function green(str) {
    return run(str, code([32], 39));
  }
  function yellow(str) {
    return run(str, code([33], 39));
  }
  function blue(str) {
    return run(str, code([34], 39));
  }
  function magenta(str) {
    return run(str, code([35], 39));
  }
  function cyan(str) {
    return run(str, code([36], 39));
  }
  function white(str) {
    return run(str, code([37], 39));
  }
  function gray(str) {
    return brightBlack(str);
  }
  function brightBlack(str) {
    return run(str, code([90], 39));
  }
  function brightRed(str) {
    return run(str, code([91], 39));
  }
  function brightGreen(str) {
    return run(str, code([92], 39));
  }
  function brightYellow(str) {
    return run(str, code([93], 39));
  }
  function brightBlue(str) {
    return run(str, code([94], 39));
  }
  function brightMagenta(str) {
    return run(str, code([95], 39));
  }
  function brightCyan(str) {
    return run(str, code([96], 39));
  }
  function brightWhite(str) {
    return run(str, code([97], 39));
  }
  function bgBlack(str) {
    return run(str, code([40], 49));
  }
  function bgRed(str) {
    return run(str, code([41], 49));
  }
  function bgGreen(str) {
    return run(str, code([42], 49));
  }
  function bgYellow(str) {
    return run(str, code([43], 49));
  }
  function bgBlue(str) {
    return run(str, code([44], 49));
  }
  function bgMagenta(str) {
    return run(str, code([45], 49));
  }
  function bgCyan(str) {
    return run(str, code([46], 49));
  }
  function bgWhite(str) {
    return run(str, code([47], 49));
  }
  function bgBrightBlack(str) {
    return run(str, code([100], 49));
  }
  function bgBrightRed(str) {
    return run(str, code([101], 49));
  }
  function bgBrightGreen(str) {
    return run(str, code([102], 49));
  }
  function bgBrightYellow(str) {
    return run(str, code([103], 49));
  }
  function bgBrightBlue(str) {
    return run(str, code([104], 49));
  }
  function bgBrightMagenta(str) {
    return run(str, code([105], 49));
  }
  function bgBrightCyan(str) {
    return run(str, code([106], 49));
  }
  function bgBrightWhite(str) {
    return run(str, code([107], 49));
  }
  function clampAndTruncate(n2, max = 255, min = 0) {
    return Math.trunc(Math.max(Math.min(n2, max), min));
  }
  function rgb8(str, color) {
    return run(str, code([38, 5, clampAndTruncate(color)], 39));
  }
  function bgRgb8(str, color) {
    return run(str, code([48, 5, clampAndTruncate(color)], 49));
  }
  function rgb24(str, color) {
    return typeof color == "number" ? run(
      str,
      code(
        [38, 2, color >> 16 & 255, color >> 8 & 255, color & 255],
        39
      )
    ) : run(
      str,
      code(
        [
          38,
          2,
          clampAndTruncate(color.r),
          clampAndTruncate(color.g),
          clampAndTruncate(color.b)
        ],
        39
      )
    );
  }
  function bgRgb24(str, color) {
    return typeof color == "number" ? run(
      str,
      code(
        [48, 2, color >> 16 & 255, color >> 8 & 255, color & 255],
        49
      )
    ) : run(
      str,
      code(
        [
          48,
          2,
          clampAndTruncate(color.r),
          clampAndTruncate(color.g),
          clampAndTruncate(color.b)
        ],
        49
      )
    );
  }
  var ANSI_PATTERN = new RegExp(
    [
      "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
      "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-nq-uy=><~]))"
    ].join("|"),
    "g"
  );
  function stripColor(string) {
    return string.replace(ANSI_PATTERN, "");
  }

  // https://esm.sh/v119/memoize-one@6.0.0/deno/memoize-one.mjs
  var s2 = Number.isNaN || function(r) {
    return typeof r == "number" && r !== r;
  };

  // https://esm.sh/v119/lodash.throttle@4.1.1/deno/lodash.throttle.mjs
  var __global$2 = globalThis || (typeof window < "u" ? window : self), P4 = Object.create, I3 = Object.defineProperty, D4 = Object.getOwnPropertyDescriptor, G3 = Object.getOwnPropertyNames, H4 = Object.getPrototypeOf, U4 = Object.prototype.hasOwnProperty, X3 = (e3, t2) => () => (t2 || e3((t2 = { exports: {} }).exports, t2), t2.exports), q3 = (e3, t2) => {
    for (var n2 in t2)
      I3(e3, n2, { get: t2[n2], enumerable: !0 });
  }, v2 = (e3, t2, n2, f5) => {
    if (t2 && typeof t2 == "object" || typeof t2 == "function")
      for (let i3 of G3(t2))
        !U4.call(e3, i3) && i3 !== n2 && I3(e3, i3, { get: () => t2[i3], enumerable: !(f5 = D4(t2, i3)) || f5.enumerable });
    return e3;
  }, s3 = (e3, t2, n2) => (v2(e3, t2, "default"), n2 && v2(n2, t2, "default")), L3 = (e3, t2, n2) => (n2 = e3 != null ? P4(H4(e3)) : {}, v2(t2 || !e3 || !e3.__esModule ? I3(n2, "default", { value: e3, enumerable: !0 }) : n2, e3)), h2 = X3((ge2, N5) => {
    var M5 = "Expected a function", W5 = NaN, z4 = "[object Symbol]", J3 = /^\s+|\s+$/g, K3 = /^[-+]0x[0-9a-f]+$/i, Q5 = /^0b[01]+$/i, V5 = /^0o[0-7]+$/i, Y4 = parseInt, Z3 = typeof __global$2 == "object" && __global$2 && __global$2.Object === Object && __global$2, w4 = typeof self == "object" && self && self.Object === Object && self, ee3 = Z3 || w4 || Function("return this")(), te = Object.prototype, ne3 = te.toString, re3 = Math.max, ie2 = Math.min, O5 = function() {
      return ee3.Date.now();
    };
    function fe(e3, t2, n2) {
      var f5, i3, b6, l2, a3, u4, d6 = 0, S7 = !1, g5 = !1, T6 = !0;
      if (typeof e3 != "function")
        throw new TypeError(M5);
      t2 = C5(t2) || 0, p4(n2) && (S7 = !!n2.leading, g5 = "maxWait" in n2, b6 = g5 ? re3(C5(n2.maxWait) || 0, t2) : b6, T6 = "trailing" in n2 ? !!n2.trailing : T6);
      function j4(r) {
        var o3 = f5, m5 = i3;
        return f5 = i3 = void 0, d6 = r, l2 = e3.apply(m5, o3), l2;
      }
      function A5(r) {
        return d6 = r, a3 = setTimeout(y3, t2), S7 ? j4(r) : l2;
      }
      function B8(r) {
        var o3 = r - u4, m5 = r - d6, k4 = t2 - o3;
        return g5 ? ie2(k4, b6 - m5) : k4;
      }
      function E4(r) {
        var o3 = r - u4, m5 = r - d6;
        return u4 === void 0 || o3 >= t2 || o3 < 0 || g5 && m5 >= b6;
      }
      function y3() {
        var r = O5();
        if (E4(r))
          return _3(r);
        a3 = setTimeout(y3, B8(r));
      }
      function _3(r) {
        return a3 = void 0, T6 && f5 ? j4(r) : (f5 = i3 = void 0, l2);
      }
      function F7() {
        a3 !== void 0 && clearTimeout(a3), d6 = 0, f5 = u4 = i3 = a3 = void 0;
      }
      function R6() {
        return a3 === void 0 ? l2 : _3(O5());
      }
      function x2() {
        var r = O5(), o3 = E4(r);
        if (f5 = arguments, i3 = this, u4 = r, o3) {
          if (a3 === void 0)
            return A5(u4);
          if (g5)
            return a3 = setTimeout(y3, t2), j4(u4);
        }
        return a3 === void 0 && (a3 = setTimeout(y3, t2)), l2;
      }
      return x2.cancel = F7, x2.flush = R6, x2;
    }
    function ae2(e3, t2, n2) {
      var f5 = !0, i3 = !0;
      if (typeof e3 != "function")
        throw new TypeError(M5);
      return p4(n2) && (f5 = "leading" in n2 ? !!n2.leading : f5, i3 = "trailing" in n2 ? !!n2.trailing : i3), fe(e3, t2, { leading: f5, maxWait: t2, trailing: i3 });
    }
    function p4(e3) {
      var t2 = typeof e3;
      return !!e3 && (t2 == "object" || t2 == "function");
    }
    function oe3(e3) {
      return !!e3 && typeof e3 == "object";
    }
    function ue2(e3) {
      return typeof e3 == "symbol" || oe3(e3) && ne3.call(e3) == z4;
    }
    function C5(e3) {
      if (typeof e3 == "number")
        return e3;
      if (ue2(e3))
        return W5;
      if (p4(e3)) {
        var t2 = typeof e3.valueOf == "function" ? e3.valueOf() : e3;
        e3 = p4(t2) ? t2 + "" : t2;
      }
      if (typeof e3 != "string")
        return e3 === 0 ? e3 : +e3;
      e3 = e3.replace(J3, "");
      var n2 = Q5.test(e3);
      return n2 || V5.test(e3) ? Y4(e3.slice(2), n2 ? 2 : 8) : K3.test(e3) ? W5 : +e3;
    }
    N5.exports = ae2;
  }), c = {};
  q3(c, { default: () => se2 });
  var ce3 = L3(h2());
  s3(c, L3(h2()));
  var { default: $3, ...le2 } = ce3, se2 = $3 !== void 0 ? $3 : le2;

  // https://esm.sh/v119/notie@4.3.1/deno/notie.mjs
  var Oe2 = Object.create, ve2 = Object.defineProperty, Ae2 = Object.getOwnPropertyDescriptor, De = Object.getOwnPropertyNames, Ie = Object.getPrototypeOf, je2 = Object.prototype.hasOwnProperty, Ne2 = (v5, i3) => () => (i3 || v5((i3 = { exports: {} }).exports, i3), i3.exports), Pe = (v5, i3) => {
    for (var l2 in i3)
      ve2(v5, l2, { get: i3[l2], enumerable: !0 });
  }, me2 = (v5, i3, l2, x2) => {
    if (i3 && typeof i3 == "object" || typeof i3 == "function")
      for (let b6 of De(i3))
        !je2.call(v5, b6) && b6 !== l2 && ve2(v5, b6, { get: () => i3[b6], enumerable: !(x2 = Ae2(i3, b6)) || x2.enumerable });
    return v5;
  }, X4 = (v5, i3, l2) => (me2(v5, i3, "default"), l2 && me2(l2, i3, "default")), ke2 = (v5, i3, l2) => (l2 = v5 != null ? Oe2(Ie(v5)) : {}, me2(i3 || !v5 || !v5.__esModule ? ve2(l2, "default", { value: v5, enumerable: !0 }) : l2, v5)), xe = Ne2((oe3, be) => {
    (function(v5, i3) {
      typeof oe3 == "object" && typeof be == "object" ? be.exports = i3() : typeof define == "function" && define.amd ? define([], i3) : typeof oe3 == "object" ? oe3.notie = i3() : v5.notie = i3();
    })(oe3, function() {
      return function(v5) {
        function i3(x2) {
          if (l2[x2])
            return l2[x2].exports;
          var b6 = l2[x2] = { i: x2, l: !1, exports: {} };
          return v5[x2].call(b6.exports, b6, b6.exports, i3), b6.l = !0, b6.exports;
        }
        var l2 = {};
        return i3.m = v5, i3.c = l2, i3.i = function(x2) {
          return x2;
        }, i3.d = function(x2, b6, re3) {
          i3.o(x2, b6) || Object.defineProperty(x2, b6, { configurable: !1, enumerable: !0, get: re3 });
        }, i3.n = function(x2) {
          var b6 = x2 && x2.__esModule ? function() {
            return x2.default;
          } : function() {
            return x2;
          };
          return i3.d(b6, "a", b6), b6;
        }, i3.o = function(x2, b6) {
          return Object.prototype.hasOwnProperty.call(x2, b6);
        }, i3.p = "", i3(i3.s = 1);
      }([function(v5, i3) {
        v5.exports = function(l2) {
          return l2.webpackPolyfill || (l2.deprecate = function() {
          }, l2.paths = [], l2.children || (l2.children = []), Object.defineProperty(l2, "loaded", { enumerable: !0, get: function() {
            return l2.l;
          } }), Object.defineProperty(l2, "id", { enumerable: !0, get: function() {
            return l2.i;
          } }), l2.webpackPolyfill = 1), l2;
        };
      }, function(v5, i3, l2) {
        "use strict";
        (function(x2) {
          var b6, re3, de2, $5 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(A5) {
            return typeof A5;
          } : function(A5) {
            return A5 && typeof Symbol == "function" && A5.constructor === Symbol && A5 !== Symbol.prototype ? "symbol" : typeof A5;
          };
          (function(A5, p4) {
            $5(i3) === "object" && $5(x2) === "object" ? x2.exports = p4() : (re3 = [], b6 = p4, de2 = typeof b6 == "function" ? b6.apply(i3, re3) : b6, de2 !== void 0 && (x2.exports = de2));
          })(void 0, function() {
            return function(A5) {
              function p4(g5) {
                if (ee3[g5])
                  return ee3[g5].exports;
                var T6 = ee3[g5] = { i: g5, l: !1, exports: {} };
                return A5[g5].call(T6.exports, T6, T6.exports, p4), T6.l = !0, T6.exports;
              }
              var ee3 = {};
              return p4.m = A5, p4.c = ee3, p4.i = function(g5) {
                return g5;
              }, p4.d = function(g5, T6, J3) {
                p4.o(g5, T6) || Object.defineProperty(g5, T6, { configurable: !1, enumerable: !0, get: J3 });
              }, p4.n = function(g5) {
                var T6 = g5 && g5.__esModule ? function() {
                  return g5.default;
                } : function() {
                  return g5;
                };
                return p4.d(T6, "a", T6), T6;
              }, p4.o = function(g5, T6) {
                return Object.prototype.hasOwnProperty.call(g5, T6);
              }, p4.p = "", p4(p4.s = 0);
            }([function(A5, p4, ee3) {
              function g5(t2, o3) {
                var s5 = {};
                for (var u4 in t2)
                  o3.indexOf(u4) >= 0 || Object.prototype.hasOwnProperty.call(t2, u4) && (s5[u4] = t2[u4]);
                return s5;
              }
              Object.defineProperty(p4, "__esModule", { value: !0 });
              var T6 = typeof Symbol == "function" && $5(Symbol.iterator) === "symbol" ? function(t2) {
                return typeof t2 > "u" ? "undefined" : $5(t2);
              } : function(t2) {
                return t2 && typeof Symbol == "function" && t2.constructor === Symbol && t2 !== Symbol.prototype ? "symbol" : typeof t2 > "u" ? "undefined" : $5(t2);
              }, J3 = Object.assign || function(t2) {
                for (var o3 = 1; o3 < arguments.length; o3++) {
                  var s5 = arguments[o3];
                  for (var u4 in s5)
                    Object.prototype.hasOwnProperty.call(s5, u4) && (t2[u4] = s5[u4]);
                }
                return t2;
              }, R6 = { top: "top", bottom: "bottom" }, e3 = { alertTime: 3, dateMonths: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], overlayClickDismiss: !0, overlayOpacity: 0.75, transitionCurve: "ease", transitionDuration: 0.3, transitionSelector: "all", classes: { container: "notie-container", textbox: "notie-textbox", textboxInner: "notie-textbox-inner", button: "notie-button", element: "notie-element", elementHalf: "notie-element-half", elementThird: "notie-element-third", overlay: "notie-overlay", backgroundSuccess: "notie-background-success", backgroundWarning: "notie-background-warning", backgroundError: "notie-background-error", backgroundInfo: "notie-background-info", backgroundNeutral: "notie-background-neutral", backgroundOverlay: "notie-background-overlay", alert: "notie-alert", inputField: "notie-input-field", selectChoiceRepeated: "notie-select-choice-repeated", dateSelectorInner: "notie-date-selector-inner", dateSelectorUp: "notie-date-selector-up" }, ids: { overlay: "notie-overlay" }, positions: { alert: R6.top, force: R6.top, confirm: R6.top, input: R6.top, select: R6.bottom, date: R6.top } }, Ee2 = p4.setOptions = function(t2) {
                e3 = J3({}, e3, t2, { classes: J3({}, e3.classes, t2.classes), ids: J3({}, e3.ids, t2.ids), positions: J3({}, e3.positions, t2.positions) });
              }, ye2 = function() {
                return new Promise(function(t2) {
                  return setTimeout(t2, 0);
                });
              }, le3 = function(t2) {
                return new Promise(function(o3) {
                  return setTimeout(o3, 1e3 * t2);
                });
              }, W5 = function() {
                document.activeElement && document.activeElement.blur();
              }, K3 = function() {
                var t2 = "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function(o3) {
                  var s5 = 16 * Math.random() | 0, u4 = o3 === "x" ? s5 : 3 & s5 | 8;
                  return u4.toString(16);
                });
                return "notie-" + t2;
              }, ue2 = { 1: e3.classes.backgroundSuccess, success: e3.classes.backgroundSuccess, 2: e3.classes.backgroundWarning, warning: e3.classes.backgroundWarning, 3: e3.classes.backgroundError, error: e3.classes.backgroundError, 4: e3.classes.backgroundInfo, info: e3.classes.backgroundInfo, 5: e3.classes.backgroundNeutral, neutral: e3.classes.backgroundNeutral }, Le = function() {
                return e3.transitionSelector + " " + e3.transitionDuration + "s " + e3.transitionCurve;
              }, te = function(t2) {
                return t2.keyCode === 13;
              }, ne3 = function(t2) {
                return t2.keyCode === 27;
              }, Z3 = function(t2, o3) {
                t2.classList.add(e3.classes.container), t2.style[o3] = "-10000px", document.body.appendChild(t2), t2.style[o3] = "-" + t2.offsetHeight + "px", t2.listener && window.addEventListener("keydown", t2.listener), ye2().then(function() {
                  t2.style.transition = Le(), t2.style[o3] = 0;
                });
              }, O5 = function(t2, o3) {
                var s5 = document.getElementById(t2);
                s5 && (s5.style[o3] = "-" + s5.offsetHeight + "px", s5.listener && window.removeEventListener("keydown", s5.listener), le3(e3.transitionDuration).then(function() {
                  s5.parentNode && s5.parentNode.removeChild(s5);
                }));
              }, se3 = function(t2, o3) {
                var s5 = document.createElement("div");
                s5.id = e3.ids.overlay, s5.classList.add(e3.classes.overlay), s5.classList.add(e3.classes.backgroundOverlay), s5.style.opacity = 0, t2 && e3.overlayClickDismiss && (s5.onclick = function() {
                  O5(t2.id, o3), j4();
                }), document.body.appendChild(s5), ye2().then(function() {
                  s5.style.transition = Le(), s5.style.opacity = e3.overlayOpacity;
                });
              }, j4 = function() {
                var t2 = document.getElementById(e3.ids.overlay);
                t2.style.opacity = 0, le3(e3.transitionDuration).then(function() {
                  t2.parentNode && t2.parentNode.removeChild(t2);
                });
              }, F7 = p4.hideAlerts = function(t2) {
                var o3 = document.getElementsByClassName(e3.classes.alert);
                if (o3.length) {
                  for (var s5 = 0; s5 < o3.length; s5++) {
                    var u4 = o3[s5];
                    O5(u4.id, u4.position);
                  }
                  t2 && le3(e3.transitionDuration).then(function() {
                    return t2();
                  });
                }
              }, Te2 = p4.alert = function(t2) {
                var o3 = t2.type, s5 = o3 === void 0 ? 4 : o3, u4 = t2.text, c3 = t2.time, k4 = c3 === void 0 ? e3.alertTime : c3, H6 = t2.stay, S7 = H6 !== void 0 && H6, h3 = t2.position, f5 = h3 === void 0 ? e3.positions.alert || f5.top : h3;
                W5(), F7();
                var d6 = document.createElement("div"), m5 = K3();
                d6.id = m5, d6.position = f5, d6.classList.add(e3.classes.textbox), d6.classList.add(ue2[s5]), d6.classList.add(e3.classes.alert), d6.innerHTML = '<div class="' + e3.classes.textboxInner + '">' + u4 + "</div>", d6.onclick = function() {
                  return O5(m5, f5);
                }, d6.listener = function(n2) {
                  (te(n2) || ne3(n2)) && F7();
                }, Z3(d6, f5), k4 && k4 < 1 && (k4 = 1), !S7 && k4 && le3(k4).then(function() {
                  return O5(m5, f5);
                });
              }, Me2 = p4.force = function(t2, o3) {
                var s5 = t2.type, u4 = s5 === void 0 ? 5 : s5, c3 = t2.text, k4 = t2.buttonText, H6 = k4 === void 0 ? "OK" : k4, S7 = t2.callback, h3 = t2.position, f5 = h3 === void 0 ? e3.positions.force || f5.top : h3;
                W5(), F7();
                var d6 = document.createElement("div"), m5 = K3();
                d6.id = m5;
                var n2 = document.createElement("div");
                n2.classList.add(e3.classes.textbox), n2.classList.add(e3.classes.backgroundInfo), n2.innerHTML = '<div class="' + e3.classes.textboxInner + '">' + c3 + "</div>";
                var r = document.createElement("div");
                r.classList.add(e3.classes.button), r.classList.add(ue2[u4]), r.innerHTML = H6, r.onclick = function() {
                  O5(m5, f5), j4(), S7 ? S7() : o3 && o3();
                }, d6.appendChild(n2), d6.appendChild(r), d6.listener = function(C5) {
                  te(C5) && r.click();
                }, Z3(d6, f5), se3();
              }, He2 = p4.confirm = function(t2, o3, s5) {
                var u4 = t2.text, c3 = t2.submitText, k4 = c3 === void 0 ? "Yes" : c3, H6 = t2.cancelText, S7 = H6 === void 0 ? "Cancel" : H6, h3 = t2.submitCallback, f5 = t2.cancelCallback, d6 = t2.position, m5 = d6 === void 0 ? e3.positions.confirm || m5.top : d6;
                W5(), F7();
                var n2 = document.createElement("div"), r = K3();
                n2.id = r;
                var C5 = document.createElement("div");
                C5.classList.add(e3.classes.textbox), C5.classList.add(e3.classes.backgroundInfo), C5.innerHTML = '<div class="' + e3.classes.textboxInner + '">' + u4 + "</div>";
                var y3 = document.createElement("div");
                y3.classList.add(e3.classes.button), y3.classList.add(e3.classes.elementHalf), y3.classList.add(e3.classes.backgroundSuccess), y3.innerHTML = k4, y3.onclick = function() {
                  O5(r, m5), j4(), h3 ? h3() : o3 && o3();
                };
                var a3 = document.createElement("div");
                a3.classList.add(e3.classes.button), a3.classList.add(e3.classes.elementHalf), a3.classList.add(e3.classes.backgroundError), a3.innerHTML = S7, a3.onclick = function() {
                  O5(r, m5), j4(), f5 ? f5() : s5 && s5();
                }, n2.appendChild(C5), n2.appendChild(y3), n2.appendChild(a3), n2.listener = function(E4) {
                  te(E4) ? y3.click() : ne3(E4) && a3.click();
                }, Z3(n2, m5), se3(n2, m5);
              }, ge2 = function(t2, o3, s5) {
                var u4 = t2.text, c3 = t2.submitText, k4 = c3 === void 0 ? "Submit" : c3, H6 = t2.cancelText, S7 = H6 === void 0 ? "Cancel" : H6, h3 = t2.submitCallback, f5 = t2.cancelCallback, d6 = t2.position, m5 = d6 === void 0 ? e3.positions.input || m5.top : d6, n2 = g5(t2, ["text", "submitText", "cancelText", "submitCallback", "cancelCallback", "position"]);
                W5(), F7();
                var r = document.createElement("div"), C5 = K3();
                r.id = C5;
                var y3 = document.createElement("div");
                y3.classList.add(e3.classes.textbox), y3.classList.add(e3.classes.backgroundInfo), y3.innerHTML = '<div class="' + e3.classes.textboxInner + '">' + u4 + "</div>";
                var a3 = document.createElement("input");
                a3.classList.add(e3.classes.inputField), a3.setAttribute("autocapitalize", n2.autocapitalize || "none"), a3.setAttribute("autocomplete", n2.autocomplete || "off"), a3.setAttribute("autocorrect", n2.autocorrect || "off"), a3.setAttribute("autofocus", n2.autofocus || "true"), a3.setAttribute("inputmode", n2.inputmode || "verbatim"), a3.setAttribute("max", n2.max || ""), a3.setAttribute("maxlength", n2.maxlength || ""), a3.setAttribute("min", n2.min || ""), a3.setAttribute("minlength", n2.minlength || ""), a3.setAttribute("placeholder", n2.placeholder || ""), a3.setAttribute("spellcheck", n2.spellcheck || "default"), a3.setAttribute("step", n2.step || "any"), a3.setAttribute("type", n2.type || "text"), a3.value = n2.value || "", n2.allowed && (a3.oninput = function() {
                  var M5 = void 0;
                  if (Array.isArray(n2.allowed)) {
                    for (var w4 = "", _3 = n2.allowed, P6 = 0; P6 < _3.length; P6++)
                      _3[P6] === "an" ? w4 += "0-9a-zA-Z" : _3[P6] === "a" ? w4 += "a-zA-Z" : _3[P6] === "n" && (w4 += "0-9"), _3[P6] === "s" && (w4 += " ");
                    M5 = new RegExp("[^" + w4 + "]", "g");
                  } else
                    T6(n2.allowed) === "object" && (M5 = n2.allowed);
                  a3.value = a3.value.replace(M5, "");
                });
                var E4 = document.createElement("div");
                E4.classList.add(e3.classes.button), E4.classList.add(e3.classes.elementHalf), E4.classList.add(e3.classes.backgroundSuccess), E4.innerHTML = k4, E4.onclick = function() {
                  O5(C5, m5), j4(), h3 ? h3(a3.value) : o3 && o3(a3.value);
                };
                var D7 = document.createElement("div");
                D7.classList.add(e3.classes.button), D7.classList.add(e3.classes.elementHalf), D7.classList.add(e3.classes.backgroundError), D7.innerHTML = S7, D7.onclick = function() {
                  O5(C5, m5), j4(), f5 ? f5(a3.value) : s5 && s5(a3.value);
                }, r.appendChild(y3), r.appendChild(a3), r.appendChild(E4), r.appendChild(D7), r.listener = function(M5) {
                  te(M5) ? E4.click() : ne3(M5) && D7.click();
                }, Z3(r, m5), a3.focus(), se3(r, m5);
              };
              p4.input = ge2;
              var Se2 = p4.select = function(t2, o3) {
                var s5 = t2.text, u4 = t2.cancelText, c3 = u4 === void 0 ? "Cancel" : u4, k4 = t2.cancelCallback, H6 = t2.choices, S7 = t2.position, h3 = S7 === void 0 ? e3.positions.select || h3.top : S7;
                W5(), F7();
                var f5 = document.createElement("div"), d6 = K3();
                f5.id = d6;
                var m5 = document.createElement("div");
                m5.classList.add(e3.classes.textbox), m5.classList.add(e3.classes.backgroundInfo), m5.innerHTML = '<div class="' + e3.classes.textboxInner + '">' + s5 + "</div>", f5.appendChild(m5), H6.forEach(function(r, C5) {
                  var y3 = r.type, a3 = y3 === void 0 ? 1 : y3, E4 = r.text, D7 = r.handler, M5 = document.createElement("div");
                  M5.classList.add(ue2[a3]), M5.classList.add(e3.classes.button), M5.classList.add(e3.classes.selectChoice);
                  var w4 = H6[C5 + 1];
                  w4 && !w4.type && (w4.type = 1), w4 && w4.type === a3 && M5.classList.add(e3.classes.selectChoiceRepeated), M5.innerHTML = E4, M5.onclick = function() {
                    O5(d6, h3), j4(), D7();
                  }, f5.appendChild(M5);
                });
                var n2 = document.createElement("div");
                n2.classList.add(e3.classes.backgroundNeutral), n2.classList.add(e3.classes.button), n2.innerHTML = c3, n2.onclick = function() {
                  O5(d6, h3), j4(), k4 ? k4() : o3 && o3();
                }, f5.appendChild(n2), f5.listener = function(r) {
                  ne3(r) && n2.click();
                }, Z3(f5, h3), se3(f5, h3);
              }, we2 = p4.date = function(t2, o3, s5) {
                var u4 = t2.value, c3 = u4 === void 0 ? /* @__PURE__ */ new Date() : u4, k4 = t2.submitText, H6 = k4 === void 0 ? "OK" : k4, S7 = t2.cancelText, h3 = S7 === void 0 ? "Cancel" : S7, f5 = t2.submitCallback, d6 = t2.cancelCallback, m5 = t2.position, n2 = m5 === void 0 ? e3.positions.date || n2.top : m5;
                W5(), F7();
                var r = "&#9662", C5 = document.createElement("div"), y3 = document.createElement("div"), a3 = document.createElement("div"), E4 = function(L6) {
                  C5.innerHTML = e3.dateMonths[L6.getMonth()], y3.innerHTML = L6.getDate(), a3.innerHTML = L6.getFullYear();
                }, D7 = function(L6) {
                  var N5 = new Date(c3.getFullYear(), c3.getMonth() + 1, 0).getDate(), V5 = L6.target.textContent.replace(/^0+/, "").replace(/[^\d]/g, "").slice(0, 2);
                  Number(V5) > N5 && (V5 = N5.toString()), L6.target.textContent = V5, Number(V5) < 1 && (V5 = "1"), c3.setDate(Number(V5));
                }, M5 = function(L6) {
                  var N5 = L6.target.textContent.replace(/^0+/, "").replace(/[^\d]/g, "").slice(0, 4);
                  L6.target.textContent = N5, c3.setFullYear(Number(N5));
                }, w4 = function(L6) {
                  E4(c3);
                }, _3 = function(L6) {
                  var N5 = new Date(c3.getFullYear(), c3.getMonth() + L6 + 1, 0).getDate();
                  c3.getDate() > N5 && c3.setDate(N5), c3.setMonth(c3.getMonth() + L6), E4(c3);
                }, P6 = function(L6) {
                  c3.setDate(c3.getDate() + L6), E4(c3);
                }, he2 = function(L6) {
                  var N5 = c3.getFullYear() + L6;
                  N5 < 0 ? c3.setFullYear(0) : c3.setFullYear(c3.getFullYear() + L6), E4(c3);
                }, Y4 = document.createElement("div"), pe2 = K3();
                Y4.id = pe2;
                var fe = document.createElement("div");
                fe.classList.add(e3.classes.backgroundInfo);
                var I5 = document.createElement("div");
                I5.classList.add(e3.classes.dateSelectorInner);
                var q5 = document.createElement("div");
                q5.classList.add(e3.classes.button), q5.classList.add(e3.classes.elementThird), q5.classList.add(e3.classes.dateSelectorUp), q5.innerHTML = r;
                var G5 = document.createElement("div");
                G5.classList.add(e3.classes.button), G5.classList.add(e3.classes.elementThird), G5.classList.add(e3.classes.dateSelectorUp), G5.innerHTML = r;
                var Q5 = document.createElement("div");
                Q5.classList.add(e3.classes.button), Q5.classList.add(e3.classes.elementThird), Q5.classList.add(e3.classes.dateSelectorUp), Q5.innerHTML = r, C5.classList.add(e3.classes.element), C5.classList.add(e3.classes.elementThird), C5.innerHTML = e3.dateMonths[c3.getMonth()], y3.classList.add(e3.classes.element), y3.classList.add(e3.classes.elementThird), y3.setAttribute("contentEditable", !0), y3.addEventListener("input", D7), y3.addEventListener("blur", w4), y3.innerHTML = c3.getDate(), a3.classList.add(e3.classes.element), a3.classList.add(e3.classes.elementThird), a3.setAttribute("contentEditable", !0), a3.addEventListener("input", M5), a3.addEventListener("blur", w4), a3.innerHTML = c3.getFullYear();
                var ae2 = document.createElement("div");
                ae2.classList.add(e3.classes.button), ae2.classList.add(e3.classes.elementThird), ae2.innerHTML = r;
                var ie2 = document.createElement("div");
                ie2.classList.add(e3.classes.button), ie2.classList.add(e3.classes.elementThird), ie2.innerHTML = r;
                var ce4 = document.createElement("div");
                ce4.classList.add(e3.classes.button), ce4.classList.add(e3.classes.elementThird), ce4.innerHTML = r, q5.onclick = function() {
                  return _3(1);
                }, G5.onclick = function() {
                  return P6(1);
                }, Q5.onclick = function() {
                  return he2(1);
                }, ae2.onclick = function() {
                  return _3(-1);
                }, ie2.onclick = function() {
                  return P6(-1);
                }, ce4.onclick = function() {
                  return he2(-1);
                };
                var z4 = document.createElement("div");
                z4.classList.add(e3.classes.button), z4.classList.add(e3.classes.elementHalf), z4.classList.add(e3.classes.backgroundSuccess), z4.innerHTML = H6, z4.onclick = function() {
                  O5(pe2, n2), j4(), f5 ? f5(c3) : o3 && o3(c3);
                };
                var U8 = document.createElement("div");
                U8.classList.add(e3.classes.button), U8.classList.add(e3.classes.elementHalf), U8.classList.add(e3.classes.backgroundError), U8.innerHTML = h3, U8.onclick = function() {
                  O5(pe2, n2), j4(), d6 ? d6(c3) : s5 && s5(c3);
                }, I5.appendChild(q5), I5.appendChild(G5), I5.appendChild(Q5), I5.appendChild(C5), I5.appendChild(y3), I5.appendChild(a3), I5.appendChild(ae2), I5.appendChild(ie2), I5.appendChild(ce4), fe.appendChild(I5), Y4.appendChild(fe), Y4.appendChild(z4), Y4.appendChild(U8), Y4.listener = function(L6) {
                  te(L6) ? z4.click() : ne3(L6) && U8.click();
                }, Z3(Y4, n2), se3(Y4, n2);
              };
              p4.default = { alert: Te2, force: Me2, confirm: He2, input: ge2, select: Se2, date: we2, setOptions: Ee2, hideAlerts: F7 };
            }]);
          });
        }).call(i3, l2(0)(v5));
      }]);
    });
  }), B5 = {};
  Pe(B5, { default: () => Ye2 });
  var Fe = ke2(xe());
  X4(B5, ke2(xe()));
  var { default: Ce2, ..._e3 } = Fe, Ye2 = Ce2 !== void 0 ? Ce2 : _e3;

  // https://esm.sh/v119/nanostores@0.7.4/deno/nanostores.mjs
  var S5 = Symbol("clean");
  var m4 = Symbol();

  // https://esm.sh/v119/@nanostores/i18n@0.7.1/deno/i18n.mjs
  function g3(r, n2) {
    if (typeof r == "string")
      return n2(r);
    {
      let e3 = {};
      for (let t2 in r)
        e3[t2] = g3(r[t2], n2);
      return e3;
    }
  }
  function p3(r) {
    return (n2) => {
      if (n2.transform) {
        let e3 = n2.transform;
        return n2 = n2.input, { input: n2, transform(t2, o3, s5) {
          let f5 = r(t2, o3, ...s5);
          return (...l2) => e3(t2, f5, l2);
        } };
      } else
        return { input: n2, transform(e3, t2, o3) {
          return r(e3, t2, ...o3);
        } };
    };
  }
  var N3 = p3((r, n2, e3) => g3(n2, (t2) => {
    for (let o3 in e3)
      t2 = t2.replace(new RegExp(`{${o3}}`, "g"), e3[o3]);
    return t2;
  })), R4 = p3((r, n2, e3) => {
    let t2 = new Intl.PluralRules(r).select(e3);
    return t2 in n2 || (t2 = "many"), g3(n2[t2], (o3) => o3.replace(/{count}/g, e3));
  });

  // https://esm.sh/v119/hotkeys-js@3.10.1/deno/hotkeys-js.mjs
  var M4 = typeof navigator < "u" ? navigator.userAgent.toLowerCase().indexOf("firefox") > 0 : !1;
  function P5(e3, t2, i3, r) {
    e3.addEventListener ? e3.addEventListener(t2, i3, r) : e3.attachEvent && e3.attachEvent("on".concat(t2), function() {
      i3(window.event);
    });
  }
  function T5(e3, t2) {
    for (var i3 = t2.slice(0, t2.length - 1), r = 0; r < i3.length; r++)
      i3[r] = e3[i3[r].toLowerCase()];
    return i3;
  }
  function U5(e3) {
    typeof e3 != "string" && (e3 = ""), e3 = e3.replace(/\s/g, "");
    for (var t2 = e3.split(","), i3 = t2.lastIndexOf(""); i3 >= 0; )
      t2[i3 - 1] += ",", t2.splice(i3, 1), i3 = t2.lastIndexOf("");
    return t2;
  }
  function G4(e3, t2) {
    for (var i3 = e3.length >= t2.length ? e3 : t2, r = e3.length >= t2.length ? t2 : e3, n2 = !0, a3 = 0; a3 < i3.length; a3++)
      r.indexOf(i3[a3]) === -1 && (n2 = !1);
    return n2;
  }
  var b5 = { backspace: 8, "\u232B": 8, tab: 9, clear: 12, enter: 13, "\u21A9": 13, return: 13, esc: 27, escape: 27, space: 32, left: 37, up: 38, right: 39, down: 40, del: 46, delete: 46, ins: 45, insert: 45, home: 36, end: 35, pageup: 33, pagedown: 34, capslock: 20, num_0: 96, num_1: 97, num_2: 98, num_3: 99, num_4: 100, num_5: 101, num_6: 102, num_7: 103, num_8: 104, num_9: 105, num_multiply: 106, num_add: 107, num_enter: 108, num_subtract: 109, num_decimal: 110, num_divide: 111, "\u21EA": 20, ",": 188, ".": 190, "/": 191, "`": 192, "-": M4 ? 173 : 189, "=": M4 ? 61 : 187, ";": M4 ? 59 : 186, "'": 222, "[": 219, "]": 221, "\\": 220 }, g4 = { "\u21E7": 16, shift: 16, "\u2325": 18, alt: 18, option: 18, "\u2303": 17, ctrl: 17, control: 17, "\u2318": 91, cmd: 91, command: 91 }, L4 = { 16: "shiftKey", 18: "altKey", 17: "ctrlKey", 91: "metaKey", shiftKey: 16, ctrlKey: 17, altKey: 18, metaKey: 91 }, u3 = { 16: !1, 18: !1, 17: !1, 91: !1 }, s4 = {};
  for (O4 = 1; O4 < 20; O4++)
    b5["f".concat(O4)] = 111 + O4;
  var O4, f4 = [], A4 = !1, D5 = "all", H5 = [], C4 = function(t2) {
    return b5[t2.toLowerCase()] || g4[t2.toLowerCase()] || t2.toUpperCase().charCodeAt(0);
  }, R5 = function(t2) {
    return Object.keys(b5).find(function(i3) {
      return b5[i3] === t2;
    });
  }, V3 = function(t2) {
    return Object.keys(g4).find(function(i3) {
      return g4[i3] === t2;
    });
  };
  function F6(e3) {
    D5 = e3 || "all";
  }
  function E2() {
    return D5 || "all";
  }
  function X5() {
    return f4.slice(0);
  }
  function $4() {
    return f4.map(function(e3) {
      return R5(e3) || V3(e3) || String.fromCharCode(e3);
    });
  }
  function q4(e3) {
    var t2 = e3.target || e3.srcElement, i3 = t2.tagName, r = !0;
    return (t2.isContentEditable || (i3 === "INPUT" || i3 === "TEXTAREA" || i3 === "SELECT") && !t2.readOnly) && (r = !1), r;
  }
  function z3(e3) {
    return typeof e3 == "string" && (e3 = C4(e3)), f4.indexOf(e3) !== -1;
  }
  function J2(e3, t2) {
    var i3, r;
    e3 || (e3 = E2());
    for (var n2 in s4)
      if (Object.prototype.hasOwnProperty.call(s4, n2))
        for (i3 = s4[n2], r = 0; r < i3.length; )
          i3[r].scope === e3 ? i3.splice(r, 1) : r++;
    E2() === e3 && F6(t2 || "all");
  }
  function N4(e3) {
    var t2 = e3.keyCode || e3.which || e3.charCode, i3 = f4.indexOf(t2);
    if (i3 >= 0 && f4.splice(i3, 1), e3.key && e3.key.toLowerCase() === "meta" && f4.splice(0, f4.length), (t2 === 93 || t2 === 224) && (t2 = 91), t2 in u3) {
      u3[t2] = !1;
      for (var r in g4)
        g4[r] === t2 && (v3[r] = !1);
    }
  }
  function Q3(e3) {
    if (typeof e3 > "u")
      Object.keys(s4).forEach(function(o3) {
        return delete s4[o3];
      });
    else if (Array.isArray(e3))
      e3.forEach(function(o3) {
        o3.key && S6(o3);
      });
    else if (typeof e3 == "object")
      e3.key && S6(e3);
    else if (typeof e3 == "string") {
      for (var t2 = arguments.length, i3 = new Array(t2 > 1 ? t2 - 1 : 0), r = 1; r < t2; r++)
        i3[r - 1] = arguments[r];
      var n2 = i3[0], a3 = i3[1];
      typeof n2 == "function" && (a3 = n2, n2 = ""), S6({ key: e3, scope: n2, method: a3, splitKey: "+" });
    }
  }
  var S6 = function(t2) {
    var i3 = t2.key, r = t2.scope, n2 = t2.method, a3 = t2.splitKey, o3 = a3 === void 0 ? "+" : a3, l2 = U5(i3);
    l2.forEach(function(c3) {
      var p4 = c3.split(o3), m5 = p4.length, y3 = p4[m5 - 1], d6 = y3 === "*" ? "*" : C4(y3);
      if (s4[d6]) {
        r || (r = E2());
        var K3 = m5 > 1 ? T5(g4, p4) : [];
        s4[d6] = s4[d6].filter(function(h3) {
          var w4 = n2 ? h3.method === n2 : !0;
          return !(w4 && h3.scope === r && G4(h3.mods, K3));
        });
      }
    });
  };
  function _2(e3, t2, i3, r) {
    if (t2.element === r) {
      var n2;
      if (t2.scope === i3 || t2.scope === "all") {
        n2 = t2.mods.length > 0;
        for (var a3 in u3)
          Object.prototype.hasOwnProperty.call(u3, a3) && (!u3[a3] && t2.mods.indexOf(+a3) > -1 || u3[a3] && t2.mods.indexOf(+a3) === -1) && (n2 = !1);
        (t2.mods.length === 0 && !u3[16] && !u3[18] && !u3[17] && !u3[91] || n2 || t2.shortcut === "*") && t2.method(e3, t2) === !1 && (e3.preventDefault ? e3.preventDefault() : e3.returnValue = !1, e3.stopPropagation && e3.stopPropagation(), e3.cancelBubble && (e3.cancelBubble = !0));
      }
    }
  }
  function k3(e3, t2) {
    var i3 = s4["*"], r = e3.keyCode || e3.which || e3.charCode;
    if (v3.filter.call(this, e3)) {
      if ((r === 93 || r === 224) && (r = 91), f4.indexOf(r) === -1 && r !== 229 && f4.push(r), ["ctrlKey", "altKey", "shiftKey", "metaKey"].forEach(function(h3) {
        var w4 = L4[h3];
        e3[h3] && f4.indexOf(w4) === -1 ? f4.push(w4) : !e3[h3] && f4.indexOf(w4) > -1 ? f4.splice(f4.indexOf(w4), 1) : h3 === "metaKey" && e3[h3] && f4.length === 3 && (e3.ctrlKey || e3.shiftKey || e3.altKey || (f4 = f4.slice(f4.indexOf(w4))));
      }), r in u3) {
        u3[r] = !0;
        for (var n2 in g4)
          g4[n2] === r && (v3[n2] = !0);
        if (!i3)
          return;
      }
      for (var a3 in u3)
        Object.prototype.hasOwnProperty.call(u3, a3) && (u3[a3] = e3[L4[a3]]);
      e3.getModifierState && !(e3.altKey && !e3.ctrlKey) && e3.getModifierState("AltGraph") && (f4.indexOf(17) === -1 && f4.push(17), f4.indexOf(18) === -1 && f4.push(18), u3[17] = !0, u3[18] = !0);
      var o3 = E2();
      if (i3)
        for (var l2 = 0; l2 < i3.length; l2++)
          i3[l2].scope === o3 && (e3.type === "keydown" && i3[l2].keydown || e3.type === "keyup" && i3[l2].keyup) && _2(e3, i3[l2], o3, t2);
      if (r in s4) {
        for (var c3 = 0; c3 < s4[r].length; c3++)
          if ((e3.type === "keydown" && s4[r][c3].keydown || e3.type === "keyup" && s4[r][c3].keyup) && s4[r][c3].key) {
            for (var p4 = s4[r][c3], m5 = p4.splitKey, y3 = p4.key.split(m5), d6 = [], K3 = 0; K3 < y3.length; K3++)
              d6.push(C4(y3[K3]));
            d6.sort().join("") === f4.sort().join("") && _2(e3, p4, o3, t2);
          }
      }
    }
  }
  function W4(e3) {
    return H5.indexOf(e3) > -1;
  }
  function v3(e3, t2, i3) {
    f4 = [];
    var r = U5(e3), n2 = [], a3 = "all", o3 = document, l2 = 0, c3 = !1, p4 = !0, m5 = "+", y3 = !1;
    for (i3 === void 0 && typeof t2 == "function" && (i3 = t2), Object.prototype.toString.call(t2) === "[object Object]" && (t2.scope && (a3 = t2.scope), t2.element && (o3 = t2.element), t2.keyup && (c3 = t2.keyup), t2.keydown !== void 0 && (p4 = t2.keydown), t2.capture !== void 0 && (y3 = t2.capture), typeof t2.splitKey == "string" && (m5 = t2.splitKey)), typeof t2 == "string" && (a3 = t2); l2 < r.length; l2++)
      e3 = r[l2].split(m5), n2 = [], e3.length > 1 && (n2 = T5(g4, e3)), e3 = e3[e3.length - 1], e3 = e3 === "*" ? "*" : C4(e3), e3 in s4 || (s4[e3] = []), s4[e3].push({ keyup: c3, keydown: p4, scope: a3, mods: n2, shortcut: r[l2], method: i3, key: r[l2], splitKey: m5, element: o3 });
    typeof o3 < "u" && !W4(o3) && window && (H5.push(o3), P5(o3, "keydown", function(d6) {
      k3(d6, o3);
    }, y3), A4 || (A4 = !0, P5(window, "focus", function() {
      f4 = [];
    }, y3)), P5(o3, "keyup", function(d6) {
      k3(d6, o3), N4(d6);
    }, y3));
  }
  function Y3(e3) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "all";
    Object.keys(s4).forEach(function(i3) {
      var r = s4[i3].filter(function(n2) {
        return n2.scope === t2 && n2.shortcut === e3;
      });
      r.forEach(function(n2) {
        n2 && n2.method && n2.method();
      });
    });
  }
  var j3 = { getPressedKeyString: $4, setScope: F6, getScope: E2, deleteScope: J2, getPressedKeyCodes: X5, isPressed: z3, filter: q4, trigger: Y3, unbind: Q3, keyMap: b5, modifier: g4, modifierMap: L4 };
  for (x in j3)
    Object.prototype.hasOwnProperty.call(j3, x) && (v3[x] = j3[x]);
  var x;
  typeof document < "u" && (B7 = window.hotkeys, v3.noConflict = function(e3) {
    return e3 && window.hotkeys === v3 && (window.hotkeys = B7), v3;
  }, window.hotkeys = v3);
  var B7;

  // https://esm.sh/v119/immersive-translate@1.0.9/deno/immersive-translate.mjs
  var v4 = class {
    #e = performance.now();
    reset() {
      this.#e = performance.now();
    }
    stop(e3) {
      let t2 = performance.now(), n2 = Math.round(t2 - this.#e);
      this.#e = t2;
    }
  }, D6 = class {
    #e = 1;
    get level() {
      return this.#e;
    }
    setLevel(e3) {
      switch (e3) {
        case "debug":
          this.#e = 0;
          break;
        case "info":
          this.#e = 1;
          break;
        case "warn":
          this.#e = 2;
          break;
        case "error":
          this.#e = 3;
          break;
        case "fatal":
          this.#e = 4;
          break;
      }
    }
    debug(...e3) {
      this.#e <= 0;
    }
    v(...e3) {
      this.#e <= 0;
    }
    info(...e3) {
      this.#e <= 1;
    }
    l(...e3) {
      this.#e <= 1;
    }
    warn(...e3) {
      this.#e <= 2;
    }
    error(...e3) {
      this.#e <= 3;
    }
    fatal(...e3) {
      this.#e <= 4;
    }
    timing() {
      return this.level === 0 ? new v4() : { reset: () => {
      }, stop: () => {
      } };
    }
  }, E3 = new D6(), L5 = "poegempjloogba", I4 = "ension://";
  var U6 = "rome-ext";
  var V4 = "ch" + U6 + I4 + "cofdb" + L5 + "gkncekinflcnj";

  // deps.ts
  var toast = Ye2.alert;

  // log.ts
  var theConsole = console, Timing = class {
    #t = performance.now();
    reset() {
      this.#t = performance.now();
    }
    stop(message) {
      let now = performance.now(), d6 = Math.round(now - this.#t), cf = colors_exports.green;
      d6 > 1e4 ? cf = colors_exports.red : d6 > 1e3 && (cf = colors_exports.yellow), theConsole.debug(
        colors_exports.dim(brandName + " TIMING:"),
        message,
        "in",
        cf(d6 + "ms")
      ), this.#t = now;
    }
  }, Logger = class {
    #level = 1 /* Info */;
    get level() {
      return this.#level;
    }
    setLevel(level) {
      switch (level) {
        case "debug":
          this.#level = 0 /* Debug */;
          break;
        case "info":
          this.#level = 1 /* Info */;
          break;
        case "warn":
          this.#level = 2 /* Warn */;
          break;
        case "error":
          this.#level = 3 /* Error */;
          break;
        case "fatal":
          this.#level = 4 /* Fatal */;
          break;
      }
    }
    debug(...args) {
      this.#level <= 0 /* Debug */ && theConsole.log(colors_exports.dim(brandName + " DEBUG:"), ...args);
    }
    v(...args) {
      this.#level <= 0 /* Debug */;
    }
    info(...args) {
      this.#level <= 1 /* Info */ && theConsole.log(colors_exports.green(brandName + " INFO:"), ...args);
    }
    l(...args) {
      this.#level <= 1 /* Info */;
    }
    warn(...args) {
      this.#level <= 2 /* Warn */ && theConsole.warn(colors_exports.yellow(brandName + " WARN:"), ...args);
    }
    error(...args) {
      this.#level <= 3 /* Error */ && theConsole.error(colors_exports.red(brandName + " ERROR:"), ...args);
    }
    fatal(...args) {
      this.#level <= 4 /* Fatal */ && theConsole.error(colors_exports.red(brandName + " FATAL:"), ...args);
    }
    timing() {
      return this.level === 0 /* Debug */ ? new Timing() : { reset: () => {
      }, stop: () => {
      } };
    }
  }, log_default = new Logger();

  // libs/subtitle/subtitle.jsx
  var $$$ = document.querySelector.bind(document), open2 = (file) => {
    if (document.body.removeChild($$$("#drop-target")), file) {
      let reader = new FileReader();
      reader.readAsText(file, "UTF-8"), reader.onload = function(evt) {
        let content = reader.result, parsed = subsrt_default.parse(content), mountPoint = document.getElementById("mount");
        mountPoint && re(
          /* @__PURE__ */ p2(
            TranslateProvider,
            {
              lang: "zh-CN",
              translations: locales_default,
              fallbackLang: "zh-CN",
              children: /* @__PURE__ */ p2(Page, { data: {
                parsed,
                file
              } })
            }
          ),
          mountPoint
        );
      }, reader.onerror = function(evt) {
        alert("error reading file"), window.location.reload();
      };
    }
  }, dragOverHandler = (e3) => e3.preventDefault(), dropHandler = (e3) => {
    e3.preventDefault();
    let item = Array.from(e3.dataTransfer.items).find(
      (item2) => item2.kind === "file"
    );
    if (item) {
      let entry = item.webkitGetAsEntry();
      open2(entry.isFile ? item.getAsFile() : entry).catch(
        (e4) => {
        }
      );
    }
  }, dropTarget = $$$("#drop-target");
  dropTarget.addEventListener("drop", dropHandler);
  dropTarget.addEventListener("dragover", dragOverHandler);
  $$$("#file-input").addEventListener("change", (e3) => open2(e3.target.files[0]));
  $$$("#file-button").addEventListener("click", () => {
    document.querySelector("#file-input").click();
  });
})();
/*! Bundled license information:

bowser/src/bowser.js:
  (*!
   * Bowser - a browser detector
   * https://github.com/lancedikson/bowser
   * MIT License | (c) Dustin Diaz 2012-2015
   * MIT License | (c) Denis Demchenko 2015-2019
   *)
*/
